SystemOrganization addCategory: #'Roassal-Actions'!
SystemOrganization addCategory: #'Roassal-AttachPoint'!
SystemOrganization addCategory: #'Roassal-AttachPoint-Test'!
SystemOrganization addCategory: #'Roassal-Benchmarks'!
SystemOrganization addCategory: #'Roassal-Builder'!
SystemOrganization addCategory: #'Roassal-Builder-Tests'!
SystemOrganization addCategory: #'Roassal-Core'!
SystemOrganization addCategory: #'Roassal-Core-Tests'!
SystemOrganization addCategory: #'Roassal-Event'!
SystemOrganization addCategory: #'Roassal-Example'!
SystemOrganization addCategory: #'Roassal-Hooks'!
SystemOrganization addCategory: #'Roassal-Interaction'!
SystemOrganization addCategory: #'Roassal-Interaction-Tests'!
SystemOrganization addCategory: #'Roassal-Layout'!
SystemOrganization addCategory: #'Roassal-Layout-Tests'!
SystemOrganization addCategory: #'Roassal-Transformation'!
SystemOrganization addCategory: #'Roassal-Visitor'!
SystemOrganization addCategory: #'Roassal-Visitor-Tests'!
SystemOrganization addCategory: #'Roassal-Widgets'!

!Class methodsFor: '*roassal-core' stamp: ''!
numberOfSubclasses
	^ self allSubclasses size! !

!Class methodsFor: '*roassal-core' stamp: ''!
numberOfVariables
	^ self instVarNames size! !

!SequenceableCollection methodsFor: '*roassal-core' stamp: ''!
asSorted: aBlockOrSymbol
	| c b |
	c := self copy.
	(aBlockOrSymbol isKindOf: BlockClosure)
		ifTrue: [ b := aBlockOrSymbol ].
		
	(aBlockOrSymbol isKindOf: Symbol)
		ifTrue: [ b := [ :v1 :v2 | (v1 perform: aBlockOrSymbol) <= (v2 perform: aBlockOrSymbol) ] ].
		
	c sort: b.
	^ c! !

!SequenceableCollection methodsFor: '*roassal-core' stamp: 'AlexandreBergel 5/3/2012 19:16'!
roSwapElement: u withElement: v
	| index1 index2 |
	index1 := self indexOf: u.
	index2 := self indexOf: v.
	self at: index2 put: u.
	self at: index1 put: v.! !

!Number methodsFor: '*roassal-core' stamp: ''!
max: max in: anInterval 
	"
	(0 max: 20 in: (1 to: 10)) == 1
	(0 max: 20 in: (0 to: 10)) == 0
	(0 max: 20 in: (1 to: 10)) == 1
	(2 max: 20 in: (0 to: 10)) == 1 
	(4 max: 20 in: (0 to: 10)) == 2
	(20 max: 20 in: (0 to: 10)) == 10
	"
	^ self min: 0 max: max in: anInterval! !

!Number methodsFor: '*roassal-core' stamp: ''!
min: min max: max in: anInterval 
	"
	(0 max: 20 in: (1 to: 10)) == 1
	(0 max: 20 in: (0 to: 10)) == 0
	(0 max: 20 in: (1 to: 10)) == 1
	(2 max: 20 in: (0 to: 10)) == 1 
	(4 max: 20 in: (0 to: 10)) == 2
	(19 max: 20 in: (0 to: 10)) == 10
	"
	^ (self - min) / (max - min) * (anInterval last - anInterval first) + anInterval first
! !

TestCase subclass: #ROAttachPointTest
	instanceVariableNames: 'view el1 el2 edge shape'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint-Test'!

!ROAttachPointTest methodsFor: 'running' stamp: 'AlexandreBergel 6/1/2012 06:02'!
setUp
	
	view := ROView new.
	el1 := ROElement spriteOn: 1.
	el2 := ROElement spriteOn: 2.
	el1 @ ROPopup.
	el2 @ ROPopup.
	
	edge := ROEdge from: el1 to: el2.
	view addAll: (Array with: el1 with: el2 with: edge).
	shape := ROLine new color: Color black.
	edge + shape.
	ROHorizontalLineLayout on: (Array with: el1 with: el2)! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/31/2012 15:19'!
testHorizontalAttachPoint
	shape attachPoint: (ROHorizontalAttachPoint new).
	self assert: (shape startingPointOf: edge) = (el1 bounds topRight + (0 @ (el1 bounds extent y / 2)))  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + (0 @ (el2 bounds extent y / 2)))  .! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/31/2012 15:30'!
testShorterDistancePoint1
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same horizontal line. el1 is on the left of el2"
	self assert: (shape startingPointOf: edge) = (el1 bounds topRight + (0 @ (el1 bounds extent y / 2)))  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + (0 @ (el2 bounds extent y / 2)))  .! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/1/2012 06:05'!
testShorterDistancePoint2
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same horizontal line. el2 is on the left of el1"
	p := el1 position.
	el1 translateTo: el2 position.
	el2 translateTo: p.
	
	self assert: (shape startingPointOf: edge) = (el1 bounds topLeft + (0 @ (el1 bounds extent y / 2)))  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topRight + (0 @ (el2 bounds extent y / 2))) .! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/1/2012 06:10'!
testShorterDistancePoint3
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same horizontal line. el2 is on the left of el1"
	p := el1 position.
	el1 translateBy: 0 @ 80.
	el2 translateTo: p.
	
	self assert: (shape startingPointOf: edge) = (el1 bounds topLeft + ((el1 bounds width / 2) @0)) .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + ((el2 bounds width / 2) @ el2 bounds width))! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/1/2012 06:11'!
testShorterDistancePoint4
	| p |
	shape attachPoint: (ROShorterDistanceAttachPoint new).
	
	"el1 and el2 are on the same vertical line. el1 is above el2"
	el2 translateTo: el1 position.
	el2 translateBy: 0 @ 80.
	
	self assert: (shape startingPointOf: edge) = (el1 bounds topLeft + ((el1 bounds width / 2) @ el1 bounds height)) .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + ((el2 bounds width / 2) @ 0))! !

!ROAttachPointTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/31/2012 15:22'!
testVerticalAttachPoint
	shape attachPoint: (ROVerticalAttachPoint new).
	self assert: (shape startingPointOf: edge) = (el1 bounds bottomLeft + ((el1 bounds extent x / 2) @ 0))  .
	self assert: (shape endingPointOf: edge) = (el2 bounds topLeft + ((el2 bounds extent x / 2) @ 0))  .! !

TestCase subclass: #RODraggableTest
	instanceVariableNames: 'node draggableNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!RODraggableTest methodsFor: 'running' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp
	node := ROElement new.
	node addShape: (ROBox new).

	draggableNode := ROElement new.
	draggableNode extent: 50@50.
	draggableNode + ROBox.
	draggableNode @ RODraggable.! !

!RODraggableTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/7/2012 11:54'!
testAddition

	
	| bounds |
	node := ROElement new.
	node addShape: (ROBox new).
	node addInteraction: RODraggable.
	bounds := node bounds.
	node announce: (ROMouseDragging new step: 5 @ 5).
	self assert: (bounds translateBy: 5 @ 5) = node bounds ! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testAnnouncingDraggingWhileBeingRegistered

	| bounds |
	bounds := node bounds.
	node addInteraction: RODraggable.
	node announce: (ROMouseDragging new step: 4@3).
	self assert: (bounds translateBy: 4@3) = node bounds.
! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testAnnouncingDraggingWithoutBeingRegistered

	| bounds |
	bounds := node bounds.
	node announce: (ROMouseDragging new step: 4@3).
	self assert: bounds = node bounds.
! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testDraggable
	self deny: (node is: RODraggable).
	self assert: (node numberOfInteractions isZero).

	node addInteraction: RODraggable new.
	self assert: (node is: RODraggable).
		! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testDraggableByClass
	self deny: (node is: RODraggable).
	self assert: (node numberOfInteractions isZero).

	node addInteraction: RODraggable.
	self assert: (node is: RODraggable).

		! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testDraggingStep

	| view p1 |
	view := ROView new.
	view add: draggableNode.
	
	"dragging a node increases its position by the dragging step"
	p1 := draggableNode position.
	self assert: (p1 = (0@0)).
	draggableNode announce: (ROMouseDragging step: 10 @ 6).
	self assert: (draggableNode position = (10 @ 6)).
	draggableNode announce: (ROMouseDragging step: -10 @ -6).
	self assert: (draggableNode position = (0 @ 0)).
	
	"take care of real vs virtual steps"
	view camera bounds: (0@0 corner: 250@250).
	draggableNode announce: (ROMouseDragging step: 10 @ 6).
	self assert: (draggableNode position = ( 5@3)).! !

!RODraggableTest methodsFor: 'tests' stamp: ''!
testElementToBeAdded

	| drag |
	self assert: (RODraggable elementToBeAdded class == RODraggable).
	drag := RODraggable new.
	self assert: (drag elementToBeAdded == drag)! !

!RODraggableTest methodsFor: 'nesting' stamp: 'AlexandreBergel 4/17/2012 17:03'!
testNesting

	| view node1 b innerNode |
	view := ROView new.
	node1 := (ROElement spriteOn: 'hello') 
				addAll: (Array with: (innerNode := ROElement spriteOn: 'world')).
				
	view add: node1.
	node1 translateBy: 10@20.
	
	b := node1 bounds.

	ROAdjustSizeOfNesting on: node1.
	ROAdjustSizeOfNesting on: node1.
	self assert: (b = node1 bounds).

	innerNode extent: 10@10.
	innerNode translateBy: 1 @ 1.
	self assert: (b = node1 bounds).
	
	innerNode translateBy: 5 @ 5.
	innerNode translateBy: 5 @ 5.
	self assert: (b = node1 bounds).
	
	innerNode announce: (ROMouseDragging step: 5 @ 5).
	innerNode announce: (ROMouseDragging step: 5 @ 5).
	self assert: (b = node1 bounds).
	
	"
	view openInWindow 
	"! !

TestCase subclass: #ROEventTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROEventTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 15:48'!
testPositionNotNil

	| event |
	ROEvent withAllSubclasses do: [ :cls | 
		event := cls new.
		self assert: event position = (0@0)
		 ]! !

!ROEventTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 15:58'!
testProperlyInitialized 
	

	| event |
	ROEvent withAllSubclasses do: [ :cls | 
		event := cls new.
		self shouldnt: [ (event class selectors select: [ :k | (k includes: $:) not]) do: [ :k | event perform: k ] ] raise: Error.
		 ]! !

TestCase subclass: #ROFocusViewTest
	instanceVariableNames: 'view camera el1 el2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROFocusViewTest methodsFor: 'running' stamp: 'AlexandreBergel 5/6/2012 10:11'!
setUp

	view := ROView new.
	camera := view camera.

	view add: (el1 := ROElement sprite).
	view add: (el2 := ROElement sprite translateBy: 200 @ 20).
	
! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 5/6/2012 10:13'!
testCamera
	self assert: camera position = (0 @ 0).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 5/6/2012 10:11'!
testOnView

	"
	self debug: #test
	"
	| focus |
	self assert: camera position = (0 @ 0).
	focus := ROFocusView new on: el2 view: view.
	focus waitUntilDone.
	"el2 is now in the center of the screen"
	self assert: camera position =  (-50@ -230).! !

!ROFocusViewTest methodsFor: 'test' stamp: 'AlexandreBergel 5/6/2012 10:15'!
testToPositionView

	"
	self debug: #testToPositionView
	"
	| focus |
	focus := ROFocusView new toPosition: 500@20 view: view.
	focus waitUntilDone.
	"el2 is now in the center of the screen"
	self assert: camera position =  (250@ -230).
	
	focus := ROFocusView new toPosition: 500@250 view: view.
	focus waitUntilDone.
	"el2 is now in the center of the screen"
	self assert: camera position =  (250@ 0).! !

TestCase subclass: #ROGraphTransformationTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Transformation'!

!ROGraphTransformationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/5/2012 11:11'!
OLDtestCheckCycleNoCycle

	| view nodes edges newNode transformation node1 node2 node3 |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2 with: 3).
	edges := view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3 with: 1 -> 3).
		
	transformation := ROGraphTransformation new.

	"self assert: (transformation containsCycleIn: nodes with: edges)"
	"self deny: (transformation containsCycleIn: nodes first with: edges passedNodes: OrderedCollection new)"
	self deny: (transformation hasCycleIn: nodes with: edges)! !

!ROGraphTransformationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/5/2012 10:10'!
testFromEdgesToNesting

	| view nodes edges newNode transformation |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2).
	edges := view edgesFromAssociations: (Array with: 1 -> 2).
	
	transformation := ROGraphTransformation new.
	"Testing utility methods"
	self assert: (transformation getConnectedNodesFrom: nodes first using: edges) = (Array with: nodes second).
	
	"Doing the transformation"
	newNode := transformation
				fromEdgesToNesting: nodes edges: edges root: nodes first.
				
	self assert: newNode elements size = 1.
	self assert: newNode model = 1.
	self assert: newNode elements first model = 2.
	
	self assert: newNode == nodes first! !

!ROGraphTransformationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/5/2012 10:46'!
testFromEdgesToNesting2

	| view nodes edges newNode transformation |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2 with: 3).
	edges := view edgesFromAssociations: (Array with: 1 -> 2 with: 1 -> 3).
	
	transformation := ROGraphTransformation new.
	"Testing utility methods"
	self assert: (transformation getConnectedNodesFrom: nodes first using: edges) 
				= (Array with: nodes second with: nodes third).
	
	"Doing the transformation"
	newNode := transformation
				fromEdgesToNesting: nodes edges: edges root: nodes first.
				
	self assert: newNode elements size = 2.
	self assert: newNode model = 1.
	self assert: newNode elements first model = 2.
	self assert: newNode elements second model = 3.	
	
	"We make sure that the nodes that have been moved are removed from the view"
	self assert: (view container elements includes: newNode).
	self deny: (view container elements includes: nodes second).
	self deny: (view container elements includes: nodes third).! !

!ROGraphTransformationTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/5/2012 09:34'!
testFromEdgesToNesting3

	| view nodes edges newNode transformation |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: (Array with: 1 with: 2 with: 3).
	edges := view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3).
	
	transformation := ROGraphTransformation new.
	"Testing utility methods"
	self assert: (transformation getConnectedNodesFrom: nodes first using: edges) 
				= (Array with: nodes second).
	
	"Doing the transformation"
	newNode := transformation
				fromEdgesToNesting: nodes edges: edges root: nodes first.
				
	self assert: newNode elements size = 1.
	self assert: newNode model = 1.
	self assert: newNode elements first model = 2.
	
	self assert: newNode elements first  numberOfElements = 1.
	self assert: newNode elements first elements first model = 3.	! !

TestCase subclass: #ROLabelElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROLabelElementTest methodsFor: 'tests' stamp: ''!
testBounds
	| el |
	el := ROLabelElement on: 'hello world'.
	self assert: el bounds ~= ( 0@0 corner: 5@5).
	self assert: el extent = (ROLabel new preferedExtentFor: el).! !

TestCase subclass: #ROLayoutTest
	instanceVariableNames: 'view elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

ROLayoutTest subclass: #ROCircleLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROCircleLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/9/2012 14:32'!
assertArrayOfPoint: computedArray isCloseTo: result
	"utility method useful to compare two set of points that are close to each other."
	
	self assert: computedArray size = result size.
	self assert: (computedArray allSatisfy: [ :p | p class = Point ]).
	computedArray with: result do: [ :e1 :e2 | (e1 x - e2 x) abs <= 1 and: [ (e1 y - e2 y) abs <= 1 ] ]
	
! !

!ROCircleLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/9/2012 16:26'!
testAssertArrayOfPoint

	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 2@3).
	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 1@3).
	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 1@2).
	self assertArrayOfPoint: (Array with: 2@3) isCloseTo: (Array with: 3@2).! !

!ROCircleLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 5/9/2012 14:29'!
testLayout
	| result computedArray |
	ROCircleLayout on: elements.
	
	computedArray := elements collect: #positionAsInteger.
	result := ((Array new: 20) at: 1 put: ((440@220)); at: 2 put: ((429@287)); at: 3 put: ((397@349)); at: 4 put: ((349@397)); at: 5 put: ((287@429)); at: 6 put: ((220@440)); at: 7 put: ((152@429)); at: 8 put: ((90@397)); at: 9 put: ((42@349)); at: 10 put: ((10@287)); at: 11 put: ((0@220)); at: 12 put: ((10@152)); at: 13 put: ((42@90)); at: 14 put: ((90@42)); at: 15 put: ((152@10)); at: 16 put: ((219@0)); at: 17 put: ((287@10)); at: 18 put: ((349@42)); at: 19 put: ((397@90)); at: 20 put: ((429@152)); yourself).
	
	self assertArrayOfPoint: computedArray isCloseTo: result.
"
view openInWindow
" ! !

ROLayoutTest subclass: #ROGridLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROGridLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/17/2012 17:06'!
testLayout
	| result |
	ROGridLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((5@5)); at: 2 put: ((65@5)); at: 3 put: ((125@5)); at: 4 put: ((185@5)); at: 5 put: ((245@5)); at: 6 put: ((5@65)); at: 7 put: ((65@65)); at: 8 put: ((125@65)); at: 9 put: ((185@65)); at: 10 put: ((245@65)); at: 11 put: ((5@125)); at: 12 put: ((65@125)); at: 13 put: ((125@125)); at: 14 put: ((185@125)); at: 15 put: ((245@125)); at: 16 put: ((5@185)); at: 17 put: ((65@185)); at: 18 put: ((125@185)); at: 19 put: ((185@185)); at: 20 put: ((245@185)); yourself).
	
	self assert: (elements collect: #position) = result! !

!ROLayoutTest class methodsFor: 'as yet unclassified' stamp: ''!
isAbstract 
	^ self name == #ROLayoutTest  ! !

!ROLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/22/2012 21:01'!
setUp

	elements := ROElement forCollection: (1 to: 20).
	elements do: [ :n | n extent: 50@50; addShape: (ROBox new) ].
	view := ROView new.
	view addAll: elements.
	elements allButFirst do: [:e | 
	 	view add: (ROEdge lineFrom: elements first to: e) ]! !

!ROLayoutTest methodsFor: 'test layout' stamp: ''!
testLayout
	self subclassResponsibility ! !

ROLayoutTest subclass: #ROSugiyamaLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROSugiyamaLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/17/2012 17:28'!
testLayout
	| result |
	ROSugiyamaLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((497.0@3.0)); at: 2 put: ((974.0@73.0)); at: 3 put: ((921.0@73.0)); at: 4 put: ((868.0@73.0)); at: 5 put: ((815.0@73.0)); at: 6 put: ((762.0@73.0)); at: 7 put: ((709.0@73.0)); at: 8 put: ((656.0@73.0)); at: 9 put: ((603.0@73.0)); at: 10 put: ((550.0@73.0)); at: 11 put: ((497.0@73.0)); at: 12 put: ((444.0@73.0)); at: 13 put: ((391.0@73.0)); at: 14 put: ((338.0@73.0)); at: 15 put: ((285.0@73.0)); at: 16 put: ((232.0@73.0)); at: 17 put: ((179.0@73.0)); at: 18 put: ((126.0@73.0)); at: 19 put: ((73.0@73.0)); at: 20 put: ((20.0@73.0)); yourself).
	self assert: (elements collect: #position) = result! !

ROLayoutTest subclass: #ROTreeLayoutTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROTreeLayoutTest methodsFor: 'test layout' stamp: 'AlexandreBergel 4/17/2012 17:08'!
testLayout
	| result |
	ROTreeLayout on: elements.
	
	result := ((Array new: 20) at: 1 put: ((482@5)); at: 2 put: ((5@75)); at: 3 put: ((58@75)); at: 4 put: ((111@75)); at: 5 put: ((164@75)); at: 6 put: ((217@75)); at: 7 put: ((270@75)); at: 8 put: ((323@75)); at: 9 put: ((376@75)); at: 10 put: ((429@75)); at: 11 put: ((482@75)); at: 12 put: ((535@75)); at: 13 put: ((588@75)); at: 14 put: ((641@75)); at: 15 put: ((694@75)); at: 16 put: ((747@75)); at: 17 put: ((800@75)); at: 18 put: ((853@75)); at: 19 put: ((906@75)); at: 20 put: ((959@75)); yourself).
	self assert:  (result includesAllOf: (elements collect: #positionAsInteger))! !

TestCase subclass: #ROLayoutTranslatorTest
	instanceVariableNames: 'elements layout'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

ROLayoutTranslatorTest subclass: #ROAbsorbLayoutTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROAbsorbLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/17/2012 17:28'!
testLayout
	layout translator: ROAbsorbLayoutTranslator new.
	layout applyOn: elements.
	self assert: ((elements collect: #position) asSet asArray first = (0@0))! !

ROLayoutTranslatorTest subclass: #RODirectLayoutTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!RODirectLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/19/2012 10:22'!
testLayout
	| result |
	layout translator: RODirectLayoutTranslator new.
	layout applyOn: elements.
	result := ((Array new: 5) at: 1 put: (31@5); at: 2 put: (31@75); at: 3 put: (58@145); at: 4 put: (111@5); at: 5 put: (5@145); yourself).
	self assert: (result includesAllOf: (elements collect: #positionAsInteger))! !

!ROLayoutTranslatorTest methodsFor: 'running' stamp: 'AlexandreBergel 4/17/2012 17:02'!
setUp

	| view edges |
	view := ROView new.
	elements := ROElement spritesFor: (1 to: 5).
	view addAll: elements.
	view addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	layout := ROTreeLayout new! !

!ROLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 15:33'!
testDefault
	"
	Commented out because isAbstractClass is not in VW
	self assert: ROLayoutTranslator isAbstractClass.
	self assert: ROLayoutTranslator defaultClass isAbstractClass not.
	"
	
	self assert: (ROLayoutTranslator withAllSubclasses select: #isDefault) size = 1.
	
	self assert: ROLayoutTranslator default class ==  ROLayoutTranslator defaultClass! !

ROLayoutTranslatorTest subclass: #ROSmoothLayoutTranslatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout-Tests'!

!ROSmoothLayoutTranslatorTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 16:32'!
testLayout
	| result |
	layout translator: ROSmoothLayoutTranslator new.
	layout applyOn: elements.
	self assert: ((elements collect: #positionAsInteger) asSet asArray first = (0@0)).
	[ layout translator hasCompleted not ] whileTrue: [ self wait ].
	1 to: 10 do: [ :i | self wait ].

	result := ((Array new: 5) at: 1 put: (31@5); at: 2 put: (31@75); at: 3 put: (58@145); at: 4 put: (111@5); at: 5 put: (5@145); yourself).
	self assert: (result includesAllOf: (elements collect: #positionAsInteger))! !

!ROSmoothLayoutTranslatorTest methodsFor: 'waiting' stamp: ''!
wait
	(Delay forMilliseconds: 3) wait.! !

TestCase subclass: #ROMondrianScatterLayoutTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianScatterLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/21/2012 22:41'!
tearDown 
	window ifNotNil: [ window delete ]! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:39'!
testScatterplotLayout
	
	| nodes |
	view := ROMondrianViewBuilder new.
		
	nodes := view
		nodes: #(#(10 20) #(30 40)).
	view layout: (ROScatterplotLayout new 
						x: [:entity | entity first ];
						y: [:entity | entity last ]).
	window := view open.
	self assert: nodes first bounds topLeft x = 10.
	self assert: nodes first bounds topLeft y = 20.

	self assert: nodes last bounds topLeft x = 30.
	self assert: nodes last bounds topLeft y = 40.
! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:39'!
testScatterplotLayoutBounds
	"
	self debug: #testScatterplotLayoutBounds
	"
	| nodes |
	view := ROMondrianViewBuilder new.
		
	view node: #foo forIt: [
		view layout: (ROScatterplotLayout new 
							x: #first ;
							y: #last).
		nodes := view nodes: #(#(10 20) #(30 40)).
	].

	window := view open.
	self assert: nodes first bounds topLeft x = 10.
	self assert: nodes first bounds topLeft y = 20.

	self assert: nodes last bounds topLeft x = 30.
	self assert: nodes last bounds topLeft y = 40.
! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:45'!
testScatterplotLayoutOffset
	
	| nodes |
	view := ROMondrianViewBuilder new.
		
	nodes := view
		nodes: #(#(10 20) #(30 40)).
		
	view layout: (ROScatterplotLayout new 
						offset: 2;
						x: [:entity | entity first ];
						y: [:entity | entity last ]).
	window := view open.
	self assert: nodes first bounds topLeft x = 12.
	self assert: nodes first bounds topLeft y = 22.

	self assert: nodes last bounds topLeft x = 32.
	self assert: nodes last bounds topLeft y = 42.
! !

!ROMondrianScatterLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/21/2012 22:45'!
testScatterplotLayoutScalled

	|  nodes |
	view := ROMondrianViewBuilder new.
		
	view node: #foo forIt: [
		view layout: (ROScatterplotLayout new 
							x: #first ;
							y: #last
							;
							scaledToWidth: 20;
							scaledToHeight: 15 ).
		nodes := view nodes: #(#(10 20) #(30 40)).
	].

	window := view open.
	self assert: nodes first bounds topLeft x = 6.
	self assert: nodes first bounds topLeft y =  7.

	self assert: nodes last bounds topLeft x = 20.
	self assert: nodes last bounds topLeft y = 15.

! !

TestCase subclass: #ROMondrianViewBuilderLayoutTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianViewBuilderLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/17/2012 20:03'!
setUp
	view := ROMondrianViewBuilder new.
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'running' stamp: 'AlexandreBergel 5/21/2012 22:36'!
tearDown 
	window ifNotNil: [ window delete ]! !

!ROMondrianViewBuilderLayoutTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/18/2012 09:04'!
testLayouts

	| l |
	l := OrderedCollection new.
	l add: #treeLayout.
	l add: #gridLayout.
	l add: #forceBasedLayout.
	l add: #circleLayout.
	l add: #verticalLineLayout.
	l add: #horizontalLineLayout.
	l add: #sugiyamaLayout.
	l add: #bottomFlowLayout.
	l add: #flowLayout.
	l add: #radialTreeLayout.
	l add: #scatterPlotLayout.
	
	l do: [ :sel | 
		self shouldnt:  [ view perform: sel. view applyLayout ] raise: Error ]! !

TestCase subclass: #ROMondrianViewBuilderTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROMondrianViewBuilderTest commentStamp: '<historical>' prior: 0!
A ROMondrianViewBuilderTest is a test class for testing the behavior of ROMondrianViewBuilder!

!ROMondrianViewBuilderTest methodsFor: 'running' stamp: ''!
setUp
	view := ROMondrianViewBuilder new! !

!ROMondrianViewBuilderTest methodsFor: 'running' stamp: ''!
tearDown
	super tearDown.
	window ifNotNil: [window delete. window := nil]! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testAbsolutePosition
	
	| inner2 outter inner |

	outter := view node: 'outter' forIt: [
		inner := view node: 'inner' forIt: [
			inner2 := view node: 'inner2'
		]
	].
	view applyLayout.

	self assert: outter absolutePosition = outter position.
	self assert: outter absolutePosition = (5@5).
	
	self assert: inner absolutePosition = (inner position + outter position).
	self assert: inner absolutePosition = (10@10).

	self assert: inner2 absolutePosition = (inner2 position + outter position + inner position).
	self assert: inner2 absolutePosition = ( 15@15).! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testAbsolutePositionAfterTranslation
	
	| inner2 outter inner |

	outter := view node: 'outter' forIt: [
		inner := view node: 'inner' forIt: [
			inner2 := view node: 'inner2'
		]
	].
	view applyLayout.
	outter translateBy: 10@3.

	self assert: outter absolutePosition = outter position.
	self assert: outter absolutePosition = (5@5 + (10@3)).
	
	self assert: inner absolutePosition = (inner position + outter position).
	self assert: inner absolutePosition = (10@10 + (10@3)).

	self assert: inner2 absolutePosition = (inner2 position + outter position + inner position).
	self assert: inner2 absolutePosition = ( 15@15 + (10@3)).! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: ''!
testAddingNode

	view node: 123.
	self assert: (view container numberOfElements = 1)! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: ''!
testAddingNodes

	view nodes: (1 to: 20).
	self assert: (view container numberOfElements = 20)! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testChangeInteraction

	
	| el |
	el := ROElement new.
	self deny: (el is: ROAbstractPopup).
	self deny: (el is: ROPopup).
	self deny: (el is: ROPopupView).

	el changeInteraction: ROPopup for: (ROPopupView new).
	self deny: (el is: ROPopup).
	self assert: (el is: ROPopupView).
	
	el changeInteraction: ROPopupView for: (ROPopup new).
	self assert: (el is: ROPopup).
	self deny: (el is: ROPopupView).

! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testChangeInteraction2

	
	| el |
	el := ROElement new.
	self deny: (el is: ROAbstractPopup).
	self deny: (el is: ROPopup).
	self deny: (el is: ROPopupView).

	el changeInteraction: ROAbstractPopup for: (ROPopupView new).
	self deny: (el is: ROPopup).
	self assert: (el is: ROPopupView).
	
	el changeInteraction: ROAbstractPopup for: (ROPopup new).
	self assert: (el is: ROPopup).
	self deny: (el is: ROPopupView).

! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/7/2012 11:53'!
testColoredEdges

	| edge1 edge2 |
	view nodes: #(1 2 3).
	edge1 := view edgeFromAssociation: 1 -> 2.
	
	view shape line color: Color red.
	edge2 := view edgeFromAssociation: 2 -> 3.
	
	view treeLayout.
	self assert: (edge1 numberOfShapes = 1).
	self assert: (edge2 numberOfShapes = 1)! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/7/2012 11:53'!
testColoredEdgesWithoutLayout

	| edge1 edge2 |
	view nodes: #(1 2 3).
	edge1 := view edgeFromAssociation: 1 -> 2.
	
	view shape line color: Color red.
	edge2 := view edgeFromAssociation: 2 -> 3.

	self assert: (edge1 numberOfShapes = 1).
	self assert: (edge2 numberOfShapes = 1)! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/7/2012 12:01'!
testDefaultShapeForEdge

	| edge |
	view nodes: #(1 2 3).
	edge := view edgeFromAssociation: 1 -> 2.	
	self assert: (edge isShapedAs: ROLine)
! !

!ROMondrianViewBuilderTest methodsFor: 'instantiating' stamp: 'AlexandreBergel 5/17/2012 20:52'!
testDefaultTitle
	| builder |
	builder := ROMondrianViewBuilder new.
	window := builder open.
	
	[
		self assert: window labelString = ROView defaultWindowTitle.
	] ensure: [ window delete ]! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/28/2012 17:34'!
testEdgeFromAndToItself
	"
	self debug: #testEdgeFromAndToItself
	"
	
	view nodes: #(1 2).
	view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 2 with: 1 -> 1).

	self assert: (view root container elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view root container elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/28/2012 17:33'!
testEdgeFromAndToItself2
	"
	self debug: #testEdgeFromAndToItself2
	"
	
	view nodes: #(1 2).
	view edges: #(1 2) from: #yourself toAll: [ :v | Array with: 1 ].

	self assert: (view root container elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view root container elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/28/2012 17:41'!
testEdgeFromAssociation
	| nodes edges ass m |

	nodes := view nodes: #(1 2 3 4).
	 view edges: (ass := (Array with: 1 -> 2 with: 2 -> 10 with: 10 -> 3)) from: #key to:  #value.
	edges := view root edges.
	
	self assert: edges size = 1.
	self assert: edges first from = nodes first.
	self assert: edges first to = nodes second.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/17/2012 17:21'!
testEdgesAndInnerNodes
	"Node extremities should be looked up with the nesting"
	
	| outterNode1 edges innerNode1 innerNode2 innerNode3 |
	outterNode1 := view node: 'outter1' forIt: [ innerNode1 := view node: 1 ].
	view node: 'outter2' forIt: [ innerNode2 := view node: 2 ].
	view node: 'outter3' forIt: [ innerNode3 := view node: 3 ].
	
	view edgesFromAssociations: (Array with: 1 -> 2 with: 2 -> 3 with: 1 -> 3).

	self assert: (view nestedLookup: 1 in: outterNode1) = innerNode1.
	self assert: (view nestedLookup: 2 in: outterNode1) isNil.
		
	self assert: (view lookup: 1) == innerNode1.
	self assert: (view lookup: 2) == innerNode2.
	self assert: (view lookup: 3) == innerNode3.
	
	edges := view root edges.
	self assert: edges size = 3.
	self assert: (edges first from == innerNode1).
	self assert: (edges first to == innerNode2).! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/17/2012 17:21'!
testEdgesFromTo
	| nodes edges ass m |

	nodes := view nodes: #(1 2 3 4).
	edges := view edges: (ass := (Array with: 1 -> 2 with: 1 -> 3 with: 3 -> 4)) from: #key to:  #value.
	
	self assert: edges size = 3.
	m := edges collect: [ :e | e from model -> e to model ].
	m with: ass do: [ :a :b | 
		self assert: a = b ]! !

!ROMondrianViewBuilderTest methodsFor: 'accessing' stamp: 'AlexandreBergel 4/14/2012 18:31'!
testElementsFromModels
	"
	self debug: #testElementsFromModels
	"

	| container node1To6 node7 nodeInner10To20 node8 nodeInner1To6 |
	node1To6 := view nodes: (1 to: 6).
	node7 := view node: 7 forIt: [ nodeInner10To20 := view nodes: (10 to: 20) ].
	node8 := view node: 8 forIt: [ nodeInner1To6 := view nodes: (1 to: 6) ].
	
	container := view container.

	"Looking up individual nodes"
	self assert: (container elementFromModel: 1) == node1To6 first.
	self assert: (container elementFromModel: 7) == node7.
	self assert: (container elementFromModel: 8) == node8.

	self assert: (node7 elementFromModel: 7) == node7.
	self assert: (node7 elementFromModel: 70) isNil.
	
	"------"
	"Group of nodes"
	"Checking the outter nodes"
	self assert: (container elementsFromModels: (1 to: 6)) asArray = node1To6.
	self assert: (container elementsFromModels: (Array with: 7)) asArray first == node7.
	self assert: (container elementsFromModels: (Array with: 8)) asArray first == node8.

	"Looking up the inner nodes"
	self assert: (container elementsFromModels: (10 to: 20)) asArray = nodeInner10To20. 
	
	"Looking up unexisting nodes"
	self assert: (container elementsFromModels: (Array with: 2000)) isEmpty
	
! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 6/2/2012 14:26'!
testFixedSize

	| variableNode fixedSizedNode |
	view shape rectangle width: 50; height: 50.
	variableNode := view node: 'Variable size' forIt: [ view nodes: (1 to: 100). view gridLayout ].

	view shape rectangle width: 50; height: 50; fixedSize.
	fixedSizedNode := view node: 'Fixed size' forIt: [ view nodes: (1 to: 100). view gridLayout ].


	self assert: fixedSizedNode resizeStrategy == ROFixedSizedParent instance.
	self assert: variableNode extent >= (50 @ 50).
	self assert: fixedSizedNode extent = (50 @ 50).! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testForItAndShape
	| node |
	
	view shape rectangle width: [ :v | v ].
	view node: 50.
	
	view shape withoutBorder.
	node := view node: Object new.
	
	self assert: node width = view defaultWidth.
	self assert: node height = view defaultHeight.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testForwarding

	| t outterNode innerNode |
	
	t := 0.
	"Only the outter node should be a forwarder"
	view interaction forwarder.
	outterNode := view node: 'outter' forIt: [ 
		innerNode := view node: 'inner'.
	].
	view view on: ROEvent do: [ :e | t := t + 1 ].

	self assert: t = 0.
	outterNode announce: ROEvent.
	self assert: t = 1.

	"Since the inner node is not declared has a forwarder, it should not forward"
	innerNode announce: ROEvent.
	self assert: t = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: ''!
testGraph

	"No error should be raised"
	
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:49'!
testIfborderColor

	| nodes result |
	view shape rectangle 
		if: #odd borderColor: Color red;
		if: #even borderColor: Color blue.
	nodes := view nodes: #(1 2 3 4).
	
	result :=  ((Array new: 4) at: 1 put: Color red; at: 2 put: Color blue; at: 3 put: Color red; at: 4 put: Color blue; yourself).
	self assert: (nodes collect: [ :n | (n getShape: ROBox) borderColorFor: n]) = result! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 5/22/2012 21:01'!
testInitialization

	| builder |
	builder := ROMondrianViewBuilder new.
	self assert: (builder container class == ROView)! !

!ROMondrianViewBuilderTest methodsFor: 'initializing' stamp: 'AlexandreBergel 5/3/2012 09:22'!
testInitializationWithView

	| builder v |
	v := ROView new.
	builder := ROMondrianViewBuilder titled: 'hello' view: v .
	
	self assert: (builder container == v).
	self assert: (builder container class == ROView).! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testInnerNodesAndEvents

	| outter inner inner2 |
	outter := view node: 'outter' forIt: [
		inner := view node: 'inner' forIt: [
			inner2 := view node: 'inner2'
		]
	].
	view applyLayout.

	self assert: (view view elementAtRealPosition: outter absolutePosition) == outter.
	self assert: (view view elementAtRealPosition: inner absolutePosition) == inner.
	self assert: (view view elementAtRealPosition: inner2 absolutePosition) == inner2.
	
	self assert: (view view elementAtRealPosition: 18@18) == inner2.

	"We simulate a drag and drop"
	outter translateTo: 67@32.
	self assert: (view view elementAtRealPosition: 80@45) == inner2.
	
	"What really happens underneath"
	self assert: (inner elementAt: (80@45 - outter topLeft - inner topLeft)) == inner2.
	self assert: (outter elementAt: (80@45 - outter topLeft)) == inner2.
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 4/17/2012 17:26'!
testInnerNodesAndLayout
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2) ].

	view applyLayout.

	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 35@20) with: (45@5 corner: 75@20)).
	self assert: (nodes first elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10)).
	self assert: (nodes second elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10))

! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 4/17/2012 17:25'!
testInnerNodesAndLayout2
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2).
		view verticalLineLayout ].

	view applyLayout.

	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 20@35) with: (30@5 corner: 45@35)).
	self assert: (nodes first elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (5@20 corner: 10@25)).
	self assert: (nodes second elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (5@20 corner: 10@25))
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 4/17/2012 17:24'!
testInnerNodesAndLayout3
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v+ 1 with: v +2).
	 ].
	view verticalLineLayout.
	view applyLayout.

	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 35@20) with: (5@30 corner: 35@45)).
	self assert: (nodes first elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10)).
	self assert: (nodes second elementsCollect: #bounds) asArray =  (Array with: (5@5 corner: 10@10) with: (20@5 corner: 25@10))
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: 'AlexandreBergel 5/7/2012 12:01'!
testInnerNodesAndLayout4
	| nodes |

	nodes := view nodes: #(1 10) forEach: [ :v |
		view nodes: (Array with: v +1 with: v + 2 with: v + 3).
		view shape line.
		view edgesFrom: [ :el | v + 1 ].
		view treeLayout ].

	view horizontalLineLayout.
	view applyLayout.
	
	"Sanity check begin"
	self deny: ((nodes second elementFromModel: 11) isShapedAs: ROLine).
	self assert: (nodes first elementsSuchThat: #isEdge) size = 2.
	"Sanity check end"
	
	view view bitmap.
	
	self assert: (nodes collect: #bounds) =  (Array with: (5@5 corner: 28.0@45) with: (38.0@5 corner: 61.0@45)).
	
	self assert: (((Array new: 5) at: 1 put: (9.0@5 corner: 14.0@10); at: 2 put: (5.0@30 corner: 10.0@35); at: 3 put: (13.0@30 corner: 18.0@35); at: 4 put: (0@0 corner: 5@5); at: 5 put: (0@0 corner: 5@5); yourself) includesAllOf: (nodes first elementsCollect: #bounds) asArray).
	self assert: (((((Array new: 5) at: 1 put: (9.0@5 corner: 14.0@10); at: 2 put: (5.0@30 corner: 10.0@35); at: 3 put: (13.0@30 corner: 18.0@35); at: 4 put: (0@0 corner: 5@5); at: 5 put: (0@0 corner: 5@5); yourself))) includesAllOf: (nodes second elementsCollect: #bounds) asArray)! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testInteraction
	
	| t nodes |
	t := OrderedCollection new.
	view interaction 
		item: 'act' action: [ :v |  t add: t ].
	
	nodes := view nodes: #(1 2).
	! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 5/7/2012 11:50'!
testInteraction2HighlightWhenOver
	"
	self debug: #testInteraction2HighlightWhenOver
	"
	| nodes shape1 shape2 t aNode node5 node2 |
	
	t := 0.
	view interaction highlightWhenOver: [ :v | t := t + 1. ((Array new: 4) at: 1 put: v - 1; at: 2 put: v + 1; at: 3 put: v + 4; at: 4 put: v - 4; yourself)].
	view interaction highlightWhenOver: [ :v | Array with: v ] color: Color blue.
	view shape rectangle 
		width: 40;
		height: 30.
	nodes := view nodes: (1 to: 16).
	view gridLayout gapSize: 2.
	
	aNode := nodes first.
	node5 := nodes fifth.
	node2 := nodes second.
	shape1 := aNode getShape: ROBox.
	self assert: (shape1 borderColor == Color black). 
	nodes first announce: (ROMouseEnter new).
	
	self assert: (aNode getShape: ROBox) == shape1.
	self assert: (shape1 borderColor == Color blue).
	
	shape2 := aNode getShape: ROBox.
	self assert: (t = 1).
	self assert: (shape1 == shape2).
	self assert: ((node2 getShape: ROBox) borderColor == Color red).
	self assert: ((node5 getShape: ROBox) borderColor == Color red).

	nodes first announce: (ROMouseLeave new).
	self assert: ((Array with: aNode with: node2 with: node5) allSatisfy: [ :n | (n getShape: ROBox) borderColor == Color black ]).
! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 5/7/2012 11:50'!
testInteraction2HighlightWhenOverOnInnerNodes
	"
	self debug: #testInteraction2HighlightWhenOverOnInnerNodes
	"
	| nodes shape1 shape2 t aNode node5 node2 |
	
	t := 0.
	view node: 'outterNode' forIt: [
		view interaction highlightWhenOver: [ :v | t := t + 1. ((Array new: 4) at: 1 put: v - 1; at: 2 put: v + 1; at: 3 put: v + 4; at: 4 put: v - 4; yourself)].
		view interaction highlightWhenOver: [ :v | Array with: v ] color: Color blue.
		view shape rectangle 
			width: 40;
			height: 30.
		nodes := view nodes: (1 to: 16).
		view gridLayout gapSize: 2
	].
	
	aNode := nodes first.
	node5 := nodes fifth.
	node2 := nodes second.
	shape1 := aNode getShape: ROBox.
	self assert: (shape1 borderColor == Color black). 
	
	nodes first announce: (ROMouseEnter new).
	self assert: (aNode getShape: ROBox) == shape1.
	self assert: (shape1 borderColor == Color blue).
	
	shape2 := aNode getShape: ROBox.
	self assert: (t = 1).
	self assert: (shape1 == shape2).
	self assert: ((node2 getShape: ROBox) borderColor == Color red).
	self assert: ((node5 getShape: ROBox) borderColor == Color red).

	nodes first announce: (ROMouseLeave new).
	self assert: ((Array with: aNode with: node2 with: node5) allSatisfy: [ :n | (n getShape: ROBox) borderColor == Color black ]).
! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 12:01'!
testLabel

	| node builder element | 
	builder := ROMondrianViewBuilder titled: 'Finding nodes'.
	
	builder shape label.
	node := builder node: 'hello'.

	self assert: ((node getShape: ROLabel) textFor: node) = 'hello'.
	
	view := builder view.
	self assert: view numberOfElements = 1.
	
	element := view elementDetect: [ :el | true ].
	self assert: (element isShapedAs: ROLabel).
	
	self assert: node bounds extent = (ROLabel new preferedExtentFor: node)! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:50'!
testLabelText
	
	| node |
	view shape label text: [:o | o model name, ' class'].
	node := view node: Object.

	self assert: ((node getShape: ROLabel) textFor: node) = 'Object class'.! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:53'!
testLabelWithTwoNodes
	"Just to make sure that the view does not initialize a shape that later stays one"
	
	| node1 node2 |
	view shape label text: #printString.
	node1 := view node: Object.
	self assert: (node1 shapes asArray size = 1).
	
	view shape label text: #printString.
	node2 := view node: Object.
	self assert: (node1 shapes asArray size = 1).! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 18:44'!
testLabeledRectangle

	| el1 el2 |
	view shape rectangle withText.
	el1 := view node: 'With rectangle'.
	
	view shape label.
	el2 := view node: 'Without rectangle'.
	
	self assert: (el2 width = (ROFontOrganizer current widthOfString: el2 model)).
	
	self assert: (el1 width >= (ROFontOrganizer current widthOfString: el1 model)).
	self assert: (el1 height = el2 height).! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: ''!
testMenu

	| nodes |
	
	view node: 30 forIt: [ 
		view interaction action: #inspect; action: #foo; action: #bar.
		nodes := view nodes: (1 to: 20) ].

	self assert: (nodes first getInteraction: ROMenuActivable) numberOfEntries = 3! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testNesting
	| firstNode |
	view nodes: (1 to: 20) forEach: [ :v | view nodes: (1 to: 2). ].	
	firstNode := (view container elementsSuchThat: [:el | el model = 1]) first.	
	self assert: firstNode extent = ( 30@15)
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testNestingForIt
	| firstNode |
	view node: 123 forIt: [ view nodes: (1 to: 2). ].

	firstNode := (view container elementsSuchThat: [:el | el model = 123]) first.	
	self assert: firstNode extent = ( 30@15)
! !

!ROMondrianViewBuilderTest methodsFor: 'inner nodes' stamp: ''!
testNestingWithExplicitLayout
	| firstNode |
	view nodes: (1 to: 20) forEach: [ :v | view nodes: (1 to: 2) . view treeLayout ].
	self assert: (view container numberOfElements = 20).
	
	firstNode := (view container elementsSuchThat: [:el | el model = 1]) first.
	self assert: firstNode numberOfElements = 2.
	
	self assert: firstNode extent = ( 23@15).
! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/28/2012 17:34'!
testNilKeyOrValue

	"
	self debug: #testNilKeyOrValue
	"
	
	view nodes: #(1 2).
	view edgesFromAssociations: (Array with: 1 -> 2 with: nil -> 2 with: 1 -> nil).
	view edgeFromAssociation: nil -> nil.
	view edges: #(1 2) from: #yourself to: [ :v | nil ].
	view edges: #(1 2) from: [ :v | nil ] to: [ :v | nil ].
	view edges: #(1 2) from: [ :v | nil ] to: #yourself.

	self assert: (view root container elementsSuchThat: [ :n | n class == ROElement ]) size = 2.
	self assert: (view root container elementsSuchThat: [ :n | n class == ROEdge ]) size = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 19:58'!
testNoDraggable

	| el b |
	view interaction nodraggable.
	el := view node: 123.
	b := el position.
	
	self deny: (el is: RODraggable).
	
	el announce: (ROMouseDragging step: 40@50).
	self assert: el position = b! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 17:26'!
testNoPopup

	| el1 el2 el3 |
	view interaction noPopup.
	el1 := view node: 1.
	
	el2 := view node: 2.

	view interaction noPopup.
	el3 := view node: 3.

	self deny: (el1 is: ROPopup).
	self assert: (el2 is: ROPopup).
	self deny: (el3 is: ROPopup).! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/27/2012 20:04'!
testOddLine

	view node: 4.
	view edges: (Array with: 4) from: #yourself toAll: [ :m | #() ].

	self assert: view root container numberOfElements = 1.! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/29/2012 11:14'!
testPopupOnInnerInnerNodes
	| node1 node2 node3 |
	node1 := view node: 1 forIt: [ node2 := view node: 2 forIt: [ node3 := view node: 3 forIt: [  ] ] ].
	
	self assert: (node1 is: ROPopup).
	self assert: (node2 is: ROPopup).
	self assert: (node3 is: ROPopup).! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 6/2/2012 17:42'!
testPopupView
	| t el |
	t := false.

	view interaction popupView: [ :myView :ell |  t := true ] delay: 0. 
	el := view node: 'hello'.
	
	el announce: ROMouseEnter.
	self assert: t! !

!ROMondrianViewBuilderTest methodsFor: 'interaction' stamp: 'AlexandreBergel 6/3/2012 15:43'!
testPopupViewSize
	| el popup elRef |
	

	view interaction popupView: [ :ell :myView | 
		
		myView shape rectangle fillColor: Color blue.
		myView node: '' forIt: [  myView node: 'world' ] ] delay: 0. 
	el := view node: 'hello'.
	
	elRef := view node: 'h' forIt: [ view node: 'w' ].
	
	view applyLayout.
	
	self assert: view stack numberOfElements = 0.
	el announce: ROMouseEnter.
	self assert: view stack numberOfElements = 1.
	
	popup := view stack elements first.
	self assert: popup extent = (22 @ 22).! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: ''!
testPositionRelativeTo

	| outterNode1 innerNode1 innerNode2 innerNode3 |
	outterNode1 := view node: 'outter1' forIt: 
		[ innerNode1 := view node: 1 forIt: [ innerNode2 := view node: 2] ].
	
	self assert: innerNode2 bounds = ( (5@5) corner: (10@10) ).
	self assert: (innerNode2 positionRelativeTo: innerNode2) = (0 @ 0).
	self assert: (innerNode2 positionRelativeTo: innerNode1) = innerNode2 topLeft.
	self assert: (innerNode2 positionRelativeTo: outterNode1) = (innerNode2 topLeft + innerNode1 topLeft).! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 18:43'!
testRectangleWithText

	view shape rectangle withText: [ :v | v ].
	view node: Object.
	! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 5/17/2012 20:39'!
testShapeAndEdges

	| edges |
	view nodes: (1 to: 5).
	view shape line color: Color blue.
	edges := view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
		
	self assert: edges size = 5.
	edges do: [ :edge | 
		self assert: (edge getShape: ROLine) color = Color blue. 
	]
! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: ''!
testShapeAreProperlyInitialized
	| node1 node2 |
	
	view shape rectangle width: 20.
	node1 := view node: 123.
	self assert: node1 bounds width = 20.
	node2 := view node: 1234.
	
	self assert: node1 bounds width = 20.
	self assert: node2 bounds width = 5.! !

!ROMondrianViewBuilderTest methodsFor: 'layout' stamp: 'AlexandreBergel 4/17/2012 17:26'!
testSugiyamaLayout 

	| nodes result |
	view node: 'foo' forIt: [
		view node: 'foo' forIt: [
			nodes := view nodes: (1 to: 5).
			view edgesFromAssociations: (Array with: 1 -> 2 with: 3 -> 5 with: 2-> 5).
			view sugiyamaLayout 
		]
	].
	
	result := ((Array new: 5) at: 1 put: ((24.0@3.0) corner: (29.0@8.0)); at: 2 put: ((20.0@28.0) corner: (25.0@33.0)); at: 3 put: ((28.0@28.0) corner: (33.0@33.0)); at: 4 put: ((28.0@53.0) corner: (33.0@58.0)); at: 5 put: ((20.0@53.0) corner: (25.0@58.0)); yourself).
	self assert: (nodes collect: #bounds) = result.! !

!ROMondrianViewBuilderTest methodsFor: 'instantiating' stamp: 'AlexandreBergel 5/17/2012 20:53'!
testTitle
	| builder |
	builder := ROMondrianViewBuilder titled: 'hello world'.
	window := builder open.
	
	[
		self assert: window labelString = 'hello world'.
	] ensure: [ window delete ]! !

!ROMondrianViewBuilderTest methodsFor: 'interaction updating' stamp: 'AlexandreBergel 5/7/2012 11:50'!
testUpdating

	| node bitmap1 bitmap2 view2 |

	"We first get a bitmap with a black border"
	view := ROMondrianViewBuilder new.
	view shape rectangle width: 40; height: 20.
	node := view node: $a.
	bitmap1 := view container bitmap.
	
	"We change the color of the element"
	(node getShape: ROBox) borderColor: Color red.
	node signalUpdate.
	
	"The bitmap should be different now that there is a red border"
	self assert: bitmap1 ~= view container bitmap.


	"---------"
"	view2 := ROMondrianViewBuilder new.
	view2 shape rectangle width: 40; height: 20; borderColor: Color red.
	node := view2 node: $a.
	bitmap2 := view2 container bitmap.
	self assert:  view container bitmap = bitmap2
"

"
bitmap1 asMorph openInWindow
bitmap2 asMorph openInWindow
view container bitmap asMorph openInWindow
"! !

!ROMondrianViewBuilderTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:50'!
testWithText
	| node1 node2 |

	view shape rectangle.
	node1 := view node: 'a'.

	view shape rectangle withText.
	node2 := view node: 'b'.
	
	self assert: (node2 getShape: ROLabel) notNil.
	
	self should: [ node1 getShape: ROLabel ] raise: Error.
	"self assert: (node1 getShape: ROLabel) isEmpty."! !

!ROMondrianViewBuilderTest methodsFor: 'nodes' stamp: ''!
testlookup

	| nodes |
	nodes := view nodes: #(1 2 3 4).
	self assert: (view lookup: 1) == nodes first.
	self assert: (view lookup: 4) == nodes fourth.
	self assert: (view lookup: 6) == nil! !

!ROMondrianViewBuilderTest methodsFor: 'edges' stamp: 'AlexandreBergel 4/17/2012 17:20'!
testrawEdgesFrom
	| nodes edges ass m assoc |

	nodes := view nodes: #(1 2 3 4).
	self assert: view container numberOfElements = 4.
	assoc := 1 -> 2.

	edges := view rawEdges: (Array with: assoc) from: #key to: #value.
	self assert: edges size = 1.
	self assert: edges first from = nodes first.
	self assert: edges first to = nodes second.! !

TestCase subclass: #ROPopupMondrianTest
	instanceVariableNames: 'view window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder-Tests'!

!ROPopupMondrianTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/2/2012 10:03'!
testNoTwoPopupAtTheSameTime

	| nodes |
	view := ROMondrianViewBuilder new.
	nodes := view nodes: #(1 2).
	
	"We have done nothing so far, so there is only two nodes"
	self assert:  view container numberOfElements = 2.
	self assert:  view stack numberOfElements = 0.

	
	"We enter one node, a popup appears in the stack"
	nodes first announce: ROMouseEnter.
	self assert:  view container numberOfElements = 2.
	self assert:  view stack numberOfElements = 1.
	
	"We enter the second node, a popup appears, but the first popup should diseapear"
	nodes second announce: ROMouseEnter.
	self assert:  view container numberOfElements = 2.
	self assert:  view stack numberOfElements = 1.
! !

TestCase subclass: #ROPopupTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/1/2012 19:00'!
testPositionInAStack
	| view stack element popup |
	view := ROView new.
	view
		add:
			(element := (ROLabelElement spriteOn: 'an element')
				@ ROPopup;
				textColor: Color gray).
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	element translateBy: 40@60.
	element announce: (ROMouseEnter new position: 45 @ 65; realPosition: 45 @ 65).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = ((45 @ 65) + ROPopup defaultPopupOffset).! !

!ROPopupTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/2/2012 09:41'!
testPositionInAStack2
	| view stack element popup |
	view := ROView new.
	view
		add:
			(element := (ROLabelElement spriteOn: 'an element')
				@ ROPopup;
				textColor: Color gray).
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	view translateBy: 40@60.
	element announce: (ROMouseEnter new realPosition: 40@60).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).! !

TestCase subclass: #ROPopupViewTest
	instanceVariableNames: 'popup popupView view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROPopupViewTest methodsFor: 'running' stamp: 'AlexandreBergel 6/1/2012 18:19'!
setUp
	| el |
	view := ROView new.
	
	popupView := ROView new.
	el := (ROElement new extent: 50@60)+ (ROBox new color: Color blue).
	popupView add: el.
	
! !

!ROPopupViewTest methodsFor: 'position in a stack' stamp: 'AlexandreBergel 6/2/2012 09:43'!
testPositionInAStack
	| stack element |
	view
		add:
			(element := (ROLabelElement spriteOn: 'an element')
				@ (ROPopupView new view: popupView);
				textColor: Color gray).
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	element translateBy: 40@60.
	element announce: (ROMouseEnter new realPosition: 40 @ 60).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = ((40 @ 60) + ROPopup defaultPopupOffset).! !

!ROPopupViewTest methodsFor: 'position in a stack' stamp: 'AlexandreBergel 6/2/2012 09:59'!
testPositionInAStack2
	| stack element |
	view
		add:
			(element := (ROLabelElement spriteOn: 'an element')
				@ (ROPopupView new view: popupView);
				textColor: Color gray).
	view @ RODraggable.
	
	stack := ROViewStack new.
	stack addView: view.
"	stack open"
	
	self assert: (view numberOfElements = 1).
	
	element announce: ROMouseEnter.	
	self assert: (view numberOfElements = 2).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).

	"The popup is not displayed anymore"
	element announce: ROMouseLeave.	
	self assert: (view numberOfElements = 1).
	
	view translateBy: 40@60.
	element announce: (ROMouseEnter new realPosition: 40@60).
	popup := (view elementsSuchThat: [ :el | el ~~ element ]) first.
	self assert: popup position = (element position + ROPopup defaultPopupOffset).! !

!ROPopupViewTest methodsFor: 'receiving view' stamp: 'AlexandreBergel 6/2/2012 09:59'!
testPositionWithReceivingView

	| el receivingView |
	receivingView := ROView new.
	view := ROView new.
	el := ROElement sprite.
	el translateTo: 50@25.
	el @ (ROPopup new receivingView: receivingView).
	view add: el.
	
	el announce: ROMouseEnter.
	popup := receivingView elements first.
	self assert: popup position =  (10@10).! !

!ROPopupViewTest methodsFor: 'receiving view' stamp: 'AlexandreBergel 6/1/2012 18:26'!
testWithReceivingView

	| el receivingView |
	receivingView := ROView new.
	view := ROView new.
	el := ROElement sprite.
	el @ (ROPopup new receivingView: receivingView).
	view add: el.
	
	self assert: view elements size = 1.
	self assert: receivingView elements isEmpty.
	
	el announce: ROMouseEnter.
	self assert: view elements size = 1.
	self assert: receivingView elements size = 1.
	
	el announce: ROMouseLeave.
	self assert: view elements size = 1.
	self assert: receivingView elements isEmpty.
	
	el announce: ROMouseLeave.
	self assert: view elements size = 1.
	self assert: receivingView elements isEmpty.! !

!ROPopupViewTest methodsFor: 'receiving view' stamp: 'AlexandreBergel 6/1/2012 18:21'!
testWithoutReceivingView

	| el |
	view := ROView new.
	el := ROElement sprite.
	el @ ROPopup.
	view add: el.
	
	self assert: view elements size = 1.
	el announce: ROMouseEnter.
	self assert: view elements size = 2.
	el announce: ROMouseLeave.
	self assert: view elements size = 1.
	el announce: ROMouseLeave.
	self assert: view elements size = 1.! !

TestCase subclass: #ROScrollbableTest
	instanceVariableNames: 'view stack horizontalScrollbar verticalScrollbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROScrollbableTest methodsFor: 'running' stamp: 'AlexandreBergel 6/5/2012 18:02'!
setUp

	view := ROView new.
	view add: ROElement sprite.

	view addAll: (ROHorizontalLineLayout on: (ROElement spritesFor: (1 to: 50))).
	"view @ RODraggable ."

	stack := ROViewStack new.
	stack addView: view.
	stack @ ROScrollbable.
	"stack open."

	"Get the scrollbars"	
	horizontalScrollbar := stack elements first.
	verticalScrollbar := stack elements second.
! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 23:22'!
testMovingScrollbar

	ROGridLayout on: view elements .

	verticalScrollbar announce: (ROMouseDragging step: 0 @ 250).
	self assert: verticalScrollbar position = (0 @ 250).
	
	self assert: view encompassingRectangle height =  350.
	self assert: view camera position =  (0 @ 175) " ((2995-  view camera width) @0).".
	
	
	horizontalScrollbar announce: (ROMouseDragging step: 250 @ 0).
	self assert: horizontalScrollbar position = (250 @ 0).
	
	self assert: view encompassingRectangle width =   530.
	self assert: view camera position =  (265 @ 175) " ((2995-  view camera width) @0)."! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 18:02'!
testScrollbar

	self assert: horizontalScrollbar position = (0 @ 0).
	self assert: view camera position = (0 @ 0)! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 23:22'!
testScrollbarBottomMost

	verticalScrollbar announce: (ROMouseDragging step: 0 @ 10000).
	self assert: verticalScrollbar position = (0 @ 420).
	
	self assert: view encompassingRectangle height =  55.
	self assert: view camera position =   (0@46) " ((2995-  view camera width) @0)."! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 18:02'!
testScrollbarRightMost

	horizontalScrollbar announce: (ROMouseDragging step: 10000 @ 0).
	self assert: horizontalScrollbar position = (420 @ 0).
	
	self assert: view encompassingRectangle width = 2995.
	self assert: view camera position =  (2515@0) " ((2995-  view camera width) @0)."! !

!ROScrollbableTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/5/2012 17:59'!
testStack
	"Only one element in the stack so far. Soon we will have two!!"
	self assert: stack numberOfElements = 2.
! !

TestCase subclass: #ROSequenceOfInteractionTest
	instanceVariableNames: 'emptySequence sequence incr'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction-Tests'!

!ROSequenceOfInteractionTest methodsFor: 'running' stamp: 'AlexandreBergel 5/4/2012 11:29'!
setUp
	emptySequence := ROSequenceOfInteraction new.
	sequence := ROSequenceOfInteraction new.
	incr := 0.
	sequence after: 2 do: [ incr := 0 ].
	sequence after: 5 do: [ incr := incr + 1 ].
	sequence after: 5 do: [ incr := incr + 2 ]! !

!ROSequenceOfInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/4/2012 11:29'!
testExecute
	self assert: incr = 0.
	sequence execute.
	sequence waitUntilDone.
	self assert: incr = 3.
	self assert: sequence isOver! !

!ROSequenceOfInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/4/2012 09:52'!
testExecuteEmpty
	emptySequence execute.
	self assert: emptySequence isOver! !

!ROSequenceOfInteractionTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/4/2012 09:48'!
testIsOver
	self deny: sequence isOver.
	self assert: emptySequence isOver.! !

TestCase subclass: #ROTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

ROTest subclass: #ROAbstractCanvasTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROAbstractCanvasTest class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/19/2012 12:21'!
isAbstract
	^ self name == #ROAbstractCanvasTest ! !

!ROAbstractCanvasTest methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:20'!
canvasClass
	^ ROAbstractCanvas! !

!ROAbstractCanvasTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/19/2012 12:20'!
testTransformationBijection

	| canvas camera |
	camera := ROCamera new realExtent: 100@50; extent: 200@100.
	canvas := self canvasClass onCamera: camera.
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: 0@0)) = (0 @ 0).
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: -100 @ -50)) = (-100 @ -50).
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: 100 @ 50)) = (100 @ 50).
	
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: -10@ -6)) = (-10 @ -6).
	self assert: (canvas realToVirtualPoint: (canvas virtualToRealPoint: 40 @ 50)) = (40 @ 50).
	self assert: (canvas realToVirtualRectangle: (canvas virtualToRealRectangle: (-10 @ -6 corner: 40 @ 50))) =
					 (-10 @ -6 corner: 40 @ 50).! !

ROTest subclass: #ROAnnouncerTest
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROAnnouncerTest methodsFor: 'running' stamp: ''!
setUp
	super setUp.
	announcer := ROAnnouncer new.! !

!ROAnnouncerTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 13:57'!
testIsForwarder

	| t |
	self deny: announcer isForwarder.

	t := 0.
	announcer when: ROEvent do: [ :ann | t := t + 1 ].
	self assert: t isZero.

	announcer announce: ROEvent.
	self assert: t = 1.
	announcer announce: ROMouseClick.
	self assert: t = 2.
	
	announcer forward: ROMouseClick.
	announcer announce: ROMouseClick.
	self assert: t = 2. "No increase since it is forwarded."
	announcer announce: ROEvent.
	self assert: t = 3.

! !

!ROAnnouncerTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/18/2012 13:57'!
testIsForwarder2

	| t |

	t := 0.
	announcer when: ROEvent do: [ :ann | t := t + 1 ].
	self deny: (announcer isForwarded: ROMouseClick). 

	announcer forward: ROEvent.
	self assert: (announcer isForwarded: ROMouseClick).

	announcer announce: ROMouseClick.
	self assert: t = 0. "No increase since it is forwarded."

	announcer announce: ROEvent.
	self assert: t = 0.

! !

ROTest subclass: #ROBorderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROBorderTest methodsFor: 'tests' stamp: ''!
testInitialization
	| border |
	border := ROBorder new.
	self assert: border color == ROBorder defaultColor! !

!ROBorderTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/10/2012 22:49'!
testSetting
	| border |
	border := ROBorder new.
	border color: Color green.
	self assert: border color = Color green! !

ROTest subclass: #ROBoxTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROBoxTest methodsFor: 'tests' stamp: ''!
testChangingBorderColor

	| box color |
	box := ROBox new.
	color := box borderColorFor: ROElement new.

	box borderColor: Color red.
	self assert: (box  borderColorFor: ROElement new) == Color red.
	self assert: (box  borderColorFor: ROElement new) ~= color! !

!ROBoxTest methodsFor: 'tests' stamp: ''!
testChangingWidthColor

	| box width |
	box := ROBox new.
	width := box borderWidthFor: ROElement new.

	box borderWidth: 4.
	self assert: (box  borderWidthFor: ROElement new) = 4.
	self assert: (box  borderWidthFor: ROElement new) ~= width! !

!ROBoxTest methodsFor: 'tests' stamp: ''!
testInitialization 

	self assert: ROBox new color == ROBox defaultColor! !

ROTest subclass: #ROCameraTest
	instanceVariableNames: 'camera2 camera1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCameraTest methodsFor: 'TODO' stamp: 'AlexandreBergel 4/19/2012 11:01'!
movingToSeeMore
	
	self assert: camera1 height >= 200.
	self assert: camera1 height < 230.

	self assert: camera1 position = (0@0).
	self assert: camera1 bounds = ( -199@ -199 corner: 199@199).
	
	camera1 moveToSee: (0@0 corner: 200@200).

	self assert: camera1 height = 91.
	self assert: camera1 position = (100@100).
	self assert: camera1 bounds = (0@0 corner: 200@200).

	camera1 moveToSee: (50@50 corner: 600@600).

	self assert: camera1 height = 252.
	self assert: camera1 position = (325@325).
	self assert: camera1 bounds = (73@73 corner: 576@576).
! !

!ROCameraTest methodsFor: 'running' stamp: ''!
setUp
	camera1 := ROCamera new.

	camera2 := ROCamera new.
	camera2 height: 20.! !

!ROCameraTest methodsFor: 'tests' stamp: ''!
testAngle

	self assert: camera1 angle = ROCamera defaultAngle! !

!ROCameraTest methodsFor: 'tests' stamp: ''!
testInitialization
	
	self assert: camera1 angle = ROCamera defaultAngle.
	self assert: camera1 position = ROCamera defaultPosition! !

!ROCameraTest methodsFor: 'initializing' stamp: ''!
testInitialize

	self assert: ROCamera new extent = ROCamera defaultExtent ! !

!ROCameraTest methodsFor: 'moving' stamp: ''!
testMovingUpAndDownCameraShouldBeCentered

	| view el b1 b2 |
	view := ROView new.
	view add: (el := ROElement sprite).
	"view open."

	self assert: (el bounds = ( 0@0 corner: 50@50)).

	b1 := (view camera virtualToRealRectangle: el bounds).

	"we move up"
	view camera moveDown.
	b2 := (view camera virtualToRealRectangle: el bounds).
	self assert: b1 extent < b2 extent.

	"check at the position of the element"
	self assert: b1 origin < b2 origin
! !

!ROCameraTest methodsFor: 'moving' stamp: ''!
testMovingUpAndDownCameraShouldBeCentered2

	| view el b1 b2 |
	view := ROView new.
	view add: (el := ROElement sprite).
	el center: 250@250.
	self assert: el center = (250@250).
	"view open."

	b1 := (view camera virtualToRealRectangle: el bounds).
	self assert: b1 center = (250@250).
	
	"we move up"
	view camera moveUp.
	b2 := (view camera virtualToRealRectangle: el bounds).
	self assert: b2 center = (230@230).! !

!ROCameraTest methodsFor: 'translating' stamp: ''!
testTranslating
	self assert: (camera1 virtualToRealPoint: (camera1 realToVirtualPoint: 250@500)) = ( 250@500).
	self assert: (camera1 realToVirtualPoint: 250@500) = ( 250@500).
	camera1 translateBy: 50@30.
	self assert: (camera1 virtualToRealPoint: (camera1 realToVirtualPoint: 250@500)) = ( 250@500).
	self assert: (camera1 realToVirtualPoint: 250@500) = ( 300@530).! !

!ROCameraTest methodsFor: 'TODO' stamp: 'AlexandreBergel 4/19/2012 11:01'!
visibleBounds
	| h p a ra v |
	h := camera1 height.
	p := camera1 position.
	a := camera1 angle.
	ra := a asFloat / 180 * 3.1415.
	v := h * ra sin.
	self assert: camera1 bounds = 
					(((p x - v )@ (p y - v)) asIntegerPoint corner: ((p x + v) @ (p y + v)) asIntegerPoint).

	self assert: camera1 bounds = ( -199@ -199 corner: 199@199)
! !

ROTest subclass: #ROCircleTest
	instanceVariableNames: 'node'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCircleTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp

	node := ROElement on: 'hello'.
	node extent: 40 @ 30.
	node
		addShape: (ROCircle new color: Color green)
	! !

!ROCircleTest methodsFor: 'as yet unclassified' stamp: ''!
testInitialization
	self assert: (ROCircle new color = ROCircle defaultColor)! !

ROTest subclass: #ROCollectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCollectionTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/18/2012 14:44'!
testAddInteraction

	| elements |
	elements := ROElement forCollection: (1 to: 20).
	self assert: (elements allSatisfy: [ :e | (e is: RODraggable) not ]).
	
	elements @ RODraggable.
	self assert: (elements allSatisfy: [ :e | e is: RODraggable ]).! !

ROTest subclass: #RODecoratorTest
	instanceVariableNames: 'box label element box2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!RODecoratorTest methodsFor: 'running' stamp: 'AlexandreBergel 4/14/2012 19:40'!
setUp

	box := ROBox new.
	box2 := ROBox new color: Color blue.
	label := ROLabel new.
	element := ROElement new.
! !

!RODecoratorTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/7/2012 11:52'!
testAddLast

	box addLast: box2.
	box2 addLast: label.
	self assert: box next == box2.
	self assert: label next == RONullShape current.! !

!RODecoratorTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/7/2012 11:53'!
testExample
	| el view |
	view := ROView new.
	view add: ((el := ROElement on: 10) + (ROBox new color: Color red; borderColor: Color blue)+ ROLabel).
	"
	view open
	"
	self assert: el shapes first borderColor == Color blue.
	self assert: el numberOfShapes = 2.! !

!RODecoratorTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/7/2012 11:54'!
testLinked
	"
	self debug: #testLinked
	"
				
	self assert: box next == RONullShape current.
	self assert: label next == RONullShape current.

	element 
		addShape: box;
		addShape: label.
	
	self assert: box next == label.
	self assert: label next == RONullShape current.
	
	self assert: element shapes asArray = (Array with: box with: label)! !

ROTest subclass: #ROElementTest
	instanceVariableNames: 'node draggableNode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

ROElementTest subclass: #ROContainingElementTest
	instanceVariableNames: 'node2 node3 node1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROContainingElementTest methodsFor: 'running' stamp: ''!
classToTest
	^ ROElement ! !

!ROContainingElementTest methodsFor: 'running' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp

	node2 := self classToTest on: 'world'.
	node2 extent: 40@30.
	node2 addShape: (ROBox new color: Color green).

	node3 := self classToTest on: 'world'.
	node3 extent: 40@30.
	node3 addShape: (ROBox new color: Color yellow).
	node3 translateBy: 40@30.

	node1 := self classToTest on: 'hello'.
	node1 extent: 100 @ 130.
	node1
		addShape: ROBox new;
		addShape: ROBorder new.! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/22/2012 00:38'!
testAddingWithResize

	self assert: node3 extent < node1 extent.
	node3 add: node1.
	self assert: node3 extent > node1 extent! !

!ROContainingElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/2/2012 14:27'!
testAddingWithoutResize

	self assert: node3 extent < node1 extent.
	node3 resizeStrategy: ROFixedSizedParent instance.
	node3 add: node1.
	self assert: node3 extent < node1 extent! !

!ROContainingElementTest methodsFor: 'dragging' stamp: ''!
testDraggingNestedElement

	| view b |
	"node1 bounds = 50@50 corner: 150@180 
	node3 bounds =  190@130 corner: 230@160 "
	node1 addInteraction: RODraggable.
	node3 addInteraction: RODraggable.
	node1 add: node3.
	view := (ROView new add: node1 ).

	node1 translateBy: 50 @ 50.
	
	"We move the inner node toward the bottom right corner"
	node3 translateBy: 150 @ 100.
	self assert: (node1 extent = ( 235@165)).
	
	"We move the inner node toward the top left corner"
	b := node1 bounds.
	node3 translateBy: -200 @ -150.
	self assert: node1 topLeft ~= b topLeft.
	self assert: node1 topLeft  = ( 40@30).
	"
	view open
	"! !

!ROContainingElementTest methodsFor: 'view' stamp: ''!
testElementAt

	| view |
"	node1 bounds => 0@0 corner: 100@130 
	node2 bounds => 0@0 corner: 40@30 
"
	view := ROView new.
	node1 add: node2.
	view add: node1.

	self assert: (node1 elementAt: (node1 topRight - (1 @ 0))) == node1.
	self assert: (node1 elementAt: node1 topLeft + (1 @ 1)) == node2.
	self assert: (node1 elementAt: node2 topLeft) == node2.

	self assert: (view elementAt: node1 topLeft + (1 @ 1)) == node2
	
! !

!ROContainingElementTest methodsFor: 'view' stamp: ''!
testElementAtAfterDragging

	| view |
	view := ROView new.
	node1 add: node2.
	view add: node1.
	
	node1 translateTo: 50@50.

	self assert: (node1 elementAt: (node1 extent - (1 @ 0))) == node1.
	self assert: (node1 elementAt: (1 @ 1)) == node2.
	self assert: (node1 elementAt: node2 topLeft) == node2.

	self assert: (view elementAt: node1 topLeft + (1 @ 1)) == node2
	
! !

!ROContainingElementTest methodsFor: 'events' stamp: 'AlexandreBergel 5/7/2012 18:37'!
testEventForNested

	| view circle grid options choice container t morph |
	t := 0.
	view := ROView new.
	circle := ROElement new 
				addInteraction: RODraggable;
				extent: 100@40; 
				addShape: (ROBorder red);
				addShape: (ROLabel text: 'circle'). 
	circle on: ROMouseClick do: [:e | t := t + 1 ].

	grid := ROElement new 
				addInteraction: RODraggable;
				extent: 100@40; 
				addShape: (ROBorder red);
				addShape: (ROLabel text: 'grid').
	grid on: ROMouseClick do: [:e | t := t + 10 ].
	options := (Array with: circle with: grid).

	choice := ROElement new.
	choice addAll: (ROHorizontalLineLayout on: options).
	
	view add: choice.
	"
	view openInWindow.
	"
	
	"grid adjustSizeOfParent  " 
	morph := RONativeWidgetFactory current forView: view.
	morph extent: 200@200.
	
	self assert: choice bounds = ( 0@0 corner: 220@50).
	
	"virtual position = 63@29"
	self assert: (choice contains: 63@29).
	
	"real position 32@15"
	self assert: (morph elementForRealPosition: 32@15) ~~ view.
! !

!ROContainingElementTest methodsFor: 'view' stamp: ''!
testSettingTheView

	| newNode view |
	newNode := ROElement new.
	self assert: (newNode view == ROView blackHole).

	self assert: (node1 view == ROView blackHole).
	view := ROView new.
	view add: node1.
	
	node1 add: newNode.
	
	self assert: (newNode view == view)! !

!ROContainingElementTest methodsFor: 'sizing' stamp: ''!
testSize

	| el el2 |
	el := ROElement new.
	self assert: (el extent = (5 @ 5)).
	el add: (el2 := ROElement sprite).
	
	ROAdjustSizeOfNesting on: el.
	self assert: (el extent = (el2 extent + (5@5)))
	! !

!ROContainingElementTest methodsFor: 'sizing' stamp: ''!
testSize2

	| bounds el |
	el := ROElement sprite.
	bounds := el bounds.
	
	ROAdjustSizeOfNesting on: el.
	self assert: (el bounds = bounds)
	! !

ROElementTest subclass: #ROEdgeTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROEdgeTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/18/2012 14:46'!
testCreation

	self should: [ ROEdge from: Object new to: Object new ] raise: Exception! !

!ROElementTest methodsFor: 'running' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp

	node := ROElement on: 'hello'.
	node extent: 40 @ 30.
	node
		addShape: ROBox new;
		addShape: ROBorder new.
	
	draggableNode := ROElement new.
	draggableNode @ RODraggable.
	draggableNode extent: 50@50.
	draggableNode + ROBorder red.! !

!ROElementTest methodsFor: 'event' stamp: ''!
testAnnounce

	| node1 node2 bounds |
	node1 := ROElement new.
	node2 := ROElement new.
	
	node1 on: ROMouseClick do: [ ROGrow on: node2 by: 1 ].
	bounds := node2 bounds.

	node1 announce: ROMouseClick.
	self assert: (bounds extent < node2 bounds extent)! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 08:46'!
testChangeShape
	"
	self debug: #testChangeShape
	"
	| element |
	element := ROEdge new.
	self deny: (element isShapedAs: ROCircle).
	element + ROCircle.
	element change: ROShape for: ROCircle.
	self assert: (element isShapedAs: ROCircle).
	self assert: (element isShapedAs: ROShape).
	
	element change: ROShape for: ROBox.
	self assert: (element isShapedAs: ROShape).
	self assert: (element isShapedAs: ROBox).
	"self deny: (element isDecoratedAs: ROCircle)."! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testContains

	self assert: (node contains: node position).
	self deny: (node contains: node position - (1 @ 1)).! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testCornerRadius

	node := ROElement new center: 10@8 radius: 5.
	self assert: node bounds = (5@3 corner: 15@13)! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 12:01'!
testDecoration
	| el |
	
	el := ROElement new.
	self deny: (el isShapedAs: ROShape).
	self deny: (el isShapedAs: ROLabel).
	
	el addShape: ROLabel.
	self assert: (el isShapedAs: ROShape).
	self assert: (el isShapedAs: ROLabel).! !

!ROElementTest methodsFor: 'event' stamp: 'AlexandreBergel 5/22/2012 21:01'!
testDragAndDropWithInner

	| view outter inner |
	view := ROView new.
	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	outter add: inner.
	view add: outter.
	
	self assert: outter bounds = (0@0 corner: 55@55).
	self assert: inner bounds = (0@0 corner: 50@50).
	
	inner translateBy: -10 @ -10.
	self assert: outter bounds = ( -10@ -10 corner: 55@55).
	self assert: inner bounds = (0@0 corner: 50@50).
! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testForwarding

	| inner view outter bInner bOutter |
	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	inner forward.
	outter add: inner. 
	view := ROView new.
	view add: outter.

	bInner := inner bounds.
	bOutter := outter bounds.
	inner announce: (ROMouseDragging step: 10@10). 
	self assert: inner bounds = bInner.
	self assert: outter bounds = (bOutter translateBy: (10@10)).! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testForwardingEvent

	| inner view outter bInner bOutter t |
	t := 0.
	outter := ROElement spriteOn: 'outter'.
	outter on: ROEvent do: [ :evt | t := t + 1 ].
	inner := ROElement spriteOn: 'inner'.
	inner forward.
	outter add: inner. 
	view := ROView new.
	view add: outter.

	bInner := inner bounds.
	bOutter := outter bounds.
	self assert: t = 0.
	inner announce: (ROMouseDragging step: 10@10). 
	self assert: t = 1.
! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testForwardingEventWithView

	| inner view outter bInner bOutter t |
	t := 0.
	view := ROView new.
	view on: ROEvent do: [ :evt | t := t + 1 ].

	outter := ROElement spriteOn: 'outter'.
	inner := ROElement spriteOn: 'inner'.
	
	outter add: inner. 
	view add: outter.

	inner forward.
	outter forward.
	
	self assert: outter parent == view.
	self assert: inner parent == outter.

	self assert: t = 0.
	inner announce: (ROMouseDragging step: 10@10). 
	self assert: t = 1.
! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:48'!
testGetShape
	| el deco |
	
	el := ROElement new.
	deco := ROBox new.
	deco color: Color red.
	el addShape: deco.
	
	self assert: (el getShape: ROBox) == deco.! !

!ROElementTest methodsFor: 'group of nodes' stamp: ''!
testGroupOfNodes

	| nodes |
	nodes := ROElement forCollection: (1 to: 20).
	self assert: (nodes size = 20).
	self assert: (nodes collect: #model) = (1 to: 20)! !

!ROElementTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/7/2012 11:53'!
testInitialization
	| aNode |
	aNode := ROElement new.
	self assert: aNode bounds = ROElement defaultBounds.
	self assert: aNode extent = aNode bounds extent.
	
	self assert: aNode numberOfShapes isZero! !

!ROElementTest methodsFor: 'interaction' stamp: ''!
testInteraction 

	| int int2 |

	self deny: (node is: ROMenuActivable).
	node @ (int := ROMenuActivable new item: 'act' action: #inspect).
	self assert: (node is: ROMenuActivable).
	
	self assert: int == (node getInteraction: ROMenuActivable).
	self assert: int numberOfEntries = 1.
	
	"We add a new action. We should fill the first interaction only"
	node @ (int2 := ROMenuActivable new item: 'act2' action: #inspect).
	self assert: int numberOfEntries = 2.
	self assert: int == (node getInteraction: ROMenuActivable).! !

!ROElementTest methodsFor: 'iteration' stamp: ''!
testIteratingOnEmptyCollections

	self shouldnt: [ ROElement new interactionsDo: [ :el | ] ]  raise: Error! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testModel
	| aNode object |
	aNode := ROElement new.
	self assert: aNode model isNil.

	aNode := ROElement on: (object := Object new).
	self assert: (aNode model == object)! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 5/10/2012 09:27'!
testOverridingIteraction

	"Ugly test, but we need to get the hand on it. A bug is hidding at the moment we are writting this test"
	"This test makes some strong assumption on the implementation of Announcement"
	
	| eventHandler |
	eventHandler := node instVarNamed: 'eventHandler'.

	self assert: eventHandler numberOfSubscriptions = 0.
	
	"Two subscription, one for entering and another for leaving"

	node @ ROPopup.
	self assert: eventHandler numberOfSubscriptions = 2.
	
	node changeInteraction: ROAbstractPopup for: (ROPopupView new view: ROView new).
	self assert: eventHandler numberOfSubscriptions = 2.	
! !

!ROElementTest methodsFor: 'parent' stamp: 'AlexandreBergel 5/22/2012 00:26'!
testParentAndNesting

	| inner outter |
	inner := ROElement new.
	outter := ROElement new.
	
	self assert: inner parent == ROView blackHole.
	self assert: outter parent == ROView blackHole.
	
	outter add: inner. 

	self assert: inner parent == outter.
	self assert: outter parent == ROView blackHole.
! !

!ROElementTest methodsFor: 'parent' stamp: 'AlexandreBergel 5/22/2012 00:25'!
testParentAndView

	| element view |
	element := ROElement new.
	self assert: element parent == ROView blackHole.

	view := ROView new.
	view add: element.

	self assert: element parent == view.! !

!ROElementTest methodsFor: 'parent' stamp: 'AlexandreBergel 6/2/2012 14:26'!
testParentBehavior

	| element outterElement view |
	element := ROElement new.
	self assert: element resizeStrategy == ROExtensibleParent instance.
	
	outterElement := ROElement new.
	outterElement add: element.
	self assert: element resizeStrategy == ROExtensibleParent instance.
! !

!ROElementTest methodsFor: 'printing' stamp: 'AlexandreBergel 5/10/2012 16:39'!
testPrinting

	self assert: (#('a ROElement' 'a Roassal.ROElement') includes: ROElement new printString).
	self assert: (#( 'a ROElement<10>'  'a Roassal.ROElement<10>') includes: (ROElement on: 10) printString).

! !

!ROElementTest methodsFor: 'actions' stamp: ''!
testRemoveElements

	| elements |

	elements := node elementsSuchThat: [:e | true ].
	self assert: elements isEmpty.
	
	node addAll: (ROElement forCollection: (1 to: 20)).
	elements := node elementsSuchThat: [:e | true ].
	self assert: elements notEmpty.
	
	node removeAllElements.
	elements := node elementsSuchThat: [:e | true ].
	self assert: elements isEmpty.! !

!ROElementTest methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 19:57'!
testRemoveInteraction

	| el |
	el := ROElement new.
	self deny: (el is: RODraggable).
	
	el @ RODraggable.
	self assert: (el is: RODraggable).

	el removeInteraction: RODraggable.
	self deny: (el is: RODraggable).! !

!ROElementTest methodsFor: 'actions' stamp: 'AlexandreBergel 6/5/2012 10:31'!
testRemoveOnElement

	| view |
	view := ROView new.
	view add: node.
	self assert: (view elements includes: node).
	
	node remove.
	self deny: (view elements includes: node).! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 08:31'!
testRemoveShape

	self assert: (node shapes size = 2).
	node - ROBox.
	self assert: (node shapes size = 1).
	node + ROBox.
	self assert: (node shapes size = 2).
	
	"No error should happen here"
	self shouldnt: [ node - ROLine ] raise: Error.
	
	node - ROBorder.
	node - ROBox.
	self assert: (node shapes isEmpty).
	! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 08:44'!
testRemoveShapeAfterAChangeFor

	node := ROElement new.
	self assert: node shapes isEmpty.
	node change: ROShape for: ROBox.
	self assert: node shapes isEmpty.! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 08:35'!
testRemoveShapeOnEdges

	| edge |
	edge := ROEdge new.
	self assert: (edge shapes isEmpty).
	edge - ROLine.
	self assert: (edge shapes isEmpty).
	edge + ROLine.
	self assert: (edge shapes size = 1).
	
	"No error should happen here"
	self shouldnt: [ edge - ROBox] raise: Error.
	
! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 08:44'!
testRemoveShapeWithTreeLayout

	| view edges |
	view := ROMondrianViewBuilder new.
	view nodes: #(1 2).
	edges := ( view edgesFrom: [ :v | v + 1 ]).

	edges first shapes.
	edges do: [ :edge | edge - ROLine ].
	edges first shapes.
	view treeLayout.

	self shouldnt: [ view container bitmap ]  raise:  Error ! !

!ROElementTest methodsFor: 'shapes' stamp: 'AlexandreBergel 5/10/2012 09:34'!
testRemoveSubscription

	"Ugly test, but we need to get the hand on it. A bug is hidding at the moment we are writting this test"
	"This test makes some strong assumption on the implementation of Announcement"
	
	| eventHandler aPopup |
	eventHandler := node instVarNamed: 'eventHandler'.

	self assert: eventHandler numberOfSubscriptions = 0.
	
	aPopup := ROPopup new.
	node @ aPopup.
	self assert: eventHandler numberOfSubscriptions = 2.

	eventHandler unsubscribe: aPopup.
	self assert: eventHandler numberOfSubscriptions = 0.! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testRendering
	
	| nullCanvas |
	nullCanvas := ROCountingNullCanvas new.
	self assert: nullCanvas numberOfRectangles isZero.
	node drawOn: nullCanvas.

	self assert: nullCanvas numberOfRectangles = 1.
	self assert: nullCanvas numberOfLines = 4.! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testTranslatingByFloats

	
	self assert: draggableNode position = (0@0).
	draggableNode translateBy: 4.5 @ 1.3.
	self assert: draggableNode position = (4.5 @ 1.3).
	
	node translateTo: 2.4 @ 6.4.
	self assert: node position = ( 2.4@6.4).
	
	node translateBy: 2.4 @ 6.4.
	self assert: node position = ( 4.8@12.8)! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testTranslatingByRealPoint

	| view p1 |
	view := ROView new.
	view add: draggableNode.
	
	"dragging a node increases its position by the dragging step"
	p1 := draggableNode position.
	self assert: (p1 = (0@0)).
	draggableNode translateByRealPoint: 10 @ 6.
	self assert: (draggableNode position = ( 10 @ 6)).
	draggableNode translateByRealPoint: -10 @ -6.
	self assert: (draggableNode position = ( 0 @ 0)).

	"take care of real vs virtual steps"
	view camera bounds: (0@0 corner: 250@250).
	draggableNode translateByRealPoint: 10 @ 6.
	self assert: (draggableNode position = ( 5@3)).! !

!ROElementTest methodsFor: 'tests' stamp: ''!
testView

	self assert: node view == ROView blackHole.

	ROView new add: node.
	self assert: node view notNil.	  ! !

ROTest subclass: #ROLabelTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/27/2012 18:47'!
testLinesOf

	| label |
	label := ROLabel new.
	self assert: (label linesOf: 'hello
world
	bravo') = #('hello' 'world' '	bravo')! !

!ROLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/27/2012 18:54'!
testLinesOfEmptyString

	| label |
	label := ROLabel new.
	self assert: (label linesOf: '') = #()! !

!ROLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/27/2012 18:54'!
testLinesOfWithTrailingCR

	| label |
	label := ROLabel new.
	self assert: (label linesOf: 'hello
world
	bravo
') = #('hello' 'world' '	bravo')! !

!ROLabelTest methodsFor: 'tests' stamp: ''!
testMinimumSize

	| el |
	el := ROElement on: 'hello'.
	el extent: (90 @ 45).
	self assert: el extent = (90 @ 45).
	
	el + ROLabel.
	self assert: el extent = (90 @ 45).! !

!ROLabelTest methodsFor: 'tests' stamp: ''!
testMinimumSize2

	| el |
	el := ROElement on: 'hello'.
	el extent: (3 @ 3).
	self assert: el extent = (3 @ 3).
	
	el + ROLabel.
	self assert: el extent > (3 @ 3).! !

!ROLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/27/2012 17:54'!
testMultilines

	| view elementWith2Lines elementWith1Line |
	view := ROView new.
	view add: (elementWith2Lines := ROLabelElement on: 
'hello 
world').
	view add: (elementWith1Line := ROLabelElement on: 'bonjour le monde!!').
	"view openInWindow."
	
	self assert: (elementWith2Lines height >= (elementWith1Line height * 2))! !

!ROLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/27/2012 18:31'!
testReplaingWhiteCharacter

	| label element str |
	label := ROLabel new.
	element := ROElement on: (str := '	abc	def').
	self assert: (label textFor: element) = str.
	self assert: (label textAdaptedFor: element) = '    abc    def'.
! !

!ROLabelTest methodsFor: 'tests' stamp: ''!
testSize
	| el1 el2 |
	el1 := ROElement on: 'hello'.
	el2 := ROElement on: 'h'.
	
	self assert: el1 bounds = el2 bounds.
	self assert: el1 bounds = ( 0@0 corner: 5@5).
	
	el1 + ROLabel.
	el2 + ROLabel.
	
	self assert: el1 extent = (ROLabel new preferedExtentFor: el1).
	self assert: el2 extent = (ROLabel new preferedExtentFor: el2).
	
	self assert: el1 bounds ~= el2 bounds.
	self assert: el1 bounds height = el2 bounds height.
	self assert: el1 bounds width > el2 bounds width.! !

!ROLabelTest methodsFor: 'tests' stamp: ''!
testTextFor

	| label el |
	label := ROLabel new.
	label text: [ :e | e model + 1].
	el := ROElement on: 2.
	self assert: (label textFor: el) = '3'! !

!ROLabelTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/29/2012 10:09'!
testWidthFor

	| label element1 element2 |
	label := ROLabel new.
	element1 := ROElement on: 'abcdefghijk
abc
def'.
	element2 := ROElement on: 'abcdefghijk'.
	
	self assert: (label longestTextLineFor: element1) = (label longestTextLineFor: element2).
	self assert: (label longestTextLineFor: element1) = element2 model.
	self assert: (label widthFor: element1) = (label widthFor: element2).! !

ROTest subclass: #ROOrderedCollection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROOrderedCollection methodsFor: 'as yet unclassified' stamp: ''!
testBasic

	self assert: ((#(5 4 1 5 2) asSorted: #squared) =  #(1 2 4 5 5) )! !

ROTest subclass: #ROParentElementResizeStrategyTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROParentElementResizeStrategyTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/2/2012 14:27'!
testFixedSized

	| view el1 el2 |
	view := ROView new.
	el1 := ROElement new.
	el1 resizeStrategy: ROFixedSizedParent instance.
	el1 addAll: (ROGridLayout on: ((1 to: 5) collect: [ :i | ROElement new ])).
	
	el2 := ROElement new.
	el2 resizeStrategy: ROExtensibleParent instance.
	el2 addAll: (ROGridLayout on: ((1 to: 5) collect: [ :i | ROElement new ])).
	
	self assert: el1 bounds = ( (0@0) corner: (5@5)).
	self assert: el2 bounds = ( (0@0) corner: (45@30)).! !

ROTest subclass: #ROViewTest
	instanceVariableNames: 'node1 view emptyView node2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

ROViewTest subclass: #ROViewStackTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROViewStackTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/30/2012 16:43'!
testNestingView

	| newView el mouseClickPosition |
	newView := ROView new.
	newView add: (el := ROElement sprite translateTo: 0@60).

	view := ROViewStack new.
	view addFirst: newView.
	
	self assert: (view elementAtRealPosition: 23@85) == el.
	self assert: (newView elementAtRealPosition: 23@85) == el.

	(ROZoomOutMove new on: newView) waitUntilDone.

	self assert: (view elementAtRealPosition: (53@103)) == el.
	self assert: (newView elementAtRealPosition: (53@103)) == el.
	
	(ROZoomOutMove new on: newView) waitUntilDone.
	(ROZoomOutMove new on: newView) waitUntilDone.	

	self assert: (view elementAtRealPosition: (109@131)) == el.

"	view openInWindow"! !

!ROViewStackTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/30/2012 23:18'!
testOpening

	|  window |
	view := ROViewStack new.
	view add: (ROElement on: 'hello').
	window := view open.
	window delete! !

!ROViewTest methodsFor: 'running' stamp: 'AlexandreBergel 5/7/2012 11:54'!
setUp

	node1 := ROElement on: 'hello'.
	node1 extent: 40 @ 30.
	node1
		addShape: (ROBox new color: Color yellow);
		addShape: ROBorder new.
	node1 addInteraction: RODraggable.

	node2 := ROElement on: 'hello'.
	node2 extent: 40 @ 30.
	node2
		addShape: (ROBox new color: Color green).
	node2 translateBy: 100@30.
	
	view := self viewClass new.
	view add: node1.
	view add: node2.
	
	emptyView := ROView new.! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testAddingNode

	self assert: emptyView numberOfNodes isZero.
	emptyView add: ROElement new.
	self assert: emptyView numberOfNodes = 1.
	
	emptyView add: ROElement new.
	self assert: emptyView numberOfNodes = 2! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testCamera
	self assert: (view camera class == ROCamera)! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testCameraHeight
	| camera |
	camera := view camera.
	self assert: camera position = (0@0).
	self assert: camera height asInteger = 229.
	
	"Due to the rounding"
	camera height: 230.
	self assert: camera height asInteger = 229.
	
	
	! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 4/30/2012 15:25'!
testDefaultWindowSize

	self assert: (self viewClass new defaultWindowSize class == Point)! !

!ROViewTest methodsFor: 'dragging' stamp: ''!
testDraggingElement
	| el t |
	el := ROElement sprite.
	node1 add: el.

	t := false.
	view on: RORefreshNeeded do: [ :event | t := true. ].
	self deny: t.
	
	el announce: (ROMouseDragging step: 5 @ 3).
	self assert: t! !

!ROViewTest methodsFor: 'dragging' stamp: 'AlexandreBergel 4/30/2012 15:25'!
testDraggingElement2
	| el t |
	el := ROElement sprite.
	node1 add: el.

	t := false.
	view := self viewClass new.
	view add: node1; add: node2.
	view on: RORefreshNeeded do: [ :event | t := true ].
	self deny: t.
	
	"Check signalUpdate, since this is what is used to update the view"
	self assert: el view == node1 view.
	el signalUpdate.
	self assert: t.
	t := false.
	
	el announce: (ROMouseDragging step: 5 @ 3).
	self assert: t! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testDraggingView
	| camera |
	camera := view camera.
	
	self assert: camera bounds = ( 0@0 corner: 500@500).
	
	camera translateByRealStep: 15 @ 10.
	self assert: camera bounds = ( 15@10 corner: 515@510).

	"camera translateByRealStep: -15 @ -10.
	self assert: camera bounds = ( 0@0 corner: 500@500)."! !

!ROViewTest methodsFor: 'dragging' stamp: 'AlexandreBergel 6/2/2012 10:02'!
testDraggingViewAndPopupOnElement
	"
	self debug: #testDraggingViewAndPopupOnElement
	"
	
	| el popup |
	view := ROView new.
	el := ROElement spriteOn: 12.
	el @ ROPopup.
	view add: el.
	view 
			@ RODraggable;
			@ RODraggableWithVelocity.

	el announce: (ROMouseEnter new position: 0@0).
	self assert: view elements size = 2.
	popup := view elements second.
	self assert: popup position =  (10@10).
	el announce: ROMouseLeave.
	
	"We do a drag and drop of the view, and we mouse enter again"
	view translateBy: 50@60.
	el announce: (ROMouseEnter new realPosition: 50@60).
	popup := view elements second.
	self assert: popup position =  (10@10).
	el announce: ROMouseLeave.
	
	
	"
	view open
	"! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testElementAt

	self assert: (view elementAt: node1 bounds center) == node1.
	self assert: (view elementAt: node2 bounds center) == node2.
	self assert: (view elementAt: node2 bounds bottomRight + (1 @ 1)) == view ! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testElementAt2

	node1 translateBy: (-20 @ -20).
	self assert: (view elementAt: (node1 bottomRight - (5@5))) == node1.
	

"
self halt.
view openInWindow 
"! !

!ROViewTest methodsFor: 'tests' stamp: ''!
testElementAt3

	| node aPoint |
	node := ROElement sprite 
				extent: (100@100);
				add: (ROElement sprite).
	view add: node.
	self assert: (view elementAt: (node bottomRight - (5@5))) == node.
	
	node translateBy: -20 @ -20.
	aPoint := node bottomRight - (5@5).
	self assert: (node contains: aPoint).
	self assert: (view elementAt: aPoint) == node.

"
self halt.
view openInWindow 
"! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 6/3/2012 15:13'!
testEncompassingRectangle

	self assert: view encompassingRectangle = ((0@0) corner: (140@60)).
	
	node1 translateBy: 6@9.
	self assert: view encompassingRectangle = ((6@9) corner: (140@60)).! !

!ROViewTest methodsFor: 'events' stamp: ''!
testEvents

	| t |
	t := 0.
	view announce: RORefreshNeeded.
	self assert: t isZero.
	
	view on: RORefreshNeeded do: [ :event | t := t + 1 ].
	view announce: RORefreshNeeded.
	self assert: t = 1.
! !

!ROViewTest methodsFor: 'opening' stamp: ''!
testFormSize

	| form |
	form := view bitmapForRealSize: 20@30.
	self assert: form extent = (20 @ 30)! !

!ROViewTest methodsFor: 'opening' stamp: ''!
testOpenInWindow
	| window |
	window := view openInWindow.
	window delete! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 5/10/2012 16:41'!
testOpenInWindowSized
	| window |
	[ window := view openInWindowSized: 400@30.
	 self assert: window extent >= (400@30).]
		ensure: [ window delete ]! !

!ROViewTest methodsFor: 'overlapping' stamp: ''!
testOverlapping
	| greenNode |

	"greenNode is overlapping node1"
	greenNode := ROElement on: 'green node'.
	greenNode setBounds: (node1 bounds translateBy: 5@6 ).

	view add: greenNode.
	 
	"-----"
	self assert: (view elementAt: node1 bounds topLeft) == node1. 
	self assert: (view elementAt: greenNode bounds topLeft) == greenNode

	! !

!ROViewTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/22/2012 13:55'!
testSortingElements

	| nodes nodes2 |
	
	nodes := ROElement forCollection: #(1 2 3).
	emptyView addAll: nodes.
	
	nodes2 := emptyView elementsSuchThat: [ :v | true ].
	self assert: (nodes2 collect: #model) asArray = #(1 2 3).
	
	emptyView sortElementsWith: [ :a :b | a model > b model ].
	nodes2 := emptyView elementsSuchThat: [ :v | true ].
	self assert: (nodes2 collect: #model) asArray = #(3 2 1).
! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testTranslatingCamera
	| camera |
	camera := view camera.
	
	self assert: camera bounds = ( 0@0 corner: 500@500).
	
	camera translateBy: 15 @ 10.
	self assert: camera bounds = ( 15@10 corner: 515@510).

	camera translateBy: -15 @ -10.
	self assert: camera bounds = ( 0@0 corner: 500@500).! !

!ROViewTest methodsFor: 'camera' stamp: ''!
testVisibleBounds
	| window |
	self assert: view camera bounds = ( 0@0 corner: 500@500).
	window := view open.
	window delete.
	self assert: view camera bounds = ( 0@0 corner: 500@500).

	! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 4/30/2012 15:26'!
testWindowTitle

	| window |
	window := (view := self viewClass titled: 'Hello World') open.
	[ self assert: window labelString = 'Hello World'.
	  self assert: view title = 'Hello World' ]
		ensure: [ window delete ]! !

!ROViewTest methodsFor: 'opening' stamp: 'AlexandreBergel 5/22/2012 21:01'!
testWindowTitleDefault

	| window |
	window := self viewClass new open.
	[ self assert: window labelString = ROView defaultWindowTitle ]
		ensure: [ window delete ]! !

!ROViewTest methodsFor: 'running' stamp: 'AlexandreBergel 4/30/2012 15:25'!
viewClass
	^ ROView! !

TestCase subclass: #ROVisitorTest
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor-Tests'!

ROVisitorTest subclass: #ROCountingVisitorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor-Tests'!

!ROCountingVisitorTest methodsFor: 'tests' stamp: ''!
test

	| visitor |
	visitor := ROCountingVisitor new.
	self assert: visitor nbOfEdges isZero.
	self assert: visitor nbOfNodes isZero.
	
	visitor runOn: view.
	
	self assert: visitor nbOfEdges = 3.
	self assert: visitor nbOfNodes = 5.
! !

ROVisitorTest subclass: #ROHighlighterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor-Tests'!

!ROHighlighterTest methodsFor: 'tests' stamp: 'AlexandreBergel 5/7/2012 12:02'!
test
	" 
	self debug: #test
	"

	| b |
	b := [ :n | n model = 5].
	self assert: ((view elementsSuchThat: b) first shapesCollect: #borderColor) asArray
					= (Array with: Color black).
					
	ROHighlighter for: b in: view.
	
	self assert: ((view elementsSuchThat: b) first shapesCollect: #borderColor) asArray
					= (Array with: Color red).

	self assert: ((view elementsSuchThat: [ :n | (b value: n) not ]) first shapesCollect: #borderColor) asArray
					=  (Array with: Color black).
! !

!ROVisitorTest class methodsFor: 'as yet unclassified' stamp: ''!
isAbstract
	^ self name == #ROVisitorTest! !

!ROVisitorTest methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/17/2012 17:02'!
setUp

	| elements |
	view := ROView new.
	elements := ROElement forCollection: (1 to: 5).
	elements do: [ :el | el + ROBox ].
	view addAll: elements.
	view addAll: (ROEdge linesFor: 
		(Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third ))! !

TestCase subclass: #ROZoomElementTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!Array methodsFor: '*roassal-core' stamp: ''!
@ interactionClassOrObject
	| obj |
	obj := interactionClassOrObject elementToBeAdded.
	self do: [ :el | el addInteraction: obj ].
	^ self! !

!Point class methodsFor: '*roassal-core' stamp: ''!
radius: radius theta: angle
	^ (radius * angle cos) @ (radius * angle sin)! !

Announcement subclass: #ROEvent
	instanceVariableNames: 'position element realPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROAbstractMouseDragging
	instanceVariableNames: 'step'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: ''!
step
	^ step! !

!ROAbstractMouseDragging methodsFor: 'accessing' stamp: ''!
step: anObject
	step := anObject! !

ROAbstractMouseDragging subclass: #ROMouseDragged
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROAbstractMouseDragging subclass: #ROMouseDragging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROMouseDragging class methodsFor: 'as yet unclassified' stamp: ''!
step: value
	^ self new step: value! !

ROEvent subclass: #ROBeginingAnimation
	instanceVariableNames: 'animation nbCycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
animation
	^ animation! !

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
animation: anim
	animation := anim! !

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
incrementStep
	nbCycles isZero ifTrue: [ ^ self ].
	nbCycles := nbCycles - 1.
	animation value! !

!ROBeginingAnimation methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	nbCycles := 0.! !

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
isOver
	^ nbCycles <= 0! !

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
nbCycles
	^ nbCycles
	! !

!ROBeginingAnimation methodsFor: 'accessing' stamp: ''!
nbCycles: integer
	nbCycles := integer! !

!ROBeginingAnimation methodsFor: 'actions' stamp: 'AlexandreBergel 4/30/2012 15:55'!
waitUntilDone
	[ self isOver ] whileFalse: [ self incrementStep ] ! !

!ROEvent class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/17/2012 20:19'!
new
	^ self basicNew initialize! !

!ROEvent methodsFor: 'accessing' stamp: ''!
element
	^ element! !

!ROEvent methodsFor: 'accessing' stamp: ''!
element: anObject
	element := anObject! !

!ROEvent methodsFor: 'testing' stamp: ''!
hasElement
	^ element notNil! !

!ROEvent methodsFor: 'initialize-release' stamp: 'AlexandreBergel 6/1/2012 18:47'!
initialize
	position := 0 @ 0.
	realPosition := 0 @ 0! !

!ROEvent methodsFor: 'accessing' stamp: ''!
position
	^ position! !

!ROEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 12:17'!
position: aPoint
	"Set the position of the even in the view.  The position does not necessary correspond to the position on the screen"
	position := aPoint
	! !

!ROEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 6/1/2012 18:45'!
realPosition
	^ realPosition! !

!ROEvent methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 12:19'!
realPosition: aPoint
	"aPoint corresponds to the position on the screen. This is useful to process later on"
	realPosition := aPoint! !

ROEvent subclass: #ROMouseClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROMouseClick subclass: #ROMouseLeftClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROMouseClick subclass: #ROMouseRightClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROMouseEnter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROMouseLeave
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROMouseMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #RORefreshNeeded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

ROEvent subclass: #ROViewChanged
	instanceVariableNames: 'newView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Event'!

!ROViewChanged methodsFor: 'accessing' stamp: ''!
newView 
	^ newView! !

!ROViewChanged methodsFor: 'accessing' stamp: ''!
newView: aView
	newView := aView! !

Announcer subclass: #ROAnnouncer
	instanceVariableNames: 'forwarding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAnnouncer methodsFor: 'announce' stamp: ''!
announce: event
	(self isForwarded: event) 
		ifTrue: [ self sendToParent: event ]
		ifFalse: [ super announce: event ].
! !

!ROAnnouncer methodsFor: 'forwarding' stamp: ''!
forward
	self forward: ROEvent! !

!ROAnnouncer methodsFor: 'forwarding' stamp: ''!
forward: anEventClass

	forwarding ifNil: [ forwarding := IdentitySet new ].
	forwarding add: anEventClass! !

!ROAnnouncer methodsFor: 'testing' stamp: ''!
isForwarded: anEventClass
	anEventClass isBehavior ifFalse: [ ^ self isForwarded: anEventClass class].
	 
	forwarding ifNil: [ ^ false ].
	^ forwarding anySatisfy: [ :c | (c == anEventClass) or: [ anEventClass inheritsFrom: c ]] ! !

!ROAnnouncer methodsFor: 'testing' stamp: ''!
isForwarder
	^ forwarding notNil and: [ forwarding notEmpty ]! !

!ROAnnouncer methodsFor: 'announce' stamp: ''!
sendToParent: event
	"Do nothing if an event class"
	event isBehavior ifTrue: [ ^ self ].
	
	event hasElement ifTrue: [ event element parentAnnounce: event ]! !

!BlockClosure methodsFor: '*roassal-core' stamp: ''!
roValue: valueOrArray
	self numArgs = 0 ifTrue: [ ^ self value ].  
	self numArgs = 1 ifTrue: [ ^ self value: valueOrArray ].
	
	"if I have more than 1 argument, then the valueOrArray is a collection"
	valueOrArray isCollection ifFalse: [ self error: 'A block with more than one argument can only be evaluated with a collection ' ].
	
	self numArgs = valueOrArray size ifTrue: [ ^ self valueWithArguments: valueOrArray ]. 
	
	self error: 'Incorrect number of arguments'

! !

!ClassDescription methodsFor: '*roassal-core' stamp: 'VanessaPena 5/11/2012 15:03'!
numberOfLinesOfCode 
	
	^ 5 + ((RONativeExampleUtility current getMethodsForClass: self)  inject: 0 into: [:sum :el | sum + el linesOfCode ])! !

!Object methodsFor: '*roassal-core' stamp: ''!
roValue: anArgument 
	^ self! !

Object subclass: #ROAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROAction class methodsFor: 'public' stamp: ''!
on: element
	self subclassResponsibility! !

ROAction subclass: #ROAdjustSizeOfNesting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROAdjustSizeOfNesting class methodsFor: 'public' stamp: 'AlexandreBergel 5/22/2012 00:45'!
on: element
	| rec topLeft border |
	self assert: [ element isKindOf: ROElement ].

	topLeft := element bounds topLeft.
	rec := element encompassingRectangle.
	element extent: (rec extent).
	element translateTo: rec topLeft.
	
	"Check if I was extended on the topLeft corner"
	element elementsDo: [ :el | 
		el translateWithoutUpdatingContainedElementsBy: (topLeft - rec topLeft) ].
! !

ROAction subclass: #ROGrow
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROGrow class methodsFor: 'public' stamp: ''!
on: element by: integer
	element setBounds: (element bounds extendBy: ((integer * 2) @ (integer * 2))).
	element translateBy: integer @ integer! !

ROAction subclass: #ROHighlightElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROHighlightElement class methodsFor: 'testing' stamp: 'AlexandreBergel 5/7/2012 12:01'!
isHighlighted: element
	^ (element shapesSelect: [:d | d color = Color blue ] ) notEmpty! !

!ROHighlightElement class methodsFor: 'public' stamp: 'AlexandreBergel 4/14/2012 18:41'!
on: element

	self on: element color: Color red! !

!ROHighlightElement class methodsFor: 'public' stamp: 'AlexandreBergel 5/7/2012 11:49'!
on: element color: aColor

	element forShape: ROBox do: [ :d | d borderColor: aColor ]. 
	element signalUpdate! !

ROAction subclass: #ROHighlightElements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROHighlightElements class methodsFor: 'public' stamp: ''!
on: elements
	elements do: [ :el | ROHighlightElement on: el ]! !

!ROHighlightElements class methodsFor: 'public' stamp: ''!
on: elements color: aColor
	elements do: [ :el | ROHighlightElement on: el color: aColor ]! !

ROAction subclass: #ROUnhighlightElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROUnhighlightElement class methodsFor: 'public' stamp: 'AlexandreBergel 5/22/2012 08:15'!
on: element
	"Not really good actually. We should remember the color before it was highligthed before setting it to black"
	
	element forShape: ROBox do: [ :d | d borderColor: Color black ]. 
	element signalUpdate ! !

ROAction subclass: #ROUnhighlightElements
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Actions'!

!ROUnhighlightElements class methodsFor: 'public' stamp: 'AlexandreBergel 4/14/2012 18:36'!
on: elements
	elements do: [ :el | ROUnhighlightElement on: el ]! !

Object subclass: #ROBenchmarks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Benchmarks'!

!ROBenchmarks methodsFor: 'benchmarks' stamp: ''!
interaction1
	"
	self new interaction1 
	920 AlexandreBergel 2/11/2012 17:02
	"
	| element |
	element := ROElement new.
	^ [20000 timesRepeat: [element @ RODraggable @ ROGrowable @ ROPopup]] timeToRun! !

!ROBenchmarks methodsFor: 'benchmarks' stamp: ''!
interaction2WithMenuActivable
	"
	self new interaction2WithMenuActivable 
	 793 AlexandreBergel 2/11/2012 17:04
	"
	| element |
	element := ROElement new.
	^ [100000 timesRepeat: [element @ ROMenuActivable ]] timeToRun! !

Object subclass: #RODummyNode
	instanceVariableNames: 'edge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RODummyNode class methodsFor: 'instance creation' stamp: 'AlexandreBergel 5/3/2012 19:18'!
on: anEdge slot: anIndex
	
	^(self new)
		edge: anEdge;
		slot: anIndex;
		yourself! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
edge
	
	^edge! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
edge: anEdge
	
	edge := anEdge! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
height
	
	^0! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/20/2012 19:15'!
position
	^ 0 @ 0! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/20/2012 19:16'!
signalUpdate
	"do nothing"! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
slot: anIndex
	! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/20/2012 19:16'!
translateBy: apoint
	"do nothing"! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
translateTo: aPoint
	
	"edge index: index point: aPoint"! !

!RODummyNode methodsFor: 'accessing' stamp: 'AlexandreBergel 5/3/2012 19:18'!
width
	
	^0! !

Object subclass: #ROExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Example'!

!ROExample commentStamp: '<historical>' prior: 0!
A ROExample contains a list of example of Roassal. It does not contains examples on the builder. !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 5/1/2012 17:21'!
animatable
	"
	self new animatable
	
	Click to make the element go to where you have clicked
	"

	| view el |
	view := ROView new.
	el := ROElement sprite.
	view add: el.
	view on: ROMouseLeftClick do: [ :event | 
		ROLinearMove new
			nbCycles: 180;
			for: el until: event position.
	].
	view open.
	
! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/22/2012 21:01'!
arrowedLine

	"
	self new arrowedLine
	"
	| view n1 n2|
	view := ROView new.
	n1 := ROElement sprite.
	n2 := ROElement sprite.
	n2 translateBy: 20@60.

	view add: n1; add: n2; add: (ROEdge arrowedLineFrom: n1 to: n2).
	view open! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 6/1/2012 15:00'!
choice
	"
	self new choice
	"

	| view circle grid options choice container elementsToLayout |
	view := ROView new.
	circle := ROButtonElement named: 'circle' do: [:e | ROCircleLayout on: elementsToLayout. view signalUpdate  ].

	grid := ROButtonElement named: 'grid' do:  [:e | ROGridLayout on: elementsToLayout. view signalUpdate  ].
	
	options := Array with: circle with: grid.

	choice := ROElement new.
	choice addAll: (ROHorizontalLineLayout on: options).
	
	container := ROElement new.
	container addAll: (ROCircleLayout on: (elementsToLayout := ROLabelElement spritesFor: (1 to: 20))).
	elementsToLayout do: [:l | l addShape: ROLabel].

	view addAll: (ROVerticalLineLayout on: (Array with: choice with: container)).
	view openInWindow.
	! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/7/2012 11:54'!
circle
	"
	self new circle
	"

	| view elements |
	view := ROView new.
	view addAll: ((elements := ROElement spritesFor: (1 to: 20)) do: [:n | n addShape: ROLabel]).
	ROCircleLayout on: elements.
	view openInWindow ! !

!ROExample methodsFor: 'colors' stamp: 'AlexandreBergel 4/27/2012 19:45'!
colors
	"
	self new colors
	"
	| view els |
	view := ROView new.
	els := ROElement forCollection: (1 to: 20). 
	els with: (Color red mix: Color green shades: 20) do: [:el :c | (el size: 20) + (ROCircle color: c )].
	view addAll: els.
	ROCircleLayout new scaleBy: 4; on: els.
	view open.! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:54'!
drawCircle: view x: x radius: radius level: level
	| tt |
	tt := 126 * level / 4.
	view  add: ((ROElement new center: x asInteger @100 radius: radius asInteger )
						addShape: (ROCircle new color: (Color gray256: tt) )).
	(level > 1) ifTrue: 
		[
			self drawCircle: view x: (x - (radius / 2)) radius: radius / 2 level: level - 1.
			self drawCircle: view x: (x + (radius / 2)) radius: radius / 2 level: level - 1.
		]
! !

!ROExample methodsFor: 'interaction' stamp: ''!
expandableNodes

	"
	ROExample new expandableNodes
	"
	
	| view initialNodes |
	view := ROView new.
	initialNodes := (ROLabelElement spritesFor: (Array with: Integer)) asOrderedCollection.
	initialNodes do: [:n |
		n + ROLabel.
		n @ (ROExpandChildrenOnClick newCalculatingChildrenWith: [:aClass | aClass subclasses])].
	view addAll: initialNodes.
	ROTreeLayout new 
		translator: (ROSmoothLayoutTranslator new);
		applyOn: initialNodes.
	view @RODraggable @ RODraggableWithVelocity.
	view open! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/7/2012 11:54'!
grid
	"
	self new grid
	"

	| view elements |
	view := ROView new.
	view addAll: ((elements := ROElement spritesFor: (1 to: 20)) do: [:n | n addShape: ROLabel]).
	ROGridLayout on: elements.
	view openInWindow ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 5/7/2012 11:54'!
growableAndDraggableNode

	"
	self new growableAndDraggableNode
	"
	| view greenNode blueNode |
	view := ROView new.
	greenNode := ROElement on: 'green node'.
	greenNode addShape: (ROBox new color: Color green).
	greenNode setBounds: (5 @ 10 corner: (180 @ 170)).
	greenNode addInteraction: RODraggable.
	greenNode addInteraction: ROGrowable.

	blueNode := ROElement on: 'blue node'.
	blueNode addShape: (ROBox new color: Color blue).
	blueNode setBounds: (5 @ 10 corner: (180 @ 170)).
	blueNode translateBy: 50@30.
	blueNode addInteraction: RODraggable.
	blueNode addInteraction: ROGrowable.

	view add: greenNode; add: blueNode.
	view openInWindow ! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 5/22/2012 21:01'!
innerNodeAndZoom


	"
	self new innerNodeAndZoom
	"
	| view els |
	view := ROView new.
	els := ROElement forCollection: (1 to: 200).
	els do: [:spr |
		| innerNodes |
		spr extent: 50@50. 
		spr + ROBorder red.
		spr @ ROZoomOnClick @ RODraggable.
		
		innerNodes := ROElement forCollection: (1 to: 10).
		innerNodes do: [:s | s + ROBox green @ RODraggable ].
		spr addAll: (ROGridLayout on: innerNodes).
		].
	view addAll: els.
	view @ RODraggable.
	ROGridLayout on: els.
	view open.
	! !

!ROExample methodsFor: 'basic' stamp: ''!
label

	"
	self new label
	"
	
	| view |
	view := ROView new.
	view add: (ROLabelElement on: 'hello world').
	view openInWindow .
	! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 4/27/2012 17:51'!
labelWithCRCharacter

	"
	self new labelWithCRCharacter
	"
	
	| view |
	view := ROView new.
	view add: (ROLabelElement on: 
'hello 
world').
	view openInWindow .
	! !

!ROExample methodsFor: 'software' stamp: 'AlexandreBergel 5/22/2012 21:01'!
latentSemanticIndexing
	"
	self new latentSemanticIndexing
	"

	| documentsToProcess matrix words v elements view tIndexing elementsGraphical nativeUtil|
	documentsToProcess := OrderedCollection new.
	nativeUtil := RONativeExampleUtility current.
	ROElement withAllSubclasses do: [ :cls | documentsToProcess addAll: ((nativeUtil getMethodsForClass: cls) collect: #getSource) ].
	
	"Matrix is a dictionary of dictionaries. The outter key is a word of the documents. The value is a dictionary is a method source code. In this dictionary of method source code, the value is the number of occurence of the word in the source code.
    | w1 | w2 | w3 | w4|
s0| 
s1|
s2|

(w1, s0) occurence of the word w1 in the source code s0.
...
	"
	matrix := Dictionary new.
	documentsToProcess do: [ :source | 
		words := nativeUtil substringsFor: source .
		words do: [ :w |  
			matrix at: w ifAbsentPut: [ Dictionary new ].
			v := (matrix at: w) at: source ifAbsentPut: [ 0 ].
			(matrix at: w) at: source put: (v + 1) ] ].
	elements := OrderedCollection new.
	matrix associationsDo: [ :assoc|
		assoc value associationsDo: [ :assoc2|
			elements add: (Array 
							with: assoc key 
							with: (documentsToProcess indexOf: assoc2 key) 
							with: assoc2 value) ] ].

	tIndexing := (elements collect: #first) asSet asSortedCollection.
	elements := elements collect: [ :tripple |
			Array with: (tIndexing indexOf: tripple first) with: tripple second with: tripple third  ].
	

	"We build the view"	
	view := ROView new backgroundColor: Color black.
	elementsGraphical := ROElement forCollection: elements.
	elementsGraphical do: [:el | el 
						addShape: (ROCircle green);
						
						size: (el model third) ].
						
	view addAll: elementsGraphical.
	ROScatterplotLayout new 
		x: #first ; y: #second;
		applyOn: elementsGraphical.
	

	view 
		on: ROMouseLeftClick
		do: [ :event | 
			ROZoomInMove new on: view ].
	view 
		on: ROMouseRightClick
		do: [ :event | 
			ROZoomOutMove new on: view ].
		
	view @ RODraggable @ RODraggableWithVelocity.
	view open.! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 5/7/2012 11:54'!
leftAndRightClick
	" 
	self new leftAndRightClick
	"

	| counter view add sub els |
	els := OrderedCollection new.
	view := ROView new.
	
	add := ROElement sprite 
				addShape: (ROLabel new text: '+ / --');
				addShape: (ROBorder yellow).

	add on: ROMouseLeftClick do: [ :ev | 
		| el |
		el := ROElement sprite translateTo: (200 atRandom @ 200 atRandom ).
		els add: el.
		view add: el.
		view signalUpdate ].

	add on: ROMouseRightClick do: [ :ev | 
		| el |
		els ifNotEmpty: [
			view remove: els removeLast.
			view signalUpdate ] ].

	view add: add.
	view openInWindow  ! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 4/17/2012 17:10'!
lines

	"
	self new lines
	"
	
	| view node1 node2 edge |
	view := ROView new.
	node1 := ROLabelElement on: 'node1'. 
	node2 := ROLabelElement on: 'node2'.
	node1 @ RODraggable.
	node2 @ RODraggable.
	edge := ROEdge lineFrom: node1 to: node2.
	edge + (ROLine red).
	view add: edge; add: node1; add: node2.
	ROHorizontalLineLayout on: (Array with: node1 with: node2).
	view open! !

!ROExample methodsFor: 'software' stamp: ''!
memoryProfiling
	"
	self new memoryProfiling
	"
	"| spaceItems builder |
	spaceItems := SpaceTally new spaceTally: (Array with: ByteString with: Process with: RPackage with: Bitmap).
	
	builder := ROMondrianViewBuilder new.
	builder shape rectangle logWidth: #instanceCount; logHeight: #spaceForInstances.
	builder nodes: (spaceItems asSorted: #spaceForInstances).
	builder open	.
	"! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 6/4/2012 23:49'!
motion

	"
	self new motion
	"
	|view sprs |
	view := ROView new.
	sprs := (ROElement forCollection: (1 to: 20)).
	sprs do: [:s | 
		s extent: 20@20.
		s + ROCircle blue.
		s @ RODraggable.
		s @ RODraggableWithVelocity ].
	view addAll: sprs.
	view open.
	
	sprs do: [ :spr | ROMotionMove new for: spr initialSpeed: 60 atRandom @ 60 atRandom ]
	! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 4/17/2012 17:08'!
nesting
	"
	self new nesting
	"

	| view innerNode outterNode |
	view := ROView new.
	
	innerNode := ROElement new 
					extent: 40@30; 
					+ (ROBox new color: Color green);
					@ RODraggable.
	
	outterNode := 
		ROElement new 
			addInteraction: RODraggable;
			extent: 190@190;
			translateBy: 20@20;
			+ (ROBorder new color: Color red).

	view add: outterNode.
	outterNode add: innerNode.	
	
	view openInWindow.
	! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 5/7/2012 11:54'!
nesting2
	"
	self new nesting2
	"

	| view nodes |
	view := ROView new.
	view add: (ROElement sprite
				addAll: (nodes := ROElement spritesFor: (1 to: 20))).
	nodes do: [:n | n addShape: ROLabel].
	ROCircleLayout on: nodes. 
	view openInWindow.
	! !

!ROExample methodsFor: 'nesting' stamp: 'AlexandreBergel 5/22/2012 21:01'!
nesting3
	"
	self new nesting3
	"
	
	| view elements edges outterElement |
	view := ROView new.
		
	elements := ROElement spritesFor: (1 to: 5).

	outterElement := ROElement new.
	outterElement addAll: elements.
	outterElement addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).

	ROTreeLayout on: elements edges: edges.

	view add: outterElement.
	
	view open.! !

!ROExample methodsFor: 'interaction' stamp: ''!
popup

	"
	self new popup
	"
	
	| view |
	view := ROView new.
	view add: ((ROElement spriteOn: 'world')
				+ (ROLabel text: 'hello')
				@ (ROPopup)).
	view open.! !

!ROExample methodsFor: 'interaction' stamp: ''!
popupView

	"
	self new popupView 
	"

	| element view popupView |
	
	popupView := ROView new.
	popupView add: ((ROElement new extent: 50@60)+ (ROBox new color: Color blue)).
	
	view := ROView new.
	element := ROElement sprite.
	element @ (ROPopupView new view: popupView).
	view add: element.
	view open! !

!ROExample methodsFor: 'software' stamp: 'AlexandreBergel 4/19/2012 10:23'!
punchChart
	"inspired from http://raphaeljs.com/github/dots.html
	self new punchChart
	"

	| view classes metrics maxMetrics rx ry elements initialX initialY spaceX spaceY spaceYFromAxis spaceXFromAxis |
	"Gathering the data"
	classes := OrderedCollection new.
	classes add: Object; add: Behavior; add: Metaclass; add: Collection; add: OrderedCollection.
	metrics :=  #(#numberOfMethods #numberOfVariables #numberOfSubclasses).
	
	"Visualzing the data"
	maxMetrics := metrics collect: [ :m | classes inject: 0 into: [:max :el | max max: (m roValue: el) ] ].
	initialX := 30.
	initialY := 60.
	spaceX := 100.
	spaceY := 30.
	spaceYFromAxis := 20.
	spaceXFromAxis := 20.
	rx := initialX.
	ry := initialY.
	elements := OrderedCollection new.
	view := ROView new.
	classes do: [:cls | 
		ry := initialY.
		rx := rx + spaceX.
		
		metrics with: maxMetrics do: [ :m :mMax |
						| v |
						ry := ry + spaceX.
						v := m roValue: cls.
						elements add: 
							((ROElement on: cls)
							
								translateTo: rx @ ry;
								+ (ROCircle color: ((Color green mix: Color red shades: 30) at: (v max: mMax in: (1 to: 30))));
								@ (ROPopup text: v printString);
								 radius: ((m roValue: cls) max: mMax in: (5 to: 10))) ].
		ry := ry + spaceYFromAxis.
		elements add: ((ROLabelElement on: cls name) center: rx @ ry). ].
	
	ry := initialY.
	rx := rx + spaceX.
	rx := rx + spaceXFromAxis.
	metrics do: [ :m | 
		ry := ry + spaceX.
		elements add: ((ROLabelElement on: m) center: rx @ ry) ].
				
	view addAll: elements.
	view open! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:54'!
recursionProcessing
	"
	self new recursionProcessing
	"
	| view b |
	view := ROView new.

	b := [:x :radius :level | 
		| tt |
		tt := 126 * level / 4.0.
		view  add: ((ROElement new center: x@100 radius: radius)
							addShape: (ROCircle new color: (Color gray256: tt) )).
		(level > 1) ifTrue: 
			[
				b value: (x - (radius / 2)) value: radius / 2 value: (level - 1).
				b value: (x + (radius / 2)) value: radius / 2 value: (level - 1).
			]
	].
	b value: 126 value: 170 value: 6.
	view openInWindow ! !

!ROExample methodsFor: 'basic' stamp: 'AlexandreBergel 4/17/2012 17:14'!
recursionProcessing2
	"
	self new recursionProcessing2
	"
	| view b |
	view := ROView new.

	self drawCircle: view x: 126 radius: 170 level: 6.
	view open
! !

!ROExample methodsFor: 'interaction' stamp: ''!
resizableCircle
	"
	self new resizableCircle
	"

	| view circles colors |
	view := ROView new.
	colors := Color wheel: 6 alpha: 0.7.
 
	circles := (1 to: 6) with: colors collect: [:i :c | 
		ROElement new
			@ RODraggable;
			+ (ROCircle color: c);
			translateTo: (i * 60) @ (i \\ 3 * 50 + 50);
			extent: 50@50.
	].
	view on: ROMouseMove do: [:event | 
		circles do: [:c | | t |
			t := ((c bounds center - event position ) r / 2) max: 40.
			c size: t ].
		view signalUpdate  ].
	
	view addAll: circles.
	view open.

! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/7/2012 11:54'!
scatterPlot
	"
	self new scatterPlot
	"

	| view elements |
	view := ROView new.
	elements := ROElement forCollection:  #(#(1 2) #(100 50) #(60 20)).
	elements do: [:el | el 
						addShape: (ROCircle);
						size: 30 ].
	view addAll: elements.
	ROScatterplotLayout new 
		x: #first ; y: #second;
		applyOn: elements.
	view open.! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 6/5/2012 23:23'!
scrollbar

	| view els stack |
	view := ROView new.
	view add: ROElement sprite.

	els := ROElement spritesFor: (1 to: 500).
	els do: [ :el | el + ROLabel @ ROPopup ].
	view addAll: (ROGridLayout  on: els).
	view @ RODraggable .

	stack := ROViewStack new.
	stack addView: view.
	stack @ ROScrollbable.
	stack open.! !

!ROExample methodsFor: 'nesting' stamp: ''!
stack
	"
	self new stack
	"
	
	| view1 label1 stack view2 label2 view3 label3 |
	view1 := ROView new.
	label1 := (ROLabelElement on: 'view 2') @ ROLightlyHighlightable.
	label1 on: ROMouseClick do: [ :event | stack replaceFirstBy: view2 ].
	view1 add: label1.
	view1 addAll: (ROGridLayout on: (ROElement spritesFor: (1 to: 20))).
	
	view2 := ROView new.
	label2 := (ROLabelElement on: 'view 3') @ ROLightlyHighlightable.
	label2 on: ROMouseClick do: [ :event | stack replaceFirstBy: view3 ].
	view2 add: label2.
	view2 addAll: (ROCircleLayout on: (ROElement spritesFor: (1 to: 20))).

	view3 := ROView new.
	label3 := (ROLabelElement on: 'view 1') @ ROLightlyHighlightable.
	label3 on: ROMouseClick do: [ :event | stack replaceFirstBy: view1 ].
	view3 add: label3.
	view3 addAll: (ROHorizontalLineLayout on: (ROElement spritesFor: (1 to: 20))).

	stack := ROViewStack new addFirst: view1.
	stack open! !

!ROExample methodsFor: 'nesting' stamp: ''!
stack2
	"
	self new stack2
	"
	
	| view1 view2 stack label |
	view1 := ROView new.
	view1 add: ((label := ROLabelElement on: 'subview on') @ ROLightlyHighlightable;
					on: ROMouseClick do: [ :e | 
							label model: 'subview off'. 
							stack addFirst: view2 ] ).
					
	view1 add: (ROElement sprite 
					extent: 100@100;
					translateTo: 100@100 ).

	view2 := ROView new.
	view2 add: (ROElement new 
					@ RODraggable
					+ (ROBox green);
					translateTo: 50@50;
					extent: 100@100).

	stack := ROViewStack new addFirst: view1.
	stack open! !

!ROExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/22/2012 21:01'!
treeLayout 
	"
	self new treeLayout
	"
	
	| view elements edges |
	view := ROView new.
	elements := ROElement spritesFor: (1 to: 5).
	view addAll: elements.
	view addAll: (edges := ROEdge linesFor: (Array with: elements first -> elements second with: elements second -> elements fifth with: elements second -> elements third )).
	
	ROTreeLayout on: elements.

	view open.! !

!ROExample methodsFor: 'interaction' stamp: 'AlexandreBergel 6/4/2012 23:47'!
zooming

	"
	self new zooming
	"
	| view els classes stack |
	"We gather what we want to visualize"
	classes := Smalltalk globals allClasses select: [ :c | c name beginsWith: 'RO' ].
	
	"We build the visualization"
	view := ROView new.
	els := ROElement forCollection: classes.
	els do: [:spr |
		spr extent: 50@50. 
		spr + ROBorder red.
		spr @ ROZoomOnClick @ RODraggable 
		].
	view addAll: els.
	view @ RODraggable.
	ROGridLayout on: els.
	
	stack := ROViewStack new.
	stack addView: view.
	stack open.
	! !

Object subclass: #ROLayoutTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROLayoutTranslator class
	instanceVariableNames: 'defaultTranslator'!

!ROLayoutTranslator commentStamp: 'AlexandreBergel 11/28/2011 10:48' prior: 0!
ROLayoutTranslator is used by the layout to translate object. Each layout can be parametrized with a translator to produce a visual effect.

I am an abstract class!

ROLayoutTranslator class
	instanceVariableNames: 'defaultTranslator'!

ROLayoutTranslator subclass: #ROAbsorbLayoutTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbsorbLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	"Does not perform the translation. Used in testing essentially"! !

ROLayoutTranslator subclass: #RODirectLayoutTranslator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RODirectLayoutTranslator class methodsFor: 'testing' stamp: ''!
isDefault
	^ true! !

!RODirectLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	element translateTo: newPosition! !

!ROLayoutTranslator class methodsFor: 'accessing' stamp: ''!
default
	"Return the default translator, the one used in the layouts"

	defaultTranslator ifNotNil: [ ^ defaultTranslator ].
	^ defaultTranslator := self defaultClass new! !

!ROLayoutTranslator class methodsFor: 'accessing' stamp: ''!
defaultClass
	^ self withAllSubclasses detect: #isDefault! !

!ROLayoutTranslator class methodsFor: 'testing' stamp: ''!
isDefault
	^ false! !

!ROLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	self subclassResponsibility ! !

ROLayoutTranslator subclass: #ROSmoothLayoutTranslator
	instanceVariableNames: 'move'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROSmoothLayoutTranslator methodsFor: 'testing' stamp: ''!
hasCompleted
	"Return true if all the translation has completed"
	^ move hasCompleted! !

!ROSmoothLayoutTranslator methodsFor: 'hook' stamp: ''!
translate: element to: newPosition
	move := ROLinearMove new
			nbCycles: 180;
			for: element until: newPosition! !

Object subclass: #ROMondrianExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Example'!

!ROMondrianExample commentStamp: '<historical>' prior: 0!
Example for the Mondrian builder!

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 09:01'!
bottomFlowLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view bottomFlowLayout.
	 ! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/20/2012 19:19'!
chooseLayoutOn: view

	(ROGridLayout on: (
	 ((OrderedCollection new) 
		add: ROTreeLayout; 
		add: ROGridLayout; 
		add: ROForceBasedLayout; 
		add: ROCircleLayout; 
		add: ROVerticalLineLayout; 
		add: ROHorizontalLineLayout; 
		add: ROSugiyamaLayout; 
		add: ROBottomFlowLayout; 
		add: ROFlowLayout; 
		add: RORadialTreeLayout; 
		add: ROScatterplotLayout;
		yourself) collect: [ :layoutClass | 
			| button |
			button := ((ROLabelElement on: layoutClass name) @ ROLightlyHighlightable + ROBorder).
			button on: ROMouseLeftClick do: [ :event | 
				layoutClass new 
					translator: (ROSmoothLayoutTranslator new);
					applyOn: (view container elementsFromModels: (1 to: 5)) ].
			view container add: button.
			button ])) do: [ :button | button translateBy: 0 @ 380 ].

	
	"We start with a very simple graph"
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edgesFromAssociations:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself).
	"We use circle layout as default layout"
	view circleLayout.
	
	! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 09:02'!
circleLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view circleLayout.
	 ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:28'!
clickToFocus
	"
	self new clickToFocus
	"
	
	| builder | 
	builder := ROMondrianViewBuilder titled: 'Finding nodes'.
	self clickToFocusOn: builder.	
	builder open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/6/2012 10:33'!
clickToFocusOn: view
		
	view interaction 
		on: ROMouseClick do:  [ :event |  
			ROFocusView new on: event element view: view container ].
	view shape rectangle size: 30.
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:49'!
command

	"
	self new command
	
	An example that shows the commands that can be defined on the builder. Useful to add menus.
	"

	| view |
	view := ROMondrianViewBuilder new.
	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.
	
	view addMenu: 'Inspect stack' callBack: [ :stack | stack inspect.  ].

	view addMenu: '+Node Background' callBack: [ :stack | 
		stack firstView add: (ROElement sprite translateTo: 200 atRandom @ 200 atRandom).
		stack signalUpdate ].

	view addMenu: '+Node Foreground' callBack: [ :stack | 
		| el |
		el := ROElement sprite translateTo: 200 atRandom @ 200 atRandom.
		(el getShape: ROBorder) color: Color blue. 
		stack add:  el.
		stack signalUpdate ].
	
	view addMenu: 'Zoom in' callBack: [ :stack | ROZoomInMove new on: stack firstView ].
	view addMenu: 'Zoom out' callBack: [ :stack | ROZoomOutMove new on: stack firstView ].

	view open.! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 09:01'!
flowLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view flowLayout.
	 ! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/17/2012 20:36'!
forceBasedLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view forceBasedLayout.
	 ! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/18/2012 08:49'!
gridLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view gridLayout.
	 ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:13'!
highlight
	"
	self new highlight
	"
	| view |

	view := ROMondrianViewBuilder new.
	self highlightOn: view.
	view open. ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:29'!
highlightInnerNodes
	" 
	self new highlightInnerNodes
	"

	| view |
	view := ROMondrianViewBuilder new.
	self highlightInnerNodesOn: view.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/3/2012 09:38'!
highlightInnerNodesOn: view

	view nodes: (1 to: 5) forEach: [:each |    
		view interaction highlightNodesWhenOver: [ :node | Array with: node ].    
		view shape rectangle withText; size: 20.    
		view nodes: (1 to: each).    
		view gridLayout ].
	! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/3/2012 09:38'!
highlightOn: view
	view interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := view container elementsFromModels: n element model allSubclasses.
		ROHighlighter new on: nodes in: view container  ].

	view interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := view container elementsFromModels: n element model allSubclasses.
		ROHighlighter new
			color: Color black;
			on: nodes in: view container  ].
	
	(view nodes: (Collection withAllSubclasses)).
	view edgesFrom: #superclass.
	
	view treeLayout. ! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 4/18/2012 16:35'!
highlightSeveralNodes
	"
	self new highlightSeveralNodes
	"

	| view nodes |
	view := ROMondrianViewBuilder new.
	view interaction highlightWhenOver: [:v | ((Array new: 4) at: 1 put: v - 1; at: 2 put: v + 1; at: 3 put: v + 4; at: 4 put: v - 4; yourself)  ].
	view shape rectangle 
		width: 40;
		height: 30;
		borderColor: Color black; borderWidth: 2.
	nodes := view nodes: (1 to: 16).
	view gridLayout gapSize: 2.
	
	
	view open.
	! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/2/2012 18:30'!
labeledRectangle
	"
	self new labeledRectangle
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	self labeledRectangleOn: view.
	view open! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/3/2012 09:38'!
labeledRectangleOn: view
	
	view shape rectangle withText.
	view node: 'With rectangle'.
	
	view shape label.
	view node: 'Without rectangle'.
! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/22/2012 17:53'!
lineWidthOn: view

	view shape rectangle size: 50.
	view nodes: #( 1 2 ).
	view shape line width: 4.
	view edgeFromAssociation: 1 -> 2.
	! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/2/2012 18:31'!
lines
	"
	self new lines
	"
	| view |
	view := ROMondrianViewBuilder new.
	self linesOn: view.
	view open! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/3/2012 09:38'!
linesOn: view
	view shape label.
	view nodes: #(1 2 3 4 5 6 7 8 9 10).
	view edges: #(1 2 3 4 5 6 7 8 9 10) from: #yourself toAll: (#(1 2 3 4 5 6 7 8 9 10) select: #odd).
	view circleLayout.! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/22/2012 08:27'!
makingInvisibleEdgesOn: view

	"The mondrian builder adds a shape per default. But this can be easily bypassed by using the low level facilities of Roassal"
	view nodes: Collection withAllSubclasses.
	( view edgesFrom: #superclass) do: [ :edge | edge - ROEdge ].
	view treeLayout.
	! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:31'!
menuOnNodes

	"
	self new menuOnNodes
	Right click on a node gives a menu
	"

	| view |
	
	view := ROMondrianViewBuilder new.
	self menuOnNodesOn: view.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/3/2012 08:41'!
menuOnNodesOn: view
	view shape rectangle size: 15.
	view interaction 
		item: 'inspect element' action: #inspect;
		item: 'browse element class' action: #browse.
	view nodes: (1 to: 5).! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/3/2012 19:21'!
methodComplexity

	"
	self new methodComplexity 
	"
	| view d connectedMethods disconnectedMethods methodShape |
	view := ROMondrianViewBuilder titled: 'Method Complexity'.
	self methodComplexityOn: view.
	view open! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/3/2012 19:15'!
methodComplexityFor: classes on: view

	| d connectedMethods disconnectedMethods methodShape |
	
	
	view nodes: classes forEach: [ :cls |
		d := IdentityDictionary new.
		cls methods do: [ :cm | d at: cm selector put: cm messages ].
		d copy keysAndValuesDo: [ :key :messages | d at: key put: (messages intersection: d keys) ].
		
		connectedMethods := d keys select: [ :k | (d at: k) notEmpty ].
		disconnectedMethods := d keys select: [ :k | (d at: k) isEmpty ].
	
		"Connected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: connectedMethods.
			view edges: connectedMethods from: #yourself toAll: [ :cm | d at: cm ].
			view sugiyamaLayout. 
		].
	
		"Disconnected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: disconnectedMethods.
			view gridLayout.
		].

	].
	view edgesFrom: #superclass.
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'VanessaPena 5/11/2012 14:54'!
methodComplexityOn: view


	view nodes: ((Object allSubclasses select: [ :cls | cls name beginsWith: 'RO' ])) forEach: [ :cls |
		| d connectedMethods disconnectedMethods methodShape nativeUtil |
		d := IdentityDictionary new.
		nativeUtil := RONativeExampleUtility current .
		(nativeUtil getMethodsForClass: cls) do: [ :cm | d at: cm selector put: cm messages ].
		d copy keysAndValuesDo: [ :key :messages | d at: key put: (messages intersection: d keys) ].
		
		connectedMethods := d keys select: [ :k | (d at: k) notEmpty ].
		disconnectedMethods := d keys select: [ :k | (d at: k) isEmpty ].
	
		"Connected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: connectedMethods.
			view edges: connectedMethods from: #yourself toAll: [ :cm | d at: cm ].
			view sugiyamaLayout. 
		].
	
		"Disconnected methods"
		view shape rectangle withoutBorder.
		view node: cls forIt: [
			view shape rectangle size: [ :sym | (cls >> sym) getSource lines size ].
			view interaction popupText: [ :sym | (cls >> sym) getSource ].
			view nodes: disconnectedMethods.
			view gridLayout.
		].

	].
	view edgesFrom: #superclass.
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:34'!
multilineLabel
	"
	self new multilineLabel
	"

	| view |
	view := ROMondrianViewBuilder new.
	self multilineLabelOn: view.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:34'!
multilineLabelOn: view
	view shape label text: [:m | 'line1
	  line2
		line3    ']; color: Color blue.
	view node: $a.! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:35'!
nodraggable 
	"
	self new nodraggable
	"

	| view |
	view := ROMondrianViewBuilder new.
	self nodraggableOn: view.
	
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/2/2012 18:35'!
nodraggableOn: view
	view interaction nodraggable.
	view shape label.
	view node: 'Cannot be dragged'.
	
	view shape label.
	view node: 'Can be dragged'.! !

!ROMondrianExample methodsFor: 'software visualization' stamp: ''!
polymetricViewWithMethods
	"
	self new polymetricViewWithMethods
	"

	| view classes elements  edge nodes |
	"Gathering the data"
	classes := ROTest withAllSubclasses.
	
	"Visualzing the data"
	view := ROMondrianViewBuilder new.
	view shape rectangle 
		width: #numberOfVariables; 
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within: classes.
	nodes := view nodes: classes.
	nodes do: [:n | n @ ROZoomOnClick ].
	
	view edgesFrom: #superclass.
	view treeLayout.
	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 4/30/2012 17:29'!
popupAndNoPopup
	"
	self new popupAndNoPopup
	"
	
	| view |
	view := ROMondrianViewBuilder titled: 'Popup and No popup'.
	view interaction noPopup.
	view shape label.
	view node: 'I have _no_ popup'.
	
	view shape label.
	view node: 'I have a popup'.

	view interaction noPopup.
	view shape label.
	view node: 'I have _no_ popup'.

	view open! !

!ROMondrianExample methodsFor: 'interations' stamp: ''!
popupView
	"
	self new popupView
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	view shape label.
	view interaction popupView: [ :entity :myView | 
		myView nodes: entity withAllSuperclasses.
		myView nodes: entity allSubclasses.
		myView edgesFrom: #superclass.
		myView treeLayout.
	].
	(view nodes: (Array with: ROEvent with: Collection)).
	view open
! !

!ROMondrianExample methodsFor: 'interations' stamp: 'AlexandreBergel 5/3/2012 09:43'!
popupViewOn: view

	view shape label.
	view interaction popupView: [ :entity :myView | 
		myView nodes: entity withAllSuperclasses.
		myView nodes: entity allSubclasses.
		myView edgesFrom: #superclass.
		myView treeLayout.
	].
	(view nodes: (Array with: ROEvent with: Collection)).
	
! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/21/2012 23:42'!
scatterLayoutOn: view

	view node: 'scatter layout' forIt: [
		view nodes: #((10 5) (20 50) (2 4) (60 20)).
		view layout: (ROScatterplotLayout new
						upSideDown;
						scaleFactor: 2;
						x: #first;
						y: #second) ].! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:16'!
simpleHierarchy
	"
	self new simpleHierarchy 
	"
	
	| view |
	view := ROMondrianViewBuilder new.
	self simpleHierarchyOn: view.
	view open! !

!ROMondrianExample methodsFor: 'basic' stamp: 'AlexandreBergel 5/7/2012 11:15'!
simpleHierarchyOn: view
	
	view shape rectangle size: 20.
	view nodes: (1 to: 20).
	view shape line.
	view edgesFrom: [ :i | i \\ 3 ].
	view treeLayout.
	! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/4/2012 09:27'!
step1CreatingNodesOn: view

	"A mondrian view is composed of nodes and egdes. 
	In this first step, we will have the simplest visualization possible. 
	A list of nodes representing each subclass of the class Collection."
	view nodes: Collection withAllSubclasses.
	"Since no shape is defined, each node is represented as a small white square, with a black border.
	The size of the square is 5 pixels wide.
	
	No layout is specified, therefore the horizontal line layout is used per default.
	All the nodes are lined up horizontally.
	
	Wave the mouse over a node, a popup will tell you which node you are pointing to.
	You can individually drag and drop each node.
	The whole view may be move around by dragging and dropping where there is no node, in the background."! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/4/2012 10:23'!
step2AddingEdgesOn: view

	"We will now add edges to represent the superclass hierarchy of the collection classes."
	view nodes: Collection withAllSubclasses.
	
	"The message #edgesFrom: tells Roassal to draw edges between each node. The message #superclass is sent to each nodes (i.e., each subclass of Collection). A line is draw for each couple (subclassOfCollection -> subclassOfCollection superclass)."
	view edgesFrom: #superclass.
	
	"We need to provide a layout to structure the visualization. A tree layout is appropriate in Smalltalk since a class has only one superclass."
	view treeLayout.
	"The tree layout places a superclass aboves its subclasses.
	
	The Easel offers a number of actions. Zoom in, zoom out and find objects. Really handy and you have many nodes and you are looking for a specific node.
	"! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/12/2012 21:56'!
step3DefiningShapeOn: view

	"Up to now, all the boxes have the same graphical aspect (i.e., a 5 pixels white square). 
	Each node may particularize its shape depending on the object that is rendered."
	
	"We will now define a new shape in which the height represents the amount of mehtods the class has,
	Its width is the amount of variables the class defines."
	view shape rectangle 
		width: [ :cls | cls instVarNames size ]; 
		height: [ :cls | cls methods size ].
	view nodes: Collection withAllSubclasses.
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:01'!
step4ColoringShapeOn: view

	"Shapes may be colored in many different ways. "
	
	"Let's paint with a blue border the classes for which the word Array appear in their name.
	Classes with Hash in their name will have a green border."
	
	"Classes are painted in veryLightGray. Classes with more than 20 methods are in gray.
	 The one with more than 30 methods are in back"
	view shape rectangle 
		width: [ :cls | cls instVarNames size * 5 ]; 
		height: [ :cls | cls methods size ];
		if: [ :cls | '*Array*' match: cls name ] borderColor: Color blue;
		if: [ :cls | '*Hash*' match: cls name ] borderColor: Color green;
		
		fillColor: Color veryLightGray;
		if: [ :cls | cls methods size > 20 ] fillColor: Color gray;
		if: [ :cls | cls methods size > 30 ] fillColor: Color black.
		
		
	view nodes: Collection withAllSubclasses.
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:38'!
step5LinearFillColorOn: view

	"In the previous step, we have related the amount of methods a class may have with the darkness of its color:
	many methods is associated to black and few methods with light gray. In chromatography, the lightness (or darkness) of a color is called its 'value'.
	Relating a metric (e.g., the number of methods) with the color value is a common behavior that deserves its own facilities. "

	"In this example, we relate the number of lines of code a class has with its color value."
	view shape rectangle 
		width: [ :cls | cls instVarNames size * 5 ]; 
		height: [ :cls | cls methods size ];
		linearFillColor: #linesOfCode within: Collection withAllSubclasses.
	view nodes: Collection withAllSubclasses.
	
	view edgesFrom: #superclass.	
	view treeLayout.
	
	"linearFillColor: aBlock within: aCollection computes for each node a numerical value using aBlock and associates a gray value.
	The visualization we have obtained is well know in the field of software visualization. It is called 'System Complexity'. More description of this fantastic visualization may be found in the publication 'Polymetric Views -- A Lightweight Visual Approach to Reverse Engineering', TSE 29(9), 2003."
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:43'!
step6NestingNodesOn: view

	"Until now, the only relation between nodes that we have expressed is linking them with an edge. Another way to relate nodes is to nest them. A node acts as a view in which nodes and edges may be added."

	"Methods may be added within a class using nodes:forEach:"
	view nodes: Collection withAllSubclasses forEach: [ :aClass |
		view nodes: aClass methods.
	].
	
	view edgesFrom: #superclass.	
	view treeLayout.
! !

!ROMondrianExample methodsFor: 'tutorial' stamp: 'AlexandreBergel 5/13/2012 10:52'!
step7GridLayoutOn: view

	"Having a long horizontal list of methods is not that exciting. They can be ordered a little bit by using a grid layout"
	view nodes: Collection withAllSubclasses forEach: [ :aClass |
		view nodes: aClass methods.
		view gridLayout gapSize: 2.
	].
	
	view edgesFrom: #superclass.	
	view treeLayout.

	"The amount of space between each nodes may be specified using gapSize:. "! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 5/3/2012 09:46'!
systemComplexity
	"
	self new systemComplexity
	"

	| view elements  edge |	
		
	view := ROMondrianViewBuilder new.
	self systemComplexityOn: view.
	view open.
	^ view! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'AlexandreBergel 4/29/2012 10:29'!
systemComplexityFor: classes
	"
	self new systemComplexityFor: Morph withAllSubclasses
	"

	| view elements  edge |	
		
	view := ROMondrianViewBuilder new.
	view shape rectangle 
		width: #numberOfVariables; 
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within: classes.
		
	view interaction popupText: [ :cls | 
		cls name, String cr, 
		cls methods size printString, ' methods', String cr, 
		cls instVarNames size printString, ' variables', String cr,
		cls numberOfLinesOfCode printString, ' LOC' ].
	view interaction action: #browse.

	view nodes: classes.
	view edgesFrom: #superclass.
	view treeLayout.
	view open.
	^ view! !

!ROMondrianExample methodsFor: 'software visualization' stamp: 'VanessaPena 5/11/2012 15:03'!
systemComplexityOn: view
	view shape rectangle 
		width: #numberOfVariables; 
		height: #numberOfMethods;
		linearFillColor: #numberOfLinesOfCode within:  Collection withAllSubclasses.
		
	view interaction popupText: [ :cls | 
		cls name, (String with: Character cr), 
		cls methods size printString, ' methods', (String with: Character cr), 
		cls instVarNames size printString, ' variables', (String with: Character cr),
		cls numberOfLinesOfCode printString, ' LOC' ].
	view interaction action: #browse.

	view nodes: Collection withAllSubclasses.
	view edgesFrom: #superclass.
	view treeLayout.! !

!ROMondrianExample methodsFor: 'layouts' stamp: 'AlexandreBergel 5/17/2012 19:59'!
treeLayoutOn: view
	
	view shape rectangle size: 40.
	view nodes: (1 to: 5).
	view shape arrowedLine.
	view 
		edges:  ((OrderedCollection new) add: (1->2); add: (1->3); add: (1->5); add: (2->4); add: (4->1); yourself)
		from: #key 
		to: #value.
	view treeLayout.
	 ! !

Object subclass: #ROObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROObject subclass: #ROAbstractCanvas
	instanceVariableNames: 'camera extent canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractCanvas class methodsFor: 'public' stamp: 'AlexandreBergel 4/19/2012 12:18'!
canvas: canvas camera: camera
	^ self new canvas: canvas; camera: camera; yourself! !

!ROAbstractCanvas class methodsFor: 'configuration' stamp: 'AlexandreBergel 4/19/2012 12:17'!
defaultExtent
	^ 40 @ 30! !

!ROAbstractCanvas class methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:19'!
onCamera: camera
	"Return a new canvas with a created canvas"
	"Implementation example: 
		| form canvas |
		form := Form extent: camera realExtent depth: Display depth.
		canvas := FormCanvas on: form.
		^ self canvas: canvas camera: camera
	"
	self subclassResponsibility! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
camera
	^ camera! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
camera: aROCamera
	camera := aROCamera! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
canvas
	^ canvas! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
canvas: aCanvas
	canvas := aCanvas! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
drawString: aByteString at: aPoint 
	"Render a string at a given position. No specification about the font is given. Use the default then"
	"Implementation example:
		canvas drawString: aByteString at:  (self virtualToRealPoint: aPoint) font: nil color: Color black
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
drawString: aByteString at: aPoint color: color
	"Render a colored string at a given position. No specification about the font is given. Use the default then"
	"Implementation example:
			canvas drawString: aByteString at:  (self virtualToRealPoint: aPoint) font: nil color: color
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
drawString: aByteString at:  p font: f color: color
	"Render a colored string at a given position using a particular font."
	"Implementation example:
		canvas drawString: aByteString at:  (self virtualToRealPoint: p) font: f color: color
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'accessing' stamp: 'AlexandreBergel 4/19/2012 12:00'!
extent: aPoint
	extent := aPoint! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:06'!
fillOval: aRectangle color: aColor borderWidth: aSmallInteger borderColor: aColor4 
	"Render an oval"
	"Implementation example
		canvas
		fillOval: (self virtualToRealRectangle: aRectangle)  color: aColor borderWidth: aSmallInteger borderColor: aColor4 
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:07'!
fillRectangle: aRectangle color: fillColor 
	"Render a rectangle"
	"Implementation example
	
		canvas fillRectangle: (self virtualToRealRectangle: aRectangle) color: fillColor
	"
	
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:07'!
form
	"Return a bitmap"
	"Implementation example
		^ canvas form
	"
	self subclassResponsibility ! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:05'!
frameAndFillRectangle: aRectangle fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor 
	"Render a framed rectangle. Implementation example:

	canvas 
		frameAndFillRectangle: (self virtualToRealRectangle: aRectangle) fillColor: fillColor borderWidth: aSmallInteger borderColor: aColor.
	"
	
	self subclassResponsibility.! !

!ROAbstractCanvas methodsFor: 'initialize' stamp: 'AlexandreBergel 4/19/2012 12:01'!
initialize 
	super initialize.
	
	extent := self class defaultExtent.
	
	"Not sure about this. Maybe a Global Camera is wiser"
	camera := ROCamera new.
	! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:07'!
line: aPoint to: aPoint2 width: aSmallInteger color: aColor 
	"Draw a line between two points"
	"Implementation example
		canvas line: (self virtualToRealPoint: aPoint) to: (self virtualToRealPoint: aPoint2) width: aSmallInteger color: aColor.

	"
	self subclassResponsibility 
	


	! !

!ROAbstractCanvas methodsFor: 'convenient' stamp: 'AlexandreBergel 4/19/2012 12:07'!
paintBackground: color

	self 
		frameAndFillRectangle: (camera realToVirtualRectangle: (0@0 extent: extent)) 
		fillColor: color
		borderWidth: 0 
		borderColor: Color white.! !

!ROAbstractCanvas methodsFor: 'hooks' stamp: 'AlexandreBergel 4/19/2012 12:08'!
paintImage: aForm at: aPoint
	"Render a bitmap on screen"
	"Implementation example
		canvas paintImage: aForm at:  (self virtualToRealPoint: aPoint) 

	"
	self subclassResponsibility 
! !

!ROAbstractCanvas methodsFor: 'util' stamp: 'AlexandreBergel 4/19/2012 12:02'!
realToVirtualPoint: aPoint
	"Return a real point from a one expressed in the virtual coordinates"

	^ camera realToVirtualPoint: aPoint
! !

!ROAbstractCanvas methodsFor: 'util' stamp: 'AlexandreBergel 4/19/2012 12:02'!
realToVirtualRectangle: aRectangle
	"Return a rectangle with virtual coordinates from one expressed in the real coordinates"
	
	^ camera realToVirtualRectangle: aRectangle! !

!ROAbstractCanvas methodsFor: 'util' stamp: 'AlexandreBergel 6/2/2012 12:28'!
virtualToRealPoint: aPoint
	"Return a real point from a one expressed in the virtual coordinates"

	^ camera virtualToRealPoint: aPoint
! !

!ROAbstractCanvas methodsFor: 'util' stamp: 'AlexandreBergel 4/19/2012 12:01'!
virtualToRealRectangle: aRectangle
	"Return a rectangle with real coordinates from one expressed in the virtual coordinates"
	
	^ camera virtualToRealRectangle: aRectangle! !

ROObject subclass: #ROAbstractResizeStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROAbstractResizeStrategy class
	instanceVariableNames: 'instance'!

!ROAbstractResizeStrategy commentStamp: 'AlexandreBergel 3/2/2012 19:40' prior: 0!
This hierarchy defines how a parent should behave when a child is resized.!

ROAbstractResizeStrategy class
	instanceVariableNames: 'instance'!

!ROAbstractResizeStrategy class methodsFor: 'as yet unclassified' stamp: ''!
instance
	instance ifNil: [ instance := self new ].
	^ instance! !

!ROAbstractResizeStrategy methodsFor: 'action' stamp: ''!
on: childElement
	self subclassResponsibility ! !

ROAbstractResizeStrategy subclass: #ROExtensibleParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROExtensibleParent commentStamp: 'AlexandreBergel 3/2/2012 19:41' prior: 0!
The parent get expended!

!ROExtensibleParent methodsFor: 'action' stamp: 'AlexandreBergel 5/22/2012 00:33'!
on: element
	ROAdjustSizeOfNesting on: element! !

ROAbstractResizeStrategy subclass: #ROFixedSizedParent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROFixedSizedParent commentStamp: 'AlexandreBergel 3/2/2012 19:41' prior: 0!
The size of the parent is fixed. !

!ROFixedSizedParent methodsFor: 'action' stamp: 'AlexandreBergel 5/22/2012 00:33'!
on: element
	"We do nothing"! !

ROObject subclass: #ROAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

ROAttachPoint class
	instanceVariableNames: 'instance'!

ROAttachPoint class
	instanceVariableNames: 'instance'!

!ROAttachPoint class methodsFor: 'public - creation' stamp: ''!
instance
	instance ifNil: [ instance := self new ].
	^ instance! !

!ROAttachPoint methodsFor: 'public - hooks' stamp: ''!
endingPointOf: anEdge
	self subclassResponsibility! !

!ROAttachPoint methodsFor: 'public - hooks' stamp: ''!
startingPointOf: anEdge
	self subclassResponsibility! !

ROAttachPoint subclass: #ROCenteredAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROCenteredAttachPoint methodsFor: 'public - hooks' stamp: ''!
endingPointOf: anEdge
	^ (anEdge to positionRelativeTo: anEdge parent) + (anEdge to extent / 2) asIntegerPoint! !

!ROCenteredAttachPoint methodsFor: 'public - hooks' stamp: ''!
startingPointOf: anEdge
	^ (anEdge from positionRelativeTo: anEdge parent) + (anEdge from extent / 2) asIntegerPoint! !

ROAttachPoint subclass: #ROHorizontalAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROHorizontalAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 5/31/2012 15:19'!
endingPointOf: anEdge
	^ (anEdge to positionRelativeTo: anEdge parent) + (0 @ (anEdge to bounds height / 2) asInteger)! !

!ROHorizontalAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 5/31/2012 15:17'!
startingPointOf: anEdge
	^ (anEdge from positionRelativeTo: anEdge parent) + (anEdge from bounds width @ (anEdge from bounds height / 2) asInteger)
	! !

ROAttachPoint subclass: #ROShorterDistanceAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROShorterDistanceAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 6/3/2012 14:31'!
endingPointOf: anEdge
	| ps p dp t |
	ps := self fourToPointsOfEdge: anEdge.
	p := (anEdge from positionRelativeTo: anEdge parent) + (anEdge from width @  anEdge from height).
	
	"We get the list of dot products"
	dp := ps collect: [ :pp | 
		t := p - pp.
		Array with: (t dotProduct: t) with:  pp ].
	
	"We look for the shorter path and return the point"
	^ (dp inject: dp first into: [ :shorter :el | (shorter first < el first) ifTrue: [ shorter ] ifFalse: [ el ]]) second! !

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'AlexandreBergel 6/3/2012 14:23'!
fourFromPointsOfEdge: edge
	"Return the four middle points, for each of the four sides"
	| element |
	element := edge from.
	^ Array 
		with: (element positionRelativeTo: edge parent) + ((element bounds width / 2) asInteger @ 0)
		with: (element positionRelativeTo: edge parent) + (element bounds width @ (element  bounds height / 2) asInteger)
		with: (element positionRelativeTo: edge parent) + ((element bounds width / 2) asInteger @ (element bounds height))
		with: (element positionRelativeTo: edge parent) + (0 @ (element bounds height / 2) asInteger)
		
	! !

!ROShorterDistanceAttachPoint methodsFor: 'util' stamp: 'AlexandreBergel 6/3/2012 14:23'!
fourToPointsOfEdge: edge
	"Return the four middle points, for each of the four sides"
	| element |
	element := edge to.
	^ Array 
		with: (element positionRelativeTo: edge parent) + ((element bounds width / 2) asInteger @ 0)
		with: (element positionRelativeTo: edge parent) + (element bounds width @ (element  bounds height / 2) asInteger)
		with: (element positionRelativeTo: edge parent) + ((element bounds width / 2) asInteger @ (element bounds height))
		with: (element positionRelativeTo: edge parent) + (0 @ (element bounds height / 2) asInteger)
		
	! !

!ROShorterDistanceAttachPoint methodsFor: 'public - hooks' stamp: 'AlexandreBergel 6/3/2012 14:27'!
startingPointOf: anEdge
	| ps p dp t |
	ps := self fourFromPointsOfEdge: anEdge.
	p := (anEdge to positionRelativeTo: anEdge parent) + (anEdge to width @  anEdge to height).
	
	"We get the list of dot products"
	dp := ps collect: [ :pp | 
		t := p - pp.
		Array with: (t dotProduct: t) with:  pp ].
	
	"We look for the shorter path and return the point"
	^ (dp inject: dp first into: [ :shorter :el | (shorter first < el first) ifTrue: [ shorter ] ifFalse: [ el ]]) second! !

ROAttachPoint subclass: #ROVerticalAttachPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-AttachPoint'!

!ROVerticalAttachPoint methodsFor: 'public - hooks' stamp: ''!
endingPointOf: anEdge
	^  (anEdge to positionRelativeTo: anEdge parent) + ((anEdge to bounds width / 2) asInteger @ 0)
	! !

!ROVerticalAttachPoint methodsFor: 'public - hooks' stamp: ''!
startingPointOf: anEdge
	^ (anEdge from positionRelativeTo: anEdge parent) + ((anEdge from bounds width / 2) asInteger @ (anEdge from bounds height ))
	! !

ROObject subclass: #ROCamera
	instanceVariableNames: 'position angle realExtent extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROCamera class methodsFor: 'defaults' stamp: ''!
defaultAngle
	^ 95! !

!ROCamera class methodsFor: 'defaults' stamp: ''!
defaultExtent
	"Maybe this has to be replaced by defaultAngle and default Height"
	^ 500 @ 500! !

!ROCamera class methodsFor: 'defaults' stamp: ''!
defaultHeight
	^ 200! !

!ROCamera class methodsFor: 'defaults' stamp: ''!
defaultPosition
	^ 0 @ 0! !

!ROCamera class methodsFor: 'public' stamp: ''!
realExtent: aPoint
	^ self new realExtent: aPoint! !

!ROCamera methodsFor: 'accessing' stamp: ''!
angle
	^ angle! !

!ROCamera methodsFor: 'accessing' stamp: ''!
angleInRadian
	^ angle asFloat / 180 * 3.1415! !

!ROCamera methodsFor: 'rendering' stamp: ''!
bitmapForElements: elements 
	| canvas |
	canvas := self canvas.
	elements do: [ :n | n drawOn: canvas ].
	^ canvas form! !

!ROCamera methodsFor: 'accessing' stamp: ''!
bounds
	"bounds "
	^ position extent: extent
	
"	| ra v p |
	ra := self angleInRadian.
	v := height * ra sin.
	p := position.
	^ ((p x - v) @ (p y - v)) asIntegerPoint corner: ((p x + v) @ (p y + v)) asIntegerPoint"! !

!ROCamera methodsFor: 'accessing' stamp: ''!
bounds: rec

	"Should be removed!!"
	position := rec topLeft.
	self extent: rec extent.! !

!ROCamera methodsFor: 'rendering' stamp: 'AlexandreBergel 4/19/2012 12:29'!
canvas
	^ ROAbstractCanvas subclasses first onCamera: self! !

!ROCamera methodsFor: 'accessing' stamp: ''!
centerPosition
	^ self bounds center! !

!ROCamera methodsFor: 'accessing' stamp: ''!
extent
	^ extent! !

!ROCamera methodsFor: 'accessing' stamp: ''!
extent: anExtent
	extent := anExtent! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 6/5/2012 23:10'!
height
	^ (self realExtent x / 2) / (self angleInRadian / 2 ) tan
	"^ self extent y"
	
"OLD VERSION:

height
	^ (self realExtent x / 2) / (self angleInRadian / 2 ) tan
	
	"! !

!ROCamera methodsFor: 'accessing' stamp: ''!
height: h
	| nx ny oldExtent |
	nx := 2 * h * (self angleInRadian / 2) tan.
	ny := self extent x * nx / self extent y.
	"stepForPosition := (realExtent - (nx asInteger @ ny asInteger)) / 2."
	
	oldExtent := extent.
	"self translateBy: stepForPosition asIntegerPoint negated."
	extent := nx asInteger @ ny asInteger.
	self translateBy: ((extent - oldExtent ) / 2) asIntegerPoint! !

!ROCamera methodsFor: 'initialize' stamp: 'AlexandreBergel 6/5/2012 00:24'!
initialize
	super initialize.
	angle := self class defaultAngle.
	position := self class defaultPosition.
	realExtent := self class defaultExtent.
	extent := self class defaultExtent! !

!ROCamera methodsFor: 'public' stamp: ''!
moveDown
	self height: self height - 10! !

!ROCamera methodsFor: 'public' stamp: ''!
moveToSee: aRectangle
	| t |
	t := aRectangle extent x min: aRectangle extent y.
	position := t @ t.
	"height := (t / 2 / (self angleInRadian / 2) tan) asInteger"
	"height := ((aRectangle extent x) / 2 / (self angleInRadian / 2) tan) asInteger"! !

!ROCamera methodsFor: 'public' stamp: ''!
moveUp
	self height: self height +10! !

!ROCamera methodsFor: 'accessing' stamp: ''!
position
	^ position! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realBounds
	^ position extent: realExtent! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realBounds: rec

	"Should be removed!!"
	position := rec topLeft.
	self realExtent: rec extent.! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realExtent
	^ realExtent! !

!ROCamera methodsFor: 'accessing' stamp: ''!
realExtent: anObject
	realExtent := anObject! !

!ROCamera methodsFor: 'util' stamp: 'AlexandreBergel 5/28/2012 14:07'!
realToVirtualPoint: aPoint
	"Return a real point from a one expressed in the virtual coordinates"
	
	| visibleBounds offset |
"	
	offset := visibleBounds origin.
"
	visibleBounds := self bounds.
	offset := self position.
	^ ((aPoint x asFloat / realExtent x * visibleBounds width + offset x) asInteger) @
	   ((aPoint y asFloat / realExtent y * visibleBounds height + offset y) asInteger)
! !

!ROCamera methodsFor: 'util' stamp: ''!
realToVirtualPointNoTrunc: aPoint
	"Return a real point from a one expressed in the virtual coordinates"
	
	| visibleBounds offset |
	visibleBounds := self bounds.
	offset := self position.
	^ ((aPoint x asFloat / realExtent x * visibleBounds width + offset x) asFloat) @
	   ((aPoint y asFloat / realExtent y * visibleBounds height + offset y) asFloat)
! !

!ROCamera methodsFor: 'util' stamp: ''!
realToVirtualRectangle: aRectangle
	"Return a rectangle with virtual coordinates from one expressed in the real coordinates"
	
	^ (self realToVirtualPoint: aRectangle origin) corner: (self realToVirtualPoint: aRectangle corner)! !

!ROCamera methodsFor: 'public' stamp: ''!
translateBy: pos
	position := position + pos! !

!ROCamera methodsFor: 'public' stamp: ''!
translateBy: aPoint during: aBlock
	self translateBy: aPoint.
	aBlock value.
	self translateBy: aPoint negated.! !

!ROCamera methodsFor: 'public' stamp: ''!
translateByRealStep: aStep
	"aStep represents the step in pixel on what the user see the visu"
	
	self translateBy: (self realToVirtualPoint: aStep)! !

!ROCamera methodsFor: 'public' stamp: ''!
translateTo: pos
	position := pos! !

!ROCamera methodsFor: 'util' stamp: 'AlexandreBergel 6/2/2012 12:28'!
virtualToRealPoint: aPoint 
	"Return a virtual point from a one expressed in the real coordinates"
	
	| visibleBounds offset |

	visibleBounds := self bounds.
	offset := self position.
	^ ((aPoint x asFloat - offset x  * realExtent x / visibleBounds width) asInteger) @
	   ((aPoint y asFloat - offset y * realExtent y / visibleBounds height) asInteger)
! !

!ROCamera methodsFor: 'util' stamp: ''!
virtualToRealPointNoTrunc: aPoint 
	"Return a virtual point from a one expressed in the real coordinates"
	
	| visibleBounds offset |
	visibleBounds := self bounds.
	offset := self position.
	^ ((aPoint x asFloat - offset x  * realExtent x / visibleBounds width) asFloat) @
	   ((aPoint y asFloat - offset y * realExtent y / visibleBounds height) asFloat)
! !

!ROCamera methodsFor: 'util' stamp: ''!
virtualToRealRectangle: aRectangle
	"Return a rectangle with real coordinates from one expressed in the virtual coordinates"
	
	^ (self virtualToRealPoint: aRectangle origin) corner: (self virtualToRealPoint: aRectangle corner)! !

!ROCamera methodsFor: 'accessing' stamp: 'AlexandreBergel 6/5/2012 11:17'!
width
	^ self extent x! !

ROObject subclass: #ROCountingNullCanvas
	instanceVariableNames: 'numberOfRectangles numberOfLines numberOfImages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core-Tests'!

!ROCountingNullCanvas class methodsFor: 'instance creation' stamp: ''!
on: aForm
	"we do nothing"
	^ self new! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
clipRect
	^1@1 extent: 100000@100000! !

!ROCountingNullCanvas methodsFor: 'drawing-rectangles' stamp: ''!
frameAndFillRectangle: bounds fillColor: c borderWidth: width borderColor: cc
	numberOfRectangles := numberOfRectangles + 1.
! !

!ROCountingNullCanvas methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize .
	numberOfRectangles := 0.
	numberOfLines := 0.
	numberOfImages := 0! !

!ROCountingNullCanvas methodsFor: 'drawing' stamp: ''!
line: fromPoint to: toPoint width: width color: color
	numberOfLines := numberOfLines + 1.! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
numberOfImages
	^ numberOfImages! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
numberOfLines
	^ numberOfLines! !

!ROCountingNullCanvas methodsFor: 'accessing' stamp: ''!
numberOfRectangles
	^ numberOfRectangles! !

!ROCountingNullCanvas methodsFor: 'drawing-images' stamp: ''!
paintImage: cacheForm at: position
	numberOfImages := numberOfImages + 1.
! !

!ROCountingNullCanvas methodsFor: 'hook' stamp: ''!
warpImage: aForm transform: aTransform at: extraOffset sourceRect: sourceRect cellSize: cellSize
	"We cancel this method. It is defined as abstract in the Canvas class"! !

ROObject subclass: #ROElement
	instanceVariableNames: 'bounds model eventHandler interactions view elements parent shape resizeStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

ROElement subclass: #ROButtonElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Widgets'!

!ROButtonElement class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/1/2012 15:01'!
named: aName do: aOneArgBlockAsCallback
	^ self basicNew initializeWithName: aName Callback: aOneArgBlockAsCallback! !

!ROButtonElement methodsFor: 'public' stamp: 'AlexandreBergel 6/1/2012 15:04'!
initializeWithName: aName Callback: callbackAsOneArgBlock
	super initialize.
	self + (ROLabel text: aName).
	self @ ROLightlyHighlightable.
	self on: ROMouseClick do: callbackAsOneArgBlock.
	! !

ROElement subclass: #ROEdge
	instanceVariableNames: 'from to'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROEdge class methodsFor: 'public' stamp: 'AlexandreBergel 4/15/2012 19:05'!
arrowedLineFrom: f to: t
	^ (self from: f to: t)
		+ ROArrowedLine ;
		yourself! !

!ROEdge class methodsFor: 'public' stamp: ''!
from: f to: t
	self assert: [ f isKindOf: ROElement ].
	self assert: [ t isKindOf: ROElement ].
	^ self new from: f to: t; yourself! !

!ROEdge class methodsFor: 'public' stamp: ''!
lineFrom: f to: t
	^ (self from: f to: t)
		+ ROLine ;
		yourself! !

!ROEdge class methodsFor: 'public' stamp: ''!
linesFor: associations 
	"Return a collection of edges, one for each provided association"

	^ associations collect: [ :assoc | self lineFrom: assoc key to: assoc value ]! !

!ROEdge methodsFor: 'visiting' stamp: ''!
accept: aVisitor
	aVisitor visitEdge: self! !

!ROEdge methodsFor: 'accessing' stamp: ''!
from
	^ from! !

!ROEdge methodsFor: 'accessing' stamp: ''!
from: f to: t
	from := f.
	to := t! !

!ROEdge methodsFor: 'testing' stamp: ''!
isEdge
	^ true! !

!ROEdge methodsFor: 'accessing' stamp: ''!
source
	^ self from! !

!ROEdge methodsFor: 'accessing' stamp: ''!
target
	^ self to! !

!ROEdge methodsFor: 'accessing' stamp: ''!
to 
	^ to! !

!ROElement class methodsFor: 'defaults' stamp: ''!
defaultBounds
	^ (0@0 corner: 5@5)! !

!ROElement class methodsFor: 'public' stamp: ''!
forCollection: aCollection 
	^ (aCollection collect: [ :v | self on: v ]) asArray! !

!ROElement class methodsFor: 'public' stamp: ''!
on: anObject 
	^ self basicNew model: anObject; initialize; yourself! !

!ROElement class methodsFor: 'public' stamp: 'AlexandreBergel 5/7/2012 11:54'!
sprite

	^ self new
			extent: 50 @ 50;
			addInteraction: RODraggable;
			addShape: (ROBorder new color: Color red);
			yourself! !

!ROElement class methodsFor: 'public' stamp: ''!
spriteOn: value
	^ self sprite model: value! !

!ROElement class methodsFor: 'public' stamp: ''!
spritesFor: values
	^ values collect: [:v | self sprite model: v ]! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 5/7/2012 11:59'!
+ aShape 
	self addShape: aShape.
	^ self ! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 08:11'!
- aShape 
	self removeShape: aShape.
	^ self ! !

!ROElement methodsFor: 'accessing' stamp: ''!
@ anInteractionClassOrInstance
	"Add an interaction to the node"
	self addInteraction: anInteractionClassOrInstance! !

!ROElement methodsFor: 'accessing' stamp: ''!
absolutePosition
	"Return the absolute position of the element, the top left corner"

	^ parent 
		ifNil: [ self position ]
		ifNotNil: [ self position + parent absolutePosition ]! !

!ROElement methodsFor: 'visiting' stamp: ''!
accept: aVisitor
	aVisitor visitNode: self! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 5/22/2012 00:41'!
add: el
	self assert: [ el  isKindOf: ROElement ].
	el translateBy: self topLeft negated.
	elements add: el.
	el parent: self; view: self view.
	
	self adjustSizeIfNecessary
! !

!ROElement methodsFor: 'public' stamp: ''!
addAll: els
	els do: [:el | self add: el ]! !

!ROElement methodsFor: 'accessing' stamp: ''!
addInteraction: anInteractionClassOrInstance
	"Add an interaction to the node"
	
	| key |	
	key := anInteractionClassOrInstance isBehavior 
				ifTrue: [anInteractionClassOrInstance]
				 ifFalse: [anInteractionClassOrInstance class].
	interactions at: key put: (anInteractionClassOrInstance initializeElement: self)
	! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 12:08'!
addShape: aShape 

	shape := shape addLast: (aShape installedOn: self)! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 6/2/2012 14:25'!
adjustSizeIfNecessary
	resizeStrategy on: self! !

!ROElement methodsFor: 'events' stamp: ''!
announce: anEvent
	"trigger an event. Objects who registered to me will get notified"

	| eventToBeSent |
	eventToBeSent := anEvent isBehavior 
						ifTrue: [ anEvent new ]
						ifFalse: [ anEvent ]. 
	
	eventToBeSent element: self.
	eventHandler announce: eventToBeSent! !

!ROElement methodsFor: 'accessing' stamp: ''!
bottomCenter
	^ self bounds bottomCenter! !

!ROElement methodsFor: 'accessing' stamp: ''!
bottomLeft
	^ bounds bottomLeft! !

!ROElement methodsFor: 'accessing' stamp: ''!
bottomRight 
	^ bounds bottomRight! !

!ROElement methodsFor: 'accessing' stamp: ''!
bounds
	^ bounds copy! !

!ROElement methodsFor: 'accessing' stamp: ''!
center
	^ self bounds center! !

!ROElement methodsFor: 'accessing' stamp: ''!
center: pos

	^ self translateTo: (pos - (self extent / 2))! !

!ROElement methodsFor: 'accessing' stamp: ''!
center: aPoint radius: d

	 bounds := (aPoint - (d@d)) asIntegerPoint corner: (aPoint + (d@d)) asIntegerPoint ! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 12:08'!
change: aShapeClass for: aShape
	"aDecorator could be a class or a shape"
	shape := shape change: aShapeClass for: (aShape installedOn: self).
! !

!ROElement methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 19:53'!
changeInteraction: anInteractionClass for: anInteraction
	self removeInteraction: anInteractionClass.
	self @ anInteraction! !

!ROElement methodsFor: 'testing' stamp: ''!
contains: aPoint
	^ self bounds containsPoint: aPoint! !

!ROElement methodsFor: 'copying' stamp: 'AlexandreBergel 5/7/2012 11:54'!
copy
	| answer |
	answer := self class new.
	answer 
			translateTo: self position;
			extent: self extent.
	self shapesDo: [ :d | answer + d ].
	self interactionsDo: [ :i | answer @ i ].
	^ answer
			! !

!ROElement methodsFor: 'drawing' stamp: 'AlexandreBergel 5/22/2012 08:37'!
drawOn: aCanvas
	"This should be changed. drawOn: should not do an explicit iteration, but letting each shape call drawOn: on its next "

	self shapes do: [ :d | d drawOn: aCanvas for: self ].
	self paintChildrenOn: aCanvas! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 13:49'!
elementAt: aPoint 
	| elToLookupInto |
	elements isEmpty ifTrue: [ ^ self ].
	elToLookupInto := (elements detect: [ :el | el contains: (aPoint) ] ifNone: [ 
			^ (self extent >= aPoint)
				ifTrue: [ self ]
				ifFalse: [ view ] ]).
			
	^ elToLookupInto elementAt: (aPoint - elToLookupInto topLeft) 
! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 4/14/2012 10:39'!
elementFromModel: object
	"Recursively look for the element with a model object"
	| v |
	
	(self model = object) ifTrue: [ ^ self ].
	
	v :=  elements 
		detect: [ :e | e model = object ]
		ifNone: [ nil ].
	v ifNotNil: [ ^ v ].
	
	elements do: [ :e |
		v := e elementFromModel: object.
		v ifNotNil: [ ^ v ] ].
	
	^ nil

	"^ (self elementsSuchThat: [ :el | object = el model ]) first"! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 6/5/2012 09:31'!
elements
	^ elements copy! !

!ROElement methodsFor: 'actions' stamp: ''!
elementsCollect: aBlock
	^ elements collect: aBlock! !

!ROElement methodsFor: 'actions' stamp: ''!
elementsDo: aBlock
	^ elements copy do: aBlock! !

!ROElement methodsFor: 'actions' stamp: ''!
elementsFromModels: objects
	^ self elementsSuchThat: [ :el | objects includes: el model ]! !

!ROElement methodsFor: 'actions' stamp: ''!
elementsSuchThat: aBlock
	^ elements select: aBlock! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 15:41'!
elementsWithModelDo: aBlock
	^ (elements copy select: [ :n | n model notNil ]) do: aBlock
	! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 13:49'!
encompassingRectangle
	elements isEmpty ifTrue: [ ^ self bounds ].
	^ Rectangle merging: 
		(Array with: (((Rectangle merging: (elements collect: #bounds)) translateBy: self topLeft) extendBy: 5@5)), 		
		(Array with: self bounds)! !

!ROElement methodsFor: 'accessing' stamp: ''!
extent
	^ bounds extent ! !

!ROElement methodsFor: 'accessing' stamp: ''!
extent: aPoint 
	bounds := Rectangle origin: bounds origin extent: aPoint
	 ! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 08:16'!
forShape: shapeClass do: aOneArgBlock
	"Find the shape that correspond to the shape class, and evaluate the block by passing the shape to it"

	| v |
	v := ( self getShape: ROBox). 
	v ifNotNil: [ aOneArgBlock value: v  ]! !

!ROElement methodsFor: 'events' stamp: ''!
forward
	eventHandler forward! !

!ROElement methodsFor: 'events' stamp: ''!
forward: obj
	eventHandler forward: obj! !

!ROElement methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 19:52'!
getInteraction: anInteractionClass

	^ interactions at: anInteractionClass
! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:46'!
getShape: shapeClass
	^ self shapeDetect: [ :de | de isKindOf: shapeClass ]! !

!ROElement methodsFor: 'accessing' stamp: ''!
height
	^ self extent y! !

!ROElement methodsFor: 'accessing' stamp: ''!
height: h
	self extent: self width @ (h roValue: self model)! !

!ROElement methodsFor: 'initialization' stamp: 'AlexandreBergel 5/22/2012 00:24'!
initialize 
	super initialize.
	self initializeVariables.	
	parent := ROView blackHole! !

!ROElement methodsFor: 'initialization' stamp: 'AlexandreBergel 6/2/2012 14:25'!
initializeVariables
	bounds := self class defaultBounds.
	shape := RONullShape current.
	eventHandler := ROAnnouncer new.
	view := ROView blackHole.
	elements := OrderedCollection new.
	
	"Per default, the parent is always extensible"
	resizeStrategy := ROExtensibleParent instance.
	
	"Actually, I am not sure we need to have a variable interactions"
	interactions := IdentityDictionary new.
! !

!ROElement methodsFor: 'interaction' stamp: 'AlexandreBergel 4/18/2012 14:57'!
interactionsDo: aBlock
	"Execute a block for each interaction"
	
	interactions ifNil: [ ^ self ].
	interactions values do: aBlock! !

!ROElement methodsFor: 'interaction' stamp: ''!
is: anInteractionClass

	interactions ifNil: [ ^ false ].
	^ interactions includesKey: anInteractionClass
	
	"^ interactions anySatisfy: [ :int | int isKindOf: anInteractionClass ]"! !

!ROElement methodsFor: 'testing' stamp: ''!
isEdge
	^ false! !

!ROElement methodsFor: 'testing' stamp: ''!
isNotEdge
	^ self isEdge not! !

!ROElement methodsFor: 'testing' stamp: 'AlexandreBergel 5/7/2012 12:04'!
isShapedAs: aShapeClass
	^ shape isShapedAs: aShapeClass! !

!ROElement methodsFor: 'accessing' stamp: ''!
leftCenter
	^ self bounds leftCenter! !

!ROElement methodsFor: 'accessing' stamp: ''!
model
	^ model! !

!ROElement methodsFor: 'accessing' stamp: ''!
model: anObject 
	model := anObject! !

!ROElement methodsFor: 'accessing' stamp: ''!
numberOfElements 
	^ elements size! !

!ROElement methodsFor: 'accessing' stamp: ''!
numberOfInteractions
	interactions ifNil: [ ^ 0 ].
	^ interactions size ! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 5/7/2012 11:53'!
numberOfShapes
	^ self shapes size ! !

!ROElement methodsFor: 'events' stamp: 'AlexandreBergel 4/18/2012 13:50'!
on: eventClass do: aBlock
	"Register a block as an handler for eventClass"
	
	eventHandler when: eventClass do: aBlock! !

!ROElement methodsFor: 'drawing' stamp: 'AlexandreBergel 5/10/2012 20:03'!
paintChildrenOn: aCanvas
	self view camera translateBy: self topLeft negated during: [ elements do: [ :n | n drawOn: aCanvas ] ]! !

!ROElement methodsFor: 'accessing' stamp: ''!
parent
	^ parent! !

!ROElement methodsFor: 'accessing' stamp: ''!
parent: anObject
	parent := anObject! !

!ROElement methodsFor: 'events' stamp: ''!
parentAnnounce: event
	"Do nothing if no parent"
	parent ifNil: [ ^ self ].
	
	parent announce: event! !

!ROElement methodsFor: 'accessing' stamp: ''!
position
	"Return the position of the element. Return a point of floats"
	
	^ self bounds topLeft! !

!ROElement methodsFor: 'accessing' stamp: ''!
positionAsInteger
	"Return the position as integer"
	
	^ self position asIntegerPoint ! !

!ROElement methodsFor: 'accessing' stamp: ''!
positionRelativeTo: anElement
	"Return the position of myself against the position of one of my parent, anElement. The returned position is relative to it."
	"This method is useful to draw edges that are nested"

	(anElement == self)
		ifTrue: [ ^ 0 @ 0 ].
	
	^ self topLeft + (parent positionRelativeTo: anElement)! !

!ROElement methodsFor: 'printing' stamp: ''!
printOn: stream
	super printOn: stream.
	model ifNotNil: [ 
		stream nextPutAll: '<'.
		model printOn: stream.
		stream nextPutAll: '>' ]! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 5/17/2012 20:31'!
radius
	^ self extent r / 2
	
! !

!ROElement methodsFor: 'accessing' stamp: ''!
radius: d

	^ self center: self position radius: d! !

!ROElement methodsFor: 'actions' stamp: 'AlexandreBergel 6/5/2012 10:30'!
remove
	"Remove myself from the view I belongs to "
	view remove: self! !

!ROElement methodsFor: 'actions' stamp: ''!
removeAllElements
	elements := OrderedCollection new! !

!ROElement methodsFor: 'actions' stamp: ''!
removeElement: element
	elements remove element! !

!ROElement methodsFor: 'interaction' stamp: 'AlexandreBergel 4/30/2012 19:53'!
removeInteraction: anInteractionClass
	| ds |
	ds := interactions select: [ :d | d isKindOf: anInteractionClass ].
	ds associationsDo: [ :assoc | 
		interactions removeKey: assoc key.
		eventHandler unsubscribe: assoc value ].
! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 08:18'!
removeShape: aShapeClass
	"Remove a shape of the element"

	shape := shape removeShape: aShapeClass! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 14:26'!
resizeStrategy
	^ resizeStrategy! !

!ROElement methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 14:27'!
resizeStrategy: anInstanceOfROAbstractResizeStrategy
	resizeStrategy := anInstanceOfROAbstractResizeStrategy! !

!ROElement methodsFor: 'accessing' stamp: ''!
rightCenter
	^ self bounds rightCenter! !

!ROElement methodsFor: 'translation' stamp: ''!
setBounds:  aBounds
	self extent: aBounds extent.
	self translateTo: aBounds origin.! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 12:00'!
shapeDetect: aBlock
	^ shape shapeDetect: aBlock! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 08:21'!
shapes
	"Return the list of shapes"
	
	| ans d |
	ans := OrderedCollection new.
	d := shape. 
	[ d class ~~ RONullShape ] whileTrue: [ 
		ans add: d.
		d := d next ].
	^ ans.! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 12:02'!
shapesCollect: aBlock
	^ self shapes collect: aBlock! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:54'!
shapesDo: aBlock
	^ self shapes do: aBlock! !

!ROElement methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 12:01'!
shapesSelect: aBlock
	^ self shapes select: aBlock! !

!ROElement methodsFor: 'events' stamp: ''!
signalUpdate
	^ view signalUpdate! !

!ROElement methodsFor: 'accessing' stamp: ''!
size: d
	self extent: d @ d! !

!ROElement methodsFor: 'accessing' stamp: ''!
topCenter
	^ self bounds topCenter! !

!ROElement methodsFor: 'accessing' stamp: ''!
topLeft
	^ bounds topLeft ! !

!ROElement methodsFor: 'accessing' stamp: ''!
topRight
	^ bounds topRight! !

!ROElement methodsFor: 'translation' stamp: 'AlexandreBergel 5/22/2012 00:42'!
translateBy: aPoint 
	self translateWithoutUpdatingContainedElementsBy: aPoint.
	parent adjustSizeIfNecessary
! !

!ROElement methodsFor: 'translation' stamp: ''!
translateByRealPoint: aPoint 
	| p |
	p := self view camera virtualToRealPointNoTrunc: self position.
	"Transcript show: 'translateByRealPoint -- bounds:', self bounds asString, '    aPoint', aPoint asString , '  virtual step:', (p2 - p1) asString; cr."
	self translateTo: (self view camera realToVirtualPointNoTrunc: (p + aPoint)) asIntegerPoint.
! !

!ROElement methodsFor: 'translation' stamp: ''!
translateTo: aPoint 
	self translateBy: (aPoint - self bounds origin)! !

!ROElement methodsFor: 'translation' stamp: ''!
translateToRealPoint: aPoint 
	| p |
	p := self view camera realToVirtualPoint: aPoint. 
	"Transcript show: 'translateToRealPoint -- bounds:', self bounds asString, '    real:', aPoint asString , '  virtual:', p asString; cr."
	self translateTo: p.
! !

!ROElement methodsFor: 'translation' stamp: ''!
translateWithoutUpdatingContainedElementsBy: aPoint
	"translate myself without updating the parent."
	
	bounds := bounds translateBy: aPoint.
	! !

!ROElement methodsFor: 'accessing' stamp: ''!
view
	^ view! !

!ROElement methodsFor: 'accessing' stamp: ''!
view: aView
	view := aView.
	elements do: [ :el | el view: aView ]
	! !

!ROElement methodsFor: 'accessing' stamp: ''!
width
	^ self extent x! !

!ROElement methodsFor: 'accessing' stamp: ''!
width: w
	self extent: (w roValue: self model) @ self height! !

ROElement subclass: #ROLabelElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Widgets'!

!ROLabelElement methodsFor: 'initialize' stamp: 'AlexandreBergel 6/1/2012 06:23'!
initialize
	super initialize.
	self + ROLabel.
	! !

!ROLabelElement methodsFor: 'accessing' stamp: 'AlexandreBergel 5/7/2012 11:54'!
textColor: color
	self shapesDo: [ :d | d color: color ]! !

ROElement subclass: #ROZoomElement
	instanceVariableNames: 'targetView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Widgets'!

!ROZoomElement class methodsFor: 'public' stamp: ''!
targetView: view
	^ self new targetView: view! !

!ROZoomElement methodsFor: 'initialization' stamp: 'AlexandreBergel 5/7/2012 11:54'!
inButton
	| nodeZoomIn |
	nodeZoomIn := (ROElement new)
		model: '+';
		extent: 40 @ 40;
		addShape: ROBox;
		addShape: ROBorder red;
		addShape: ROLabel.
	nodeZoomIn
		on: ROMouseClick
		do: [ :event | 
			ROZoomInMove new on: targetView ].
	self add: nodeZoomIn! !

!ROZoomElement methodsFor: 'initialization' stamp: 'AlexandreBergel 5/7/2012 11:54'!
initialize
	super initialize.
	self addShape: ROBorder yellow.
	
	self inButton.
	self outButton! !

!ROZoomElement methodsFor: 'initialization' stamp: 'AlexandreBergel 5/7/2012 11:54'!
outButton
	| nodeZoomOut |
	nodeZoomOut := (ROElement new)
		model: '-';
		setBounds: (45 @ 0 extent: 40 @ 40);
		addShape: ROBox;
		addShape: ROBorder red;
		addShape: ROLabel.
	nodeZoomOut
		on: ROMouseClick
		do: [ :event | 
			ROZoomOutMove new on: targetView ].
	self add: nodeZoomOut! !

!ROZoomElement methodsFor: 'accessing' stamp: ''!
targetView
	^ targetView! !

!ROZoomElement methodsFor: 'accessing' stamp: ''!
targetView: anObject
	targetView := anObject! !

ROObject subclass: #ROFontOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!ROFontOrganizer commentStamp: '<historical>' prior: 0!
Abstract class that tells about what a font looks like!

!ROFontOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 4/25/2012 15:47'!
current
	^ self subclasses first! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 4/27/2012 18:02'!
height
	self subclassResponsibility! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:35'!
offsetWhenDrawing
	^ 0 @ 0! !

!ROFontOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 4/18/2012 15:50'!
widthOfString: string
	self subclassResponsibility! !

ROObject subclass: #ROGraphTransformation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Transformation'!

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:02'!
containsCycleIn: nodes with: edges 
	"Broken so far"
	^ self containsCycleIn: nodes with: edges alreadyPassedNodes: #() root: nodes first
! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:00'!
containsCycleIn: nodes with: edges alreadyPassedNodes: passedNodes root: rootNode

	| newNodes newPassedNode c res |
	nodes ifEmpty: [ ^ false ].
	(passedNodes includes: rootNode) ifTrue: [ ^ true ].
	
	newNodes := nodes.
	newPassedNode := passedNodes.
	
	res := false.
	nodes do: [ :node | 
		(passedNodes contains: node) ifTrue: [ ^ true ].
		newNodes := nodes copyWithout: rootNode.
		c := self getConnectedNodesFrom: node using: edges.
		newNodes := newNodes copyWithoutAll: c.
		newPassedNode := newPassedNode, (Array with: rootNode).
		
		res := res and: [self containsCycleIn: newNodes with: edges alreadyPassedNodes: passedNodes root: node]	
	].
	^ res
	! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:38'!
containsCycleIn: rootNode with: edges passedNodes: passedNodes

	| c usedEdges |
	edges ifEmpty: [ ^ false ].
	(passedNodes includes: rootNode) ifTrue: [ ^ true ].
	c := self getConnectedNodesFrom: rootNode using: edges.
	usedEdges := edges select: [ :edge | edge from == rootNode ].
	passedNodes add: rootNode.
	c do: [ :nr | 
		(self containsCycleIn: nr with: (edges copyWithoutAll: usedEdges) passedNodes: passedNodes)
			ifTrue: [ ^ true ].
		passedNodes add: nr. ].
	^ false! !

!ROGraphTransformation methodsFor: 'public' stamp: 'AlexandreBergel 6/5/2012 10:46'!
fromEdgesToNesting: nodes edges: edges root: root
	| connectedNodes |
	"self assert: [ self containsCycleIn: nodes with: edges ] description: 'Cannot contain cycle'."
	
	connectedNodes := self getConnectedNodesFrom: root using: edges.
	connectedNodes := connectedNodes 
						collect: [ :node | self 
										fromEdgesToNesting: (nodes copyWithoutAll: connectedNodes) 
										edges: edges 
										root: node ].
	connectedNodes do: #remove.
	root addAll: connectedNodes.
	
	^ root! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 10:49'!
getConnectedEdgesFrom: rootNode using: edges
	^ (edges select: [ :edge | edge from == rootNode ])! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 09:30'!
getConnectedNodesFrom: rootNode using: edges
	^ (edges select: [ :edge | edge from == rootNode ]) collect: #to! !

!ROGraphTransformation methodsFor: 'utility' stamp: 'AlexandreBergel 6/5/2012 11:02'!
hasCycleIn: nodes with: edges	
	| connectedNodes connectedEdges runningNodes runningEdges |

	runningNodes := nodes.
	runningEdges := edges.
	nodes copy do: [ :n |	
		runningNodes := runningNodes copyWithout: n.
		
		connectedNodes := self getConnectedNodesFrom: n using: runningEdges.
		connectedEdges := self getConnectedEdgesFrom: n using: runningEdges.
		
		(runningNodes includesAllOf: connectedNodes) ifFalse: [ ^ true ].
		
		runningNodes := runningNodes copyWithoutAll: connectedNodes.
		runningEdges := runningEdges copyWithoutAll: connectedEdges.

		runningEdges ifEmpty: [ ^ false ].
		runningNodes ifEmpty: [ ^ false ].

	]! !

ROObject subclass: #ROIdentityMatrix
	instanceVariableNames: 'rows'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROIdentityMatrix methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 14:27'!
at: u
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row keys! !

!ROIdentityMatrix methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 14:27'!
at: u at: v
	
	| row |
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	^row
		at: v
		ifAbsent: [false]! !

!ROIdentityMatrix methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 14:27'!
at: u at: v put: aBoolean
	
	| row |
	"u -> v"
	row := rows
		at: u
		ifAbsentPut: [IdentityDictionary new].
	row at: v put: aBoolean.	"v -> u"
	row := rows
		at: v
		ifAbsentPut: [IdentityDictionary new].
	row at: u put: aBoolean! !

!ROIdentityMatrix methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/18/2012 14:27'!
initialize
	
	rows := IdentityDictionary new! !

ROObject subclass: #ROInteraction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

ROInteraction subclass: #ROAbstractPopup
	instanceVariableNames: 'receivingView'
	classVariableNames: 'Popups'
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAbstractPopup class methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 10:46'!
defaultPopupOffset
	^ 10 @ 10! !

!ROAbstractPopup methodsFor: 'hooks' stamp: ''!
createElementFor: element
	self subclassResponsibility! !

!ROAbstractPopup methodsFor: 'creation' stamp: 'AlexandreBergel 6/1/2012 18:32'!
createPopupFor: element
	| el |
	el := self createElementFor: element.
	el on: ROMouseLeave do: [ :e | el view remove: el ifAbsent: [  ] ].

	(self receivingViewFor: element) add: el.	

	self popups add: el.

	^ el! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 6/1/2012 18:27'!
initialize
	super initialize.
	receivingView := [ :element | element view ]. ! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 6/2/2012 01:15'!
initializeElement: element
	 element on: ROMouseEnter do: [ :event | 
		| el |
		self removeAllPopups.
		el := self createPopupFor: element.
"Transcript show: ((self receivingViewFor: element) camera realToVirtualPoint: event realPosition) printString, '   ',event position printString ."
		el translateTo: (((self receivingViewFor: element) camera realToVirtualPoint: event realPosition) + self popupOffset).
"		el translateTo: (event position + self popupOffset).
"
		el signalUpdate ].
	
	 element on: ROMouseLeave do: [ :event | 
		self removeAllPopups.
		element signalUpdate  ].! !

!ROAbstractPopup methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 10:47'!
popupOffset
	^ self class defaultPopupOffset! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 5/21/2012 22:07'!
popups
	^ Popups ifNil: [ Popups := OrderedCollection new ]! !

!ROAbstractPopup methodsFor: 'accessing' stamp: 'AlexandreBergel 6/1/2012 18:28'!
receivingView: rView
	receivingView := rView! !

!ROAbstractPopup methodsFor: 'creation' stamp: 'AlexandreBergel 6/1/2012 18:30'!
receivingViewFor: element
	"Return the view in which the popup has to be added. Per default this view is the view in which the element is contained.
	However, this may be different, especially when contained in a stack"
	^ receivingView roValue: element! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 5/28/2012 21:16'!
removeAllPopups
	self popups do: [ :p | self removePopup: p ].
	Popups := nil! !

!ROAbstractPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 5/28/2012 21:19'!
removePopup: el
	el ifNotNil: [ el view remove: el ifAbsent: [] ].! !

ROAbstractPopup subclass: #ROPopup
	instanceVariableNames: 'text textColor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROPopup class methodsFor: 'public' stamp: ''!
text: txtBlock
	^ self new text: txtBlock; yourself! !

!ROPopup methodsFor: 'creation' stamp: 'AlexandreBergel 4/29/2012 11:23'!
createElementFor: element
	^ ROElement new
			add: (ROElement new 
					+ ROBox
					+ ((ROLabel 
						text: (text roValue: element model)) color: textColor));
			yourself! !

!ROPopup methodsFor: 'initialization' stamp: 'AlexandreBergel 6/1/2012 18:27'!
initialize 
	super initialize.
	text := #yourself.
	textColor := Color white.
	! !

!ROPopup methodsFor: 'accessing' stamp: ''!
text
	^ text! !

!ROPopup methodsFor: 'accessing' stamp: ''!
text: anObject
	text := anObject! !

!ROPopup methodsFor: 'accessing' stamp: ''!
textColor
	^ textColor! !

!ROPopup methodsFor: 'accessing' stamp: ''!
textColor: anObject
	textColor := anObject! !

ROAbstractPopup subclass: #ROPopupView
	instanceVariableNames: 'view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROPopupView methodsFor: 'hooks' stamp: 'AlexandreBergel 6/3/2012 15:42'!
createElementFor: element
	| bitmap v extent encompassingRectangle |
	"We need here to have a proper extent here."
	v := (view roValue: element) view.
	encompassingRectangle := v encompassingRectangle.
	extent := encompassingRectangle corner asIntegerPoint + (2 @ 2).
	bitmap := v bitmapForSize: extent.
	^ ROElement new + (ROImage new form: bitmap)! !

!ROPopupView methodsFor: 'accessing' stamp: ''!
view
	^ view! !

!ROPopupView methodsFor: 'accessing' stamp: ''!
view: aView
	view := aView! !

ROInteraction subclass: #ROAnimation
	instanceVariableNames: 'nbCycles afterBlock remainingCycles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROAnimation methodsFor: 'hooks' stamp: ''!
after: aBlock
	afterBlock := aBlock! !

!ROAnimation methodsFor: 'hooks' stamp: ''!
defaultNumberOfCycles
	^ 10! !

!ROAnimation methodsFor: 'testing' stamp: ''!
hasCompleted 
	^ remainingCycles = 0! !

!ROAnimation methodsFor: 'initialization' stamp: ''!
initialize
	super initialize.
	nbCycles := self defaultNumberOfCycles.
	afterBlock := #yourself! !

!ROAnimation methodsFor: 'accessing' stamp: ''!
nbCycles
	^ nbCycles! !

!ROAnimation methodsFor: 'accessing' stamp: ''!
nbCycles: integer
	nbCycles := integer! !

!ROAnimation methodsFor: 'action' stamp: 'AlexandreBergel 4/30/2012 15:35'!
wait
	(Delay forMilliseconds: 3) wait.! !

!ROAnimation methodsFor: 'action' stamp: 'AlexandreBergel 4/30/2012 15:35'!
waitUntilDone
	[ self hasCompleted not ] whileTrue: [ self wait ]! !

ROAnimation subclass: #ROFocusView
	instanceVariableNames: 'increment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROFocusView methodsFor: 'hooks' stamp: ''!
defaultNumberOfCycles
	^ 100! !

!ROFocusView methodsFor: 'public' stamp: 'AlexandreBergel 5/6/2012 10:12'!
on: element view: view 
	"There is some duplication with ROLinearMove. Need to check!!!!!!"

	self toPosition: element position view: view! !

!ROFocusView methodsFor: 'public' stamp: 'AlexandreBergel 5/6/2012 10:12'!
toPosition: position view: view 
	"There is some duplication with ROLinearMove. Need to check!!!!!!"

	| camera destinationPoint |
	camera := view camera.
	[
	 destinationPoint := position - camera centerPosition.
	 increment := destinationPoint / nbCycles.
	 remainingCycles := nbCycles + 1.
	  nbCycles timesRepeat: [ 
		camera translateBy: increment.
		view signalUpdate.
		remainingCycles := remainingCycles - 1.
		(Delay forMilliseconds: 1) wait.
		].
	
	   "We do a translateTo: to erase the effect of rounded float"
	   "camera translateTo: destinationPoint."
	   remainingCycles := remainingCycles - 1. ] fork
! !

ROAnimation subclass: #ROIncrementalZoomMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROIncrementalZoomMove methodsFor: 'public' stamp: 'AlexandreBergel 4/30/2012 15:54'!
on: view
	| v |
	v := view camera bounds.
	v := (v origin + self step) corner: (v corner - self step).
	^ ROZoomMove new nbCycles: nbCycles; on: view to: v! !

ROIncrementalZoomMove subclass: #ROZoomInMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomInMove methodsFor: 'config' stamp: ''!
step
	^ 40 @ 40! !

ROIncrementalZoomMove subclass: #ROZoomOutMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomOutMove methodsFor: 'config' stamp: ''!
step
	^ -40 @ -40! !

ROAnimation subclass: #ROLinearMove
	instanceVariableNames: 'increment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROLinearMove commentStamp: 'AlexandreBergel 11/28/2011 10:50' prior: 0!
ROLinearMove moves an element in a number of cycles.

Example of usage:
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
	| view el |
	view := ROView new.
	el := ROElement sprite.
	view add: el.
	view on: ROMouseLeftClick do: [ :event | 
		ROLinearMove new
			nbCycles: 180;
			for: el until: event position.
	].
	view open.
-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=!

!ROLinearMove class methodsFor: 'public' stamp: ''!
for: element until: position
	^ self new for: element until: position! !

!ROLinearMove methodsFor: 'public' stamp: ''!
for: element until: position

	[
	 increment := ((position - element position) / nbCycles).
	 remainingCycles := nbCycles + 1.
	  nbCycles timesRepeat: [ 
		element translateBy: increment.
		element signalUpdate.
		remainingCycles := remainingCycles - 1.
		(Delay forMilliseconds: 1) wait.
		].
	   element translateTo: position.
	   remainingCycles := remainingCycles - 1. ] fork! !

ROAnimation subclass: #ROMotionMove
	instanceVariableNames: ''
	classVariableNames: 'RunningThreads'
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROMotionMove methodsFor: 'public' stamp: 'VanessaPena 5/11/2012 17:23'!
for: element initialSpeed: aPoint
	| process |
	aPoint isNil ifTrue: [ ^self].
	process := [
		| increment speed | 
		 increment := 1.
		speed := aPoint.
		[ speed r > 2 ] whileTrue:  [ 
			element translateBy: speed asIntegerPoint.
			speed := aPoint / increment.
			increment := increment + 1.
			element signalUpdate.
			(Delay forMilliseconds: 50) wait.
			].
		self runningThreads removeKey: element ifAbsent: [] ] fork.
	
	"Only one process per element. It does not make sense to have many"
	self runningThreads at: element ifPresent: [ :p | p terminate ].
	self runningThreads at: element put: process.

! !

!ROMotionMove methodsFor: 'util' stamp: ''!
runningThreads
	RunningThreads ifNil: [ RunningThreads := IdentityDictionary new ].
	^ RunningThreads! !

ROAnimation subclass: #ROZoomMove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomMove methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize.
	nbCycles := 50.! !

!ROZoomMove methodsFor: 'public' stamp: ''!
oldon: view to: finalRealBounds

	[
	| initialRealBounds incrementX1Y1 incrementX2Y2 topLeft bottomRight camera |
	camera := view camera.
	 initialRealBounds := camera bounds.
	incrementX1Y1 := ((finalRealBounds  topLeft - initialRealBounds topLeft) / nbCycles).
	incrementX2Y2 := ((finalRealBounds  bottomRight - initialRealBounds bottomRight) / nbCycles).
	 
	 topLeft := initialRealBounds topLeft.
	 bottomRight := initialRealBounds bottomRight.
	  nbCycles timesRepeat: [ 
		topLeft := topLeft + incrementX1Y1.
		bottomRight := bottomRight + incrementX2Y2.
		"Transcript show: (topLeft corner: bottomRight) printString; cr."
		camera virtualBounds: (topLeft asIntegerPoint corner: bottomRight asIntegerPoint).
		view signalUpdate.
		(Delay forMilliseconds: 10) wait.
		].
	   camera virtualBounds: finalRealBounds.
	   view signalUpdate.
	   afterBlock value.
	 ] fork! !

!ROZoomMove methodsFor: 'public' stamp: 'AlexandreBergel 4/30/2012 15:54'!
on: view to: finalRealBounds

	| initialRealBounds incrementX1Y1 incrementX2Y2 topLeft bottomRight camera animBlock animation |
	camera := view camera.
	 initialRealBounds := camera bounds.
	incrementX1Y1 := ((finalRealBounds  topLeft - initialRealBounds topLeft) / nbCycles).
	incrementX2Y2 := ((finalRealBounds  bottomRight - initialRealBounds bottomRight) / nbCycles).
	 
	 topLeft := initialRealBounds topLeft.
	 bottomRight := initialRealBounds bottomRight.
	
	 animBlock := [ 
		topLeft := topLeft + incrementX1Y1.
		bottomRight := bottomRight + incrementX2Y2.
		camera bounds: (topLeft asIntegerPoint corner: bottomRight asIntegerPoint).
		].
	animation := ROBeginingAnimation new animation: animBlock; nbCycles: nbCycles.

	view announce: animation.	
	^ animation
"	
	   camera virtualBounds: finalRealBounds.
	   view signalUpdate.
	   afterBlock value.
"
! !

ROInteraction subclass: #RODraggable
	instanceVariableNames: 'factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RODraggable methodsFor: 'accessing' stamp: 'AlexandreBergel 6/4/2012 23:53'!
factor
	^ factor! !

!RODraggable methodsFor: 'accessing' stamp: 'AlexandreBergel 6/4/2012 23:53'!
factor: anObject
	factor := anObject! !

!RODraggable methodsFor: 'initialize-release' stamp: 'AlexandreBergel 6/4/2012 23:51'!
initialize 
	super initialize.
	factor := 1 @ 1! !

!RODraggable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/4/2012 23:52'!
initializeElement: element
	 element on: ROMouseDragging do: [ :event | 
		element translateByRealPoint: (event step * factor).
		element signalUpdate ].! !

ROInteraction subclass: #RODraggableWithVelocity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!RODraggableWithVelocity methodsFor: 'initialization' stamp: 'AlexandreBergel 5/3/2012 16:45'!
initializeElement: element
	| lastStep lastTimeStamp |
	
	element on: ROMouseDragging do: [:event |
		lastStep := event step.
		lastTimeStamp := ROTimeOrganizer current milliseconds ].

	 element on: ROMouseDragged do: [ :event | 
		ROMotionMove new for: element initialSpeed: lastStep
		 ].! !

ROInteraction subclass: #ROExpandChildrenOnClick
	instanceVariableNames: 'childrenBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROExpandChildrenOnClick class methodsFor: 'instance creation' stamp: ''!
newCalculatingChildrenWith: aBlock

	^self new
		childrenBlock: aBlock;
		yourself.! !

!ROExpandChildrenOnClick methodsFor: 'initialization' stamp: ''!
addChildren: model to: element

	| newNode |
	newNode := ROLabelElement spriteOn: model.
	newNode @ (ROExpandChildrenOnClick newCalculatingChildrenWith: childrenBlock).
	element view add: newNode.
	element view add: ((ROEdge from: element to: newNode) + ROLine white).
	^ newNode! !

!ROExpandChildrenOnClick methodsFor: 'accessing' stamp: ''!
childrenBlock
	^ childrenBlock! !

!ROExpandChildrenOnClick methodsFor: 'accessing' stamp: ''!
childrenBlock: anObject
	childrenBlock := anObject! !

!ROExpandChildrenOnClick methodsFor: 'initialization' stamp: ''!
initializeElement: element

	element on: ROMouseClick do: [:event |
		| elements newElements roElements |
		
		newElements := childrenBlock value: element model.
		roElements := newElements collect: [:children | 
			self addChildren: children to: element].
		roElements do: [ :el | el translateTo: element position].


		elements := element view elementsSuchThat: #notNil.
		ROTreeLayout new
			translator: ROSmoothLayoutTranslator new;
			applyOn: elements.
			
		element signalUpdate. ].! !

ROInteraction subclass: #ROGrowable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROGrowable commentStamp: '<historical>' prior: 0!
A ROGrowable makes the object grow when clicking on it.
!

!ROGrowable methodsFor: 'initialization' stamp: ''!
initializeElement: element
	 element on: ROMouseClick do: [ :event | 
		ROGrow on: element by: 10.
		element signalUpdate ].! !

!ROInteraction class methodsFor: 'public' stamp: ''!
elementToBeAdded
	^ self new ! !

!ROInteraction class methodsFor: 'public' stamp: ''!
initializeElement: element
	^ self elementToBeAdded initializeElement: element; yourself! !

!ROInteraction methodsFor: 'accessing' stamp: ''!
elementToBeAdded
	^ self ! !

!ROInteraction methodsFor: 'hooks' stamp: ''!
initializeElement: element
	self subclassResponsibility ! !

ROInteraction subclass: #ROLightlyHighlightable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROLightlyHighlightable commentStamp: '<historical>' prior: 0!
A ROLightlyHighlightable is a decorator that highlights the element when the mouse is over it.!

!ROLightlyHighlightable class methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 10:02'!
highlightedColor
	^ Color blue! !

!ROLightlyHighlightable class methodsFor: 'configuration' stamp: 'AlexandreBergel 5/1/2012 09:59'!
unhighlightedColor
	^ Color gray! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 5/7/2012 11:54'!
highlightElement: element
	element shapesDo: [ :d | d color: self highlightedColor ]! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 5/1/2012 10:02'!
highlightedColor
	^ self class highlightedColor
	
! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 5/1/2012 10:06'!
initializeElement: element
	element
		on: ROMouseEnter
		do: [ 
			self highlightElement: element.
			element signalUpdate ].
	element
		on: ROMouseLeave
		do: [ 
			self unhighlightElement: element.
			element signalUpdate ].

	self unhighlightElement: element! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 5/7/2012 11:54'!
unhighlightElement: element
	element shapesDo: [ :d | d color: self unhighlightedColor ]! !

!ROLightlyHighlightable methodsFor: 'initialization' stamp: 'AlexandreBergel 5/1/2012 09:59'!
unhighlightedColor
	^ self class unhighlightedColor
! !

ROInteraction subclass: #ROMenuActivable
	instanceVariableNames: 'actions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROMenuActivable methodsFor: 'accessing' stamp: ''!
addActions: someActions
	actions addAll: someActions! !

!ROMenuActivable methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize.
	actions := OrderedCollection new.
	! !

!ROMenuActivable methodsFor: 'hooks' stamp: ''!
initializeElement: element
	^ (element is: self class)
		ifTrue: [ self installOnExistingInteractionOn: element ]
		ifFalse: [ self installHandlerOn: element]! !

!ROMenuActivable methodsFor: 'hooks' stamp: 'AlexandreBergel 4/26/2012 17:09'!
installHandlerOn: element
	element on: ROMouseRightClick do: [ :event |
		RONativeWidgetFactory current menuForAssociations: actions on: element
	]! !

!ROMenuActivable methodsFor: 'hooks' stamp: ''!
installOnExistingInteractionOn: element
	| el |
	el := (element getInteraction: ROMenuActivable).
	el addActions: actions.

	^ el! !

!ROMenuActivable methodsFor: 'accessing' stamp: ''!
item: titleAsString action: aBlockOrSymbol

	actions add: (titleAsString -> aBlockOrSymbol)! !

!ROMenuActivable methodsFor: 'accessing' stamp: ''!
numberOfEntries
	^ actions size! !

ROInteraction subclass: #ROScrollbable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROScrollbable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/5/2012 23:17'!
horizontalScrollbarFor: aStack

	| scrollbar view |
	
	view := aStack firstView.
	
	scrollbar := ROElement new.
	scrollbar width: 80.
	scrollbar height: 15.
	scrollbar + ROBox.
	
	scrollbar on: ROMouseDragging do: [ :event | 
		scrollbar translateByRealPoint: (event step * (1@0)).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: (aStack camera width - scrollbar width) @ 0).
		
		(scrollbar position x >= 0 and: [ scrollbar position x  <=  (aStack camera extent x - scrollbar width)])
			ifTrue: [ 
				| xView |
				xView := view encompassingRectangle width * scrollbar position x / view camera width negated.
				view translateTo: (xView @ view camera position y negated) asIntegerPoint ].
		scrollbar signalUpdate.
	].

"	view  on: ROMouseDragging do: [ :event | 
		| xView |
		xScroll := view encompassingRectangle width * scrollbar position x / view camera width negated.
		scrollbar translateTo: (xScroll @ 0).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: (aStack camera extent x - scrollbar width) @ 0).
	]."
 
	^ scrollbar! !

!ROScrollbable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/5/2012 17:58'!
initializeElement: aStack
	| view horizontalScrollbar verticalScrollbar |
	self assert: [ aStack isKindOf: ROViewStack ].
	 
	view := aStack firstView.
	
	horizontalScrollbar := self horizontalScrollbarFor: aStack.
	verticalScrollbar := self verticalScrollbarFor: aStack.
	
	aStack add: horizontalScrollbar.
	aStack add: verticalScrollbar.! !

!ROScrollbable methodsFor: 'hooks' stamp: 'AlexandreBergel 6/5/2012 23:18'!
verticalScrollbarFor: aStack

	| scrollbar view |
	
	view := aStack firstView.
	
	scrollbar := ROElement new.
	scrollbar width: 15.
	scrollbar height: 80.
	scrollbar + ROBox.
	
	scrollbar on: ROMouseDragging do: [ :event | 

		scrollbar translateByRealPoint: (event step * (0@1)).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: 0 @ (aStack camera extent y - scrollbar height)).
		
		(scrollbar position y >= 0 and: [ scrollbar position y  <=  (aStack camera extent y  - scrollbar height)])
			ifTrue: [ 
				| yView |
				yView := view encompassingRectangle height * scrollbar position y / view camera extent y  negated.
				view translateTo: (view camera position x negated @ yView) asIntegerPoint ].
		scrollbar signalUpdate.
	].

	view on: ROMouseDragging do: [ :event | 
		scrollbar translateBy: (event step negated * (0 @ 1)).
		scrollbar translateTo: (scrollbar position max: 0@0).
		scrollbar translateTo: (scrollbar position min: 0 @ aStack camera extent y - scrollbar height).
	].
 
	^ scrollbar! !

ROInteraction subclass: #ROZoomIntoElementOnClick
	instanceVariableNames: 'stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomIntoElementOnClick methodsFor: 'initialization' stamp: ''!
initializeElement: element
	
	 element on: ROMouseClick do: [:event | 
		| move |
		move := ROZoomMove new.
		move after: [ stack addLast: (ROView new add: ROElement sprite) ].
		move on: element view to: element bounds ] ! !

!ROZoomIntoElementOnClick methodsFor: 'accessing' stamp: ''!
stack
	^ stack! !

!ROZoomIntoElementOnClick methodsFor: 'accessing' stamp: ''!
stack: aStack
	stack := aStack! !

ROInteraction subclass: #ROZoomOnClick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROZoomOnClick methodsFor: 'initialization' stamp: ''!
initializeElement: element
	 | el isZoomed originalBounds |
	isZoomed := false.
	
	 element on: ROMouseClick do: [:event | 
		isZoomed 
			ifTrue: [ ROZoomMove new on: element view to: originalBounds ]
			ifFalse: [
				originalBounds := element view camera bounds.
				ROZoomMove new on: element view to: element bounds ].
		isZoomed := isZoomed not ].
	
! !

ROObject subclass: #ROLayout
	instanceVariableNames: 'affectedNodes translator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROLayout subclass: #ROAbstractLineLayout
	instanceVariableNames: 'gapSize horizontalGap verticalGap horizontalOutGap verticalOutGap alignment horizontallyStretchable verticallyStretchable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractLineLayout class methodsFor: 'instance creation' stamp: ''!
withGap: anInteger
	
	^(self new)
		gapSize: anInteger;
		yourself! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignBottom
	
	alignment := #bottom! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignCenter
	
	alignment := #center! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignLeft
	
	alignment := #left! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignRight
	
	alignment := #right! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignTop
	
	alignment := #top! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignment
	
	^alignment! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
alignment: anObject
	
	alignment := anObject! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
center
	self alignment: #center! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
deltaFor: aNodeFigure
	
	^self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
doCenter: aGraph
	self subclassResponsibility ! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:10'!
doExecute: aGraph 
	| pointer delta |
	pointer := self positionOriginalPointer: aGraph.
	aGraph do: 
		[ :element | 
		delta := self deltaFor: element.
		translator translate: element to: pointer - delta.
		self 
			movePointer: pointer
			accordingToFigure: element ].	

	horizontallyStretchable ifTrue: 
		[ self doStretchHorizontal: aGraph ].
	verticallyStretchable ifTrue: 
		[ self doStretchVertical: aGraph ]! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
doStretchHorizontal: aGraph 
	"this method is executed after translating nodes"
	
 	| max parentBounds |
	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	max := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: el bounds width ].

	((parentBounds width >= max) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodes do: [ :node | 
						node bounds width: (parentBounds width - (2 * horizontalOutGap)).
						(node layout isLineLayout and: [ node layout horizontallyStretchable ])
							ifTrue: [ node layout doStretchHorizontal: node ]
					] ]
		ifFalse: [ aGraph nodes do: [ :node | node bounds width: max ] ]
	 
! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
doStretchVertical: aGraph 
	"this method is executed after translating nodes"

 	| max parentBounds |
	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	max := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: el bounds height ].

	((parentBounds height >= max) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodes do: [ :node | 
						node bounds height: (parentBounds height - (2 * verticalOutGap) ).
						(node layout isLineLayout and: [ node layout verticallyStretchable])
							ifTrue: [ node layout doStretchVertical: node ]
					] ]
		ifFalse: [ aGraph nodes do: [ :node | node bounds height: max ] ]! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
gapSize
	
	^gapSize! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
gapSize: aNumber
	gapSize := aNumber. " This value is never used actually "
	
	verticalGap := 2 * aNumber.
	horizontalGap := 2 * aNumber.
	verticalOutGap := aNumber.
	horizontalOutGap := aNumber! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalGap
	
	^horizontalGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalGap: anObject
	
	horizontalGap := anObject! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalOutGap
	
	^horizontalOutGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
horizontalOutGap: anObject
	
	horizontalOutGap := anObject! !

!ROAbstractLineLayout methodsFor: 'testing' stamp: ''!
horizontallyStretchable
	^ horizontallyStretchable! !

!ROAbstractLineLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	verticalGap := 10.
	horizontalGap := 10.
	horizontalOutGap := 5.
	verticalOutGap := 5.
	horizontallyStretchable := verticallyStretchable := false! !

!ROAbstractLineLayout methodsFor: 'testing' stamp: ''!
isLineLayout
	^ true! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
movePointer: pointer accordingToFigure: aNodeFigure
	
	self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'hook' stamp: ''!
positionOriginalPointer: aGraph
	
	^self subclassResponsibility! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
stretch
	horizontallyStretchable := verticallyStretchable := true! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
stretchHorizontally
	horizontallyStretchable := true! !

!ROAbstractLineLayout methodsFor: 'configuration' stamp: ''!
stretchVertically
	verticallyStretchable := true! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalGap
	
	^verticalGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalGap: anObject
	
	verticalGap := anObject! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalOutGap
	
	^verticalOutGap! !

!ROAbstractLineLayout methodsFor: 'accessing' stamp: ''!
verticalOutGap: anObject
	
	verticalOutGap := anObject! !

!ROAbstractLineLayout methodsFor: 'testing' stamp: ''!
verticallyStretchable
	^ verticallyStretchable! !

ROAbstractLineLayout subclass: #ROHorizontalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #bottom ifTrue: [delta := aNodeFigure height].
	self alignment == #center ifTrue: [delta := aNodeFigure height / 2.0].
	^0 @ delta! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
doCenter: aGraph 

 	| midTallest step |
	midTallest := 0.
	midTallest := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds height )].
	midTallest := midTallest / 2.
	aGraph nodes do: [ :node | 
		step := 0@ (midTallest - (node bounds height /2)) asInteger.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:11'!
doExecute: aGraph 
	| pointer delta |
	pointer := self positionOriginalPointer: aGraph.
	horizontallyStretchable ifTrue: 
		[ self doStretchHorizontal: aGraph ].
	aGraph do: 
		[ :element | 
		delta := self deltaFor: element.
		translator translate: element to: pointer - delta.
		pointer := self 
					movePointer: pointer
					accordingToFigure: element ].	

	verticallyStretchable ifTrue: 
		[ self doStretchVertical: aGraph ]! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
doStretchHorizontal: aGraph 

 	| parentBounds addedWidth parentBoundsWidth runningIndex newWidth origin |

	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	addedWidth := aGraph nodes 
		inject: 0
		into: [ :m :el | m + el width ].

	parentBoundsWidth := parentBounds width.
	parentBoundsWidth := parentBoundsWidth - ((aGraph nodes size - 1) * horizontalGap) - (2 * horizontalOutGap).
	
	runningIndex := horizontalOutGap.
	((parentBounds width > addedWidth) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodesDo: [ :node | 
						newWidth := (node width * parentBoundsWidth / addedWidth) asInteger.
						origin := node bounds origin.
						node bounds 
								origin: (runningIndex @ origin y) ;
								width: newWidth.
						runningIndex := runningIndex + newWidth + horizontalGap ] ]
! !

!ROHorizontalLineLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	self alignTop! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
movePointer: pointer accordingToFigure: element
	
	^ (pointer x + element width + self horizontalGap) @ pointer y! !

!ROHorizontalLineLayout methodsFor: 'hook' stamp: ''!
positionOriginalPointer: aGraph 
	| maxHeight delta |
	delta := 0.
	self alignment == #bottom ifTrue: 
		[ maxHeight := aGraph nodes maxValue: #height.
		delta := maxHeight ].
	self alignment == #center ifTrue: 
		[ maxHeight := aGraph nodes maxValue: #height.
		delta := maxHeight / 2.0 ].
	^ self horizontalOutGap @ (self verticalOutGap + delta)! !

ROAbstractLineLayout subclass: #ROVerticalLineLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
deltaFor: aNodeFigure
	
	| delta |
	delta := 0.
	self alignment == #right ifTrue: [delta := aNodeFigure width].
	self alignment == #center ifTrue: [delta := aNodeFigure width / 2.0].
	^delta @ 0! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
doCenter: aGraph 

 	| midWidest step |
	midWidest := aGraph nodes 
		inject: 0
		into: [ :m :el | m max: (el bounds width )].
	midWidest := midWidest / 2.
	aGraph nodes do: [ :node | 
		step := (midWidest - (node bounds width /2)) asInteger @ 0.
		node bounds origin: (node bounds origin + step).
		node bounds corner: (node bounds corner + step).
	] 
! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
doStretchVertical: aGraph 

 	| parentBounds addedHeight parentBoundsHeight runningIndex newHeight origin |

	parentBounds := aGraph bounds.
	(parentBounds extent = (0@0))
		ifTrue: [ parentBounds := aGraph shape computeBoundsFor: aGraph ].

	addedHeight := aGraph nodes 
		inject: 0
		into: [ :m :el | m + el height ].

	parentBoundsHeight := parentBounds height.
	parentBoundsHeight := parentBoundsHeight - ((aGraph nodes size - 1) * verticalGap) - (2 * verticalOutGap).
	
	runningIndex := verticalOutGap.
	((parentBounds height > addedHeight) and: [aGraph isRoot not])
		ifTrue: [ aGraph nodesDo: [ :node | 
						newHeight := (node height * parentBoundsHeight / addedHeight) asInteger.
						origin := node bounds origin.
						node bounds 
								origin: (origin x @ runningIndex) ;
								height: newHeight.
						runningIndex := runningIndex + newHeight + verticalGap ] ]
! !

!ROVerticalLineLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	self alignLeft! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
movePointer: pointer accordingToFigure: aNodeFigure
	
	^pointer setX: pointer x setY: pointer y + aNodeFigure height + self verticalGap! !

!ROVerticalLineLayout methodsFor: 'hook' stamp: ''!
positionOriginalPointer: elements 
	| maxWidth delta |
	delta := 0.
	self alignment == #right ifTrue: 
		[ maxWidth := elements maxValue: #width.
		delta := maxWidth ].
	self alignment == #center ifTrue: 
		[ maxWidth := elements maxValue: #width.
		delta := maxWidth / 2.0 ].
	^ (self horizontalOutGap + delta) @ self verticalOutGap! !

ROLayout subclass: #ROCircleLayout
	instanceVariableNames: 'factor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROCircleLayout class methodsFor: 'instance creation' stamp: ''!
scaleBy: aNumber
	
	^self new scaleBy: aNumber! !

!ROCircleLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:09'!
doExecute: elements
	
	| angleTemp angle rad center |
	rad := elements size * self scaleFactor.
	center := Point x: rad y: rad.
	angleTemp := 2 * Float pi / elements size.
	angle := 0.
	elements
		do:
			[:each | 
			| point |
			point := center + (Point radius: rad theta: angle).
			angle := angle + angleTemp.
			translator translate: each to: point ]! !

!ROCircleLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver."
	
	super initialize.
	self scaleBy: 11! !

!ROCircleLayout methodsFor: 'accessing' stamp: ''!
scaleBy: aNumber
	
	factor := aNumber! !

!ROCircleLayout methodsFor: 'accessing' stamp: ''!
scaleFactor
	
	^factor! !

ROLayout subclass: #ROEdgeDrivenLayout
	instanceVariableNames: 'edges userDefinedEdges fromPositions toPositions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

ROEdgeDrivenLayout subclass: #ROAbstractFlowLayout
	instanceVariableNames: 'maxWidth gapSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractFlowLayout class methodsFor: 'instance creation' stamp: ''!
withMaxWidth: anInteger
	
	^(self new)
		maxWidth: anInteger;
		yourself! !

!ROAbstractFlowLayout class methodsFor: 'instance creation' stamp: ''!
withMaxWidth: anInteger withGap: anotherInteger
	
	^(self new)
		maxWidth: anInteger;
		gapSize: anotherInteger;
		yourself! !

!ROAbstractFlowLayout methodsFor: 'accessing' stamp: ''!
gapSize
	
	^gapSize! !

!ROAbstractFlowLayout methodsFor: 'accessing' stamp: ''!
gapSize: anObject
	
	gapSize := anObject! !

!ROAbstractFlowLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	maxWidth := 100.
	gapSize := 5! !

!ROAbstractFlowLayout methodsFor: 'private' stamp: ''!
maxWidth
	
	^maxWidth! !

!ROAbstractFlowLayout methodsFor: 'accessing' stamp: ''!
maxWidth: anObject
	
	maxWidth := anObject! !

ROAbstractFlowLayout subclass: #ROBottomFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROBottomFlowLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:17'!
doExecute: nodeElements 
	| x y maxLastLineHeight lineHeights lineNumber |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	lineHeights := OrderedCollection new.
	lineNumber := 1.
	nodeElements do: 
		[ :aNodeFigure | 
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ lineHeights addLast: maxLastLineHeight.
			x := self gapSize.
			maxLastLineHeight := 0 ] ].
	lineHeights addLast: maxLastLineHeight.
	x := self gapSize.
	nodeElements do: 
		[ :aNodeFigure | 
		| lineHeight |
		lineHeight := lineHeights at: lineNumber.
		translator translate: aNodeFigure to: x @ (y + lineHeight - aNodeFigure height).
		x := x + aNodeFigure width + (2 * self gapSize).
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + lineHeight.
			lineNumber := lineNumber + 1 ] ]! !

ROAbstractFlowLayout subclass: #ROFlowLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROFlowLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:18'!
doExecute: nodeElements 
	| x y maxLastLineHeight |
	x := self gapSize.
	y := self gapSize.
	maxLastLineHeight := 0.
	nodeElements do: 
		[ :aNodeFigure | 
		translator translate: aNodeFigure to: x @ y.
		x := x + aNodeFigure width + (2 * self gapSize).
		maxLastLineHeight := maxLastLineHeight max: aNodeFigure height.
		x > self maxWidth ifTrue: 
			[ x := self gapSize.
			y := y + (2 * self gapSize) + maxLastLineHeight.
			maxLastLineHeight := 0 ] ]! !

ROEdgeDrivenLayout subclass: #ROAbstractGraphLayout
	instanceVariableNames: 'verticalGap horizontalGap cachedChildren cachedParents cachedParentsWithHighestNestings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractGraphLayout class methodsFor: 'constants' stamp: ''!
horizontalGap
	
	^3.0! !

!ROAbstractGraphLayout class methodsFor: 'public' stamp: ''!
on: elements edges: edges
	"Do the layout of the elements tacking into account the provided edges"

	^ self new 
		userDefinedEdges: edges;
		applyOn: elements.! !

!ROAbstractGraphLayout class methodsFor: 'constants' stamp: ''!
verticalGap
	
	^20.0! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
cachedChildren
	
	cachedChildren ifNil: [cachedChildren := IdentityDictionary new: 1000].
	^cachedChildren! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
cachedParents
	
	cachedParents ifNil: [cachedParents := IdentityDictionary new: 1000].
	^cachedParents! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
cachedParentsWithHighestNestings
	
	cachedParentsWithHighestNestings
		ifNil: [cachedParentsWithHighestNestings := IdentityDictionary new: 1000].
	^cachedParentsWithHighestNestings! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
childrenFor: aNode
	
	^self cachedChildren
		at: aNode
		ifAbsentPut:
			[| nodes |
			nodes := OrderedCollection new.
			self edgesDo:
					[:edge | 
					(edge from == aNode and: [edge to ~= aNode])
						ifTrue:
							[(nodes includes: edge from) ifFalse: [nodes add: edge to]]].
			nodes]! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
childrenFor: aNode except: aNodeCollection
	
	^(self childrenFor: aNode) difference: aNodeCollection! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
childrenWithHighestNestingLevelFor: aNode
	
	^(self childrenFor: aNode)
		select: [:eachChild | (self highestNestingParentFor: eachChild) == aNode]! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
clear
	
	cachedParents := nil.
	cachedChildren := nil.
	cachedParentsWithHighestNestings := nil! !

!ROAbstractGraphLayout methodsFor: 'default values' stamp: ''!
defaultFromPositions
	
	^#(#bottomCenter)! !

!ROAbstractGraphLayout methodsFor: 'default values' stamp: ''!
defaultToPositions
	
	^#(#topCenter)! !

!ROAbstractGraphLayout methodsFor: 'hook' stamp: ''!
doInitialize: elements 
	super doInitialize: elements.
	self clear.
	self greedyCycleRemoval: elements! !

!ROAbstractGraphLayout methodsFor: 'battista' stamp: ''!
greedyCycleRemoval: aCollection
	"Di Battista Greedy-Cycle-Removal algorithm. Chapter 9.4, page 297. The last part is not like in the book. The original algorithm only takes
	 local optimas into account. This will break ordinary trees sometimes. This version also takes global optimas into account."
	
	| g sl sr s indeg outdeg degrees vertex |
	g := aCollection copy asOrderedCollection.
	sl := OrderedCollection new.
	sr := OrderedCollection new.	"While g contains a sink (aka leaf)"
	g copy
		do:
			[:node | 
			(self childrenFor: node) isEmpty
				ifTrue:
					[sr addFirst: node.
					g remove: node]	"self edges detect: [:edge | edge fromFigure == node] ifNone: [sr addFirst: node. g remove: node]"].	"While g contains a source (aka root)"
	g copy
		do:
			[:node | 
			(self parentsFor: node) isEmpty
				ifTrue:
					[sl addLast: node.
					g remove: node]	"self edges detect: [:edge | edge toFigure == node] ifNone: [sl addLast: node. g remove: node]"].	"Calculate deg for all remaining vertices"
	degrees := IdentityDictionary new.
	g
		do:
			[:node | 
			indeg := (self parentsFor: node) size.
			outdeg := (self childrenFor: node) size.	"indeg := self edges inject: 0 into: [:sum :edge | (edge toFigure == node) ifTrue: [sum + 1] ifFalse: [sum]].
		outdeg := self edges inject: 0 into: [:sum :edge | (edge fromFigure == node) ifTrue: [sum + 1] ifFalse: [sum]]."
			degrees
				at: node
				put: outdeg - indeg].	"While g not empty"
	g := g asSortedCollection: [:a :b | (degrees at: a) >= (degrees at: b)].
	[g isEmpty]
		whileFalse:
			[vertex := g
				detect: [:v | (self parentsFor: v) anySatisfy: [:w | sl includes: w]]
				ifNone: [g first].	"Corner case: Closed cycle with not root at all. Eg 1 -> 2 -> 3 -> 1"
			sl addLast: vertex.
			g remove: vertex].	"Remove all leftward edges"
	s := sl , sr.
	self edges notNil
		ifTrue: 
			[ self edges copy
				do:
					[:edge | 
					(s indexOf: edge source) > (s indexOf: edge target)
						ifTrue: [self edges remove: edge ] ] ].	
	"Reset the cache"
	self clear! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
highestNestingParentFor: aNodeFigure
	
	| parents |
	^self cachedParentsWithHighestNestings
		at: aNodeFigure
		ifAbsentPut:
			[parents := self parentsFor: aNodeFigure.
			parents isEmpty
				ifTrue: [0]
				ifFalse:
					[parents detectMax: [:eachParent | self nestingLevelFor: eachParent]]]! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
horizontalGap
	
	^horizontalGap ifNil: [self class horizontalGap]! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
horizontalGap: anInteger
	
	horizontalGap := anInteger! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
nestingLevelFor: aNodeFigure
	
	| parents parentsNesting |
	parents := self parentsFor: aNodeFigure.
	parentsNesting := parents
		collect: [:eachParent | self nestingLevelFor: eachParent].
	^parentsNesting isEmpty
		ifTrue: [0]
		ifFalse: [parentsNesting max + 1]
! !

!ROAbstractGraphLayout methodsFor: 'actions' stamp: ''!
on: el edges: edgs
	"Do the layout of the elements tacking into account the provided edges"

	^ self 
		userDefinedEdges: edgs;
		applyOn: el.! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: ''!
parentsFor: aNode
	^ self cachedParents
		at: aNode
		ifAbsentPut:
			[ | nodes |
			nodes := OrderedCollection new.
			self edgesDo:
					[:edge | edge to == aNode ifTrue: [ nodes add: edge from ] ].
			nodes ]! !

!ROAbstractGraphLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:18'!
rootNodesFor: aCollection
	^ aCollection select: [:node | (self parentsFor: node) isEmpty ].
	! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
verticalGap
	
	^verticalGap ifNil: [self class verticalGap]! !

!ROAbstractGraphLayout methodsFor: 'accessing' stamp: ''!
verticalGap: anInteger
	
	verticalGap := anInteger! !

ROAbstractGraphLayout subclass: #ROAbstractRegularTreeLayout
	instanceVariableNames: 'alreadyLayoutedNodes topGap leftGap nodesByLayer isLayered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractRegularTreeLayout methodsFor: 'private' stamp: ''!
atLayer: aNumber add: aNodeCollection
	| collection |
	collection := nodesByLayer at: aNumber ifAbsentPut: [OrderedCollection new].
	collection addAll: aNodeCollection! !

!ROAbstractRegularTreeLayout methodsFor: 'hook' stamp: ''!
doExecute: elements
	| rootNodes |
	alreadyLayoutedNodes := OrderedCollection new.
	rootNodes := self rootNodesFor: elements.
	nodesByLayer := OrderedCollection new.
	self
		layout: rootNodes
		atPoint: self leftGap @ self topGap
		atLayer: 1.
	self isLayered ifTrue: [
		self rearrangeByLayers: elements ]! !

!ROAbstractRegularTreeLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	topGap := 5.
	leftGap := 5.
	isLayered := false! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
isLayered
	"Is the layout layered"
	
	^ isLayered! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
isLayered: boolean
	"Is the layout layered"
	
	isLayered := boolean! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
layered
	self isLayered: true! !

!ROAbstractRegularTreeLayout methodsFor: 'hook-private' stamp: ''!
layout: aNodeCollection atPoint: aPoint atLayer: anObject
	self subclassResponsibility! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
leftGap
	^ leftGap! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
leftGap: anInteger
	leftGap := anInteger! !

!ROAbstractRegularTreeLayout methodsFor: 'private' stamp: ''!
rearrangeByLayers: aGraph
	self subclassResponsibility! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
topGap
	^ topGap! !

!ROAbstractRegularTreeLayout methodsFor: 'accessing' stamp: ''!
topGap: anInteger
	topGap := anInteger! !

ROAbstractRegularTreeLayout subclass: #ROAbstractVerticalTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: ''!
computeChildrenFor: aNode
	self subclassResponsibility! !

!ROAbstractVerticalTreeLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	verticalGap := 20.
	horizontalGap := 3! !

!ROAbstractVerticalTreeLayout methodsFor: 'hook-private' stamp: ''!
layout: aNodeCollection atPoint: aPoint atLayer: aNumber
	| treeSize childrenPosition x y middleOfTree |
	aNodeCollection isEmpty ifTrue: [ ^ 0 ].
	x := aPoint x.
	y := aPoint y.
	alreadyLayoutedNodes addAll: aNodeCollection.
	self atLayer: aNumber add: aNodeCollection.
	aNodeCollection do: [ :each | 
		childrenPosition := y + each height + self verticalGap.
		treeSize := each width
			max: (self layout: (self computeChildrenFor: each) atPoint: x @ childrenPosition atLayer: aNumber + 1).
		middleOfTree := x + (treeSize / 2.0) - (each width / 2.0).
		translator translate: each to: middleOfTree @ y.
		x := x + treeSize + self horizontalGap ].
	^ x - aPoint x - self horizontalGap! !

!ROAbstractVerticalTreeLayout methodsFor: 'private' stamp: ''!
rearrangeByLayers: aGraph
	| cursor layerDepthSize |
	cursor := self topGap.
	nodesByLayer do: [:eachSetOfNodes |
		layerDepthSize := eachSetOfNodes inject: 0 into: [:max :eachNode | 
			eachNode translateTo: (eachNode absoluteBounds left @ cursor ).
			max max: eachNode height ].
		cursor := cursor + layerDepthSize + self verticalGap ]! !

ROAbstractVerticalTreeLayout subclass: #ROTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROTreeLayout methodsFor: 'hook-private' stamp: ''!
computeChildrenFor: aNode
	^ self childrenFor: aNode except: alreadyLayoutedNodes! !

ROAbstractGraphLayout subclass: #RORadialTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!RORadialTreeLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/17/2012 20:19'!
doExecute: nodeElements 
	"	| rootNodes top left |
	top := left := Unlimited positive.
	rootNodes := self rootNodesFor: aGraph nodeFigures.
	self layoutLayer: rootNodes radius: 5 from: 0 to: (2 * Double pi).
	aGraph nodeFigures do: [:each | 
		top := top min: each bounds top. 
		left := left min: each bounds left.].
	aGraph nodeFigures do: [:each | 
		each translateBy: ((0 - left)) @ ((0 - top)).
	].


"
	| rootNodes maximumRadius xOffset |

	rootNodes := self rootNodesFor: nodeElements.
	xOffset := 0.
	rootNodes do: 
		[ :node | 
		node translateTo: 0 @ 0.	"Move the node to the origin of the coordinate system"
		maximumRadius := self 
			layoutLayer: (self childrenFor: node)
			radius: node radius
			from: 0
			to: 2 * Float pi.
		self 
			shiftTree: node
			by: (maximumRadius + xOffset) @ maximumRadius.
		xOffset := xOffset + (2 * maximumRadius) ]! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
gap
	
	^self verticalGap! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
layoutLayer: aCollection radius: oldRadius from: aFromAngle to: aToAngle
	
	| delta childRadius maximumRadius myRadius fromAngle toAngle |
	"Initialize with default value"
	maximumRadius := oldRadius.
	aCollection isEmpty
		ifFalse:
			[myRadius := oldRadius + self gap + (self maximumRadius: aCollection).
			childRadius := oldRadius + self gap + (self maximumDiameter: aCollection).	"This is a purely optical tweak"
			(aCollection size = 1 and: [aToAngle - aFromAngle = (2 * Float pi)])
				ifTrue:
					[delta := 0.4 * Float pi.
					fromAngle := 0.8 * Float pi.
					toAngle := fromAngle + delta]
				ifFalse:
					[delta := (aToAngle - aFromAngle) / aCollection size.
					fromAngle := aFromAngle.
					toAngle := aFromAngle + delta].
			aCollection
				do:
					[:child | 
					child
						translateTo:
							(Point
								r: myRadius
								theta: toAngle - (delta / 2.0)).
					maximumRadius := maximumRadius
						max:
							(self
								layoutLayer: (self childrenFor: child)
								radius: childRadius
								from: fromAngle
								to: toAngle).
					fromAngle := toAngle.
					toAngle := toAngle + delta]].
	^maximumRadius! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:23'!
maximumDiameter: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: (node radius * 2) ]
 ! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
maximumRadius: aCollection
	
	^aCollection
		inject: 0
		into: [:max :node | max max: node radius]! !

!RORadialTreeLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/17/2012 20:07'!
shiftTree: aNode by: aPoint
	
	aNode translateBy: aPoint.
	(self childrenFor: aNode) do: [:child | self shiftTree: child by: aPoint]! !

ROAbstractGraphLayout subclass: #ROSugiyamaLayout
	instanceVariableNames: 'sortBlock labels layers layerNrs connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROSugiyamaLayout class methodsFor: 'utils' stamp: ''!
sortBlock
	
	^ ROSortBlock new! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/3/2012 19:38'!
addDummyNodes
	
	| layer layerNr |
	connections := ROIdentityMatrix new.
	self edgesDo:
			[:edge | 
			| a b span fromNode toNode |
			"edge hints removeAll."
			a := layerNrs at: edge source.
			b := layerNrs at: edge target.
			span := (a - b) abs.
			span = 1
				ifTrue:
					[connections
						at: edge source
						at: edge target
						put: true].	"Normal case where nodes are in adjacent layers"
			fromNode := edge source.
			[span > 1]
				whileTrue:
					[span := span - 1.
					layerNr := b + span.
					layer := layers at: layerNr.
					toNode := RODummyNode
						on: edge
						slot: a - span.
					layer add: toNode.
					layerNrs at: toNode put: layerNr.
					connections at: fromNode at: toNode put: true.
					fromNode := toNode].
			(a - b) abs > 1
				ifTrue:
					[connections
						at: fromNode
						at: edge target
						put: true]]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 4/19/2012 08:45'!
assignLabels: aNodeCollection 
	"Initialize label dictionary"
	| label vertices parentLabels |
	labels := IdentityDictionary new.
	label := 1.	"Assign labels to the roots"
	(self rootNodesFor: aNodeCollection) do: 
		[ :node | 
		labels 
			at: node
			put: label.
		label := label + 1 ].	"Assign labels to the rest"
	[ labels keys size < aNodeCollection size ] whileTrue: 
		[ vertices := SortedCollection sortBlock: self sortBlock.
		aNodeCollection do: 
			[ :node | 
			(labels includesKey: node) ifFalse: 
				[ parentLabels := ((self parentsFor: node) collect: 
					[ :pn | 
					labels 
						at: pn
						ifAbsent: [ self maxFloat ] ]) asSortedCollection.
				parentLabels last ~= self maxFloat ifTrue: [ vertices add: node -> parentLabels ] ] ].
		labels 
			at: vertices first key
			put: label.
		label := label + 1 ]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 4/19/2012 08:45'!
buildLayers: g
	
	| w layerNr u vertices vertex layer done |
	w := self maxFloat.
	u := OrderedCollection new.
	layers := IdentityDictionary new.
	layerNrs := IdentityDictionary new.	"Assign all nodes to layers"
	[g isEmpty]
		whileFalse:
			[vertices := g
				select:
					[:e | (self childrenFor: e) allSatisfy: [:node | u includes: node]].
			vertex := vertices detectMax: [:e | labels at: e].
			done := false.
			layerNr := 1.
			[done]
				whileFalse:
					[layer := layers
						at: layerNr
						ifAbsentPut: [OrderedCollection new].
					(layer size >= w
						or:
							[(self childrenFor: vertex) anySatisfy: [:n | (layerNrs at: n) >= layerNr]])
						ifTrue: [layerNr := layerNr + 1]
						ifFalse: [done := true]].
			layer add: vertex.
			layerNrs at: vertex put: layerNr.
			u add: vertex.
			g remove: vertex]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: ''!
cl: layer u: u v: v
	"Calculates cuv. Di Battista, chapter 9.2.2, page 283"
	
	| partnersOfU partnersOfV c partnersOfUIndex partnersOfVIndex layerNr |
	layerNr := layerNrs at: u.	":= layerNrs at: v"
	partnersOfU := (connections at: u)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	partnersOfV := (connections at: v)
		select: [:each | (layerNrs at: each) = (layerNr - 1)].
	c := 0.
	partnersOfUIndex := partnersOfU collect: [:node | layer indexOf: node].
	partnersOfVIndex := partnersOfV collect: [:node | layer indexOf: node].
	partnersOfUIndex
		do:
			[:uIndex | partnersOfVIndex do: [:vIndex | vIndex < uIndex ifTrue: [c := c + 1]]].
	^c! !

!ROSugiyamaLayout methodsFor: 'hook' stamp: ''!
doExecute: aNodeCollection 
	"Coffman-Graham-Layering. Di Battista Book, page 275, chapter, 9.2.1"
	self assignLabels: aNodeCollection.
	self buildLayers: aNodeCollection copy.
	self addDummyNodes.
	self reduceCrossing.
	self layoutAt: self verticalGap @ self horizontalGap! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:15'!
layoutAt: aPoint
	
	| treeWidth layerKeys layer layerWidth horizontalPosition verticalPosition layerHeight |
	treeWidth := layers values
		inject: self maxFloat negated
		into:
			[:max :e | max max: (e sum: #width) + ((e size - 1) * self horizontalGap)].
	verticalPosition := self horizontalGap.	"For visual reasons NOT: self class verticalGap"
	layerKeys := layers keys asSortedCollection reverse.
	layerKeys
		do:
			[:aKey | 
			layer := layers at: aKey.
			layerWidth := (layer sum: #width)
				+ ((layer size - 1) * self horizontalGap).
			layerHeight := (layer detectMax: #height) height.
			horizontalPosition := treeWidth / 2.0 + aPoint x - (layerWidth / 2.0).
			layer
				do:
					[:node | 
					translator translate: node to:  horizontalPosition @ verticalPosition.
					
					horizontalPosition := horizontalPosition + node width
						+ self horizontalGap].
			verticalPosition := verticalPosition + layerHeight + self verticalGap]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 4/19/2012 08:44'!
maxFloat
	^ 1e10! !

!ROSugiyamaLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/3/2012 19:16'!
reduceCrossing
	"Crossing reduction"
	
	| layer2 u v c1 c2 layer1 done |
	2
		to: layers keys size
		do:
			[:index | 
			layer1 := layers at: index - 1.
			layer2 := layers at: index.
			done := false.
			[done]
				whileFalse:
					[done := true.
					2
						to: layer2 size
						do:
							[:i | 
							u := layer2 at: i - 1.
							v := layer2 at: i.
							c1 := self cl: layer1 u: u v: v.
							c2 := self cl: layer1 u: v v: u.
							c1 > c2
								ifTrue:
									[layer2 roSwapElement: u withElement: v.
									done := false]]]]! !

!ROSugiyamaLayout methodsFor: 'private' stamp: ''!
sortBlock
	
	sortBlock isNil ifTrue: [ sortBlock := self class sortBlock ].
	^sortBlock! !

!ROEdgeDrivenLayout class methodsFor: 'instance creation' stamp: ''!
withEdges: aCollection
	
	^self new initialize userDefinedEdges: aCollection! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
affectedNodes
	
	^affectedNodes! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
affectedNodes: anObject
	
	affectedNodes := anObject! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
affectedNodesOf:  aNode 
	^ affectedNodes ifNil: [ aNode nodes ]! !

!ROEdgeDrivenLayout methodsFor: 'adjusting' stamp: ''!
defaultAdjustHeightFor: childrenBounds and: myBounds
	
	| deltaY |
	deltaY := childrenBounds top - myBounds top.
	^childrenBounds height + (2 * deltaY)! !

!ROEdgeDrivenLayout methodsFor: 'adjusting' stamp: ''!
defaultAdjustWidthFor: childrenBounds and: myBounds
	
	| deltaX |
	deltaX := childrenBounds left - myBounds left.
	^childrenBounds width + (2 * deltaX)! !

!ROEdgeDrivenLayout methodsFor: 'default values' stamp: ''!
defaultFromPositions
	^ #()
	! !

!ROEdgeDrivenLayout methodsFor: 'default values' stamp: ''!
defaultToPositions
	^ #()
! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: ''!
doExecute: aGraphElement
	
	self subclassResponsibility! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: ''!
doIncrementallyExecute: anElementNode
	"called by refreshLayoutEvery: ms. It is used to convey a feeling of incremental execution."
	
	self doExecute: anElementNode! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: ''!
doInitialize: elements
	
	super doInitialize: elements.
	"elements edgesDo: [ :edge | edge isVisible: true ]"! !

!ROEdgeDrivenLayout methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 5/22/2012 13:59'!
doPost: elements
	"Hook method"
! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
edges
	
	^edges! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
edges: aCollection
	
	edges := aCollection! !

!ROEdgeDrivenLayout methodsFor: 'iterator' stamp: ''!
edgesDo: aBlock
	"Iterates over all the edges of the receiver."
	
	edges ifNil: [ ^ self ].
	edges do: aBlock
! !

!ROEdgeDrivenLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/18/2012 16:03'!
executeOnElements: elements 
	"Execute the layout, myself, on the elements"

	self userDefinedEdges isNil 
		ifTrue: [ self setEdgesFromElements: elements ]
		ifFalse: 
			[ | flat |
			flat := OrderedCollection new.
			self userDefinedEdges do: 
				[ :each | 
				each isCollection 
					ifTrue: [ flat addAll: each ]
					ifFalse: [ flat add: each ] ].
			self edges: flat ].
		
	super executeOnElements: elements! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
fromPositions
	
	^fromPositions ifNil: [fromPositions := self defaultFromPositions]! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
fromPositions: anArray
	
	fromPositions := anArray! !

!ROEdgeDrivenLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialization"
	super initialize.
	edges := nil! !

!ROEdgeDrivenLayout methodsFor: 'testing' stamp: ''!
isLineLayout
	^ false! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 15:55'!
setEdgesFromElements: elements 
	| view |
	elements isEmpty ifTrue: [ ^ self ].
	self assert: [ (elements collect: #view) asSet size = 1 ].
	
	elements isEmpty ifTrue: [ ^ self ].
	
	view := elements first view.
	self edges: (view elementsSuchThat: [ :el | ((el isKindOf: ROEdge) and: [ elements includes: el from ]) and: [ elements includes: el to ] ]).
	! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
toPositions
	
	^toPositions ifNil: [toPositions := self defaultToPositions]! !

!ROEdgeDrivenLayout methodsFor: 'accessing' stamp: ''!
toPositions: anArray
	
	toPositions := anArray! !

!ROEdgeDrivenLayout methodsFor: 'private' stamp: ''!
userDefinedEdges
	
	^userDefinedEdges! !

!ROEdgeDrivenLayout methodsFor: 'initialize-release' stamp: ''!
userDefinedEdges: aCollection
	
	userDefinedEdges := aCollection! !

ROEdgeDrivenLayout subclass: #ROForceBasedLayout
	instanceVariableNames: 'iterations repellingForce attractingForce'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROForceBasedLayout methodsFor: 'accessing' stamp: ''!
attractingForce: aBlock
	"Attracting force between edges."
	
	attractingForce := aBlock! !

!ROForceBasedLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:03'!
attractingForceFor: aFigure
	
	^attractingForce roValue: aFigure! !

!ROForceBasedLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:14'!
doExecute: nodeElements
	| nodes nodeCenterA nodeCenterB deltaX deltaY distance xForces yForces xForce yForce force random edgesIndices nodeCenter nodeRadius nodeRadiusA nodeRadiusB nodeOrigin minX minY delta radial |
	"Start by placing the nodes at random"
	radial := RORadialTreeLayout new.
	radial fromPositions: self fromPositions.
	radial toPositions: self toPositions.
	radial executeOnElements: nodeElements.
	
	random := Random new.	"Create array with the node center and radius. Like this we don't need to move the actual nodes"
	nodes := nodeElements asArray.
	nodeCenter := Array new: nodes size.
	nodeRadius := Array new: nodes size.
	1 to: nodes size do: [ :index | 
		nodeCenter at: index put: (nodes at: index) center.
		nodeRadius at: index put: (nodes at: index) radius ].	"Create array with the indices of the edge nodes"
	edgesIndices := Array new: self edges size.
	1 to: self edges size do: [ :index | 
		| edge |
		edge := self edges at: index.
		edgesIndices at: index put: (Array with: (nodes indexOf: edge source) with: (nodes indexOf: edge target)) ].
	1 to: (self iterationsFor: nodeElements) do: [ :iteration | 
		xForces := (Array new: nodes size) atAllPut: 0.
		yForces := (Array new: nodes size) atAllPut: 0.	"Node forces"
		1 to: nodes size do: [ :i | 
			i + 1 to: nodes size do: [ :j | 
				nodeCenterA := nodeCenter at: i.
				nodeCenterB := nodeCenter at: j.
				deltaX := nodeCenterB x - nodeCenterA x.
				deltaY := nodeCenterB y - nodeCenterA y.
				distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt.
				distance < 0.01
					ifTrue: [ 
						deltaX := random next + 5.
						deltaY := random next + 5.
						distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt ].
				distance < 100
					ifTrue: [ 
						nodeRadiusA := nodeRadius at: i.
						nodeRadiusB := nodeRadius at: j.
						force := (self repellingForceFor: nodeElements) * nodeRadiusA * nodeRadiusB / distance / distance.
						xForce := force * deltaX / distance.
						yForce := force * deltaY / distance.
						xForces at: i put: (xForces at: i) - xForce.
						yForces at: i put: (yForces at: i) - yForce.
						xForces at: j put: (xForces at: j) + xForce.
						yForces at: j put: (yForces at: j) + yForce ] ] ].	"Edge forces"
		edgesIndices
			do: [ :indices | 
				nodeCenterA := nodeCenter at: indices first.
				nodeCenterB := nodeCenter at: indices last.
				deltaX := nodeCenterB x - nodeCenterA x.
				deltaY := nodeCenterB y - nodeCenterA y.
				distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt.
				distance < 0.01
					ifTrue: [ 
						deltaX := random next + 5.
						deltaY := random next + 5.
						distance := (deltaX * deltaX + (deltaY * deltaY)) sqrt ].
				distance := distance min: 15.
				force := (self attractingForceFor: nodeElements) * distance.
				xForce := force * deltaX / distance.
				yForce := force * deltaY / distance.
				xForces at: indices first put: (xForces at: indices first) + xForce.
				yForces at: indices first put: (yForces at: indices first) + yForce.
				xForces at: indices last put: (xForces at: indices last) - xForce.
				yForces at: indices last put: (yForces at: indices last) - yForce ].	"Move centers"
		1 to: nodes size do: [ :index | 
			deltaX := xForces at: index.
			deltaY := yForces at: index.
			deltaX := deltaX min: 30.
			deltaX := deltaX max: -30.
			deltaY := deltaY min: 30.
			deltaY := deltaY max: -30.
			nodeCenter at: index put: ((nodeCenter at: index) translatedBy: deltaX @ deltaY) ] ].	"Node origins"
	nodeOrigin := Array new: nodes size.
	minX := 10000000.	"minX := Unlimited positive."
	minY := 10000000.	"minY := Unlimited positive."
	1 to: nodes size do: [ :index | 
		| origin node |
		node := nodes at: index.
		origin := (nodeCenter at: index) - ((node width / 2.0) @ (node height / 2.0)).
		nodeOrigin at: index put: origin.
		minX := minX min: origin x.
		minY := minY min: origin y ].	"Move nodes"
	minX := -1 * minX.
	minY := -1 * minY.
	delta := minX @ minY + (5 @ 5).
	
	1 to: nodes size do: [ :index | 
		translator translate: (nodes at: index) to: (nodeOrigin at: index) + delta ]! !

!ROForceBasedLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	iterations := 300.
	repellingForce := 10.
	attractingForce := 0.02! !

!ROForceBasedLayout methodsFor: 'accessing' stamp: ''!
iterations: aBlock
	
	iterations := aBlock! !

!ROForceBasedLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:03'!
iterationsFor: aFigure
	
	^iterations roValue: aFigure! !

!ROForceBasedLayout methodsFor: 'accessing' stamp: ''!
repellingForce: aBlock
	"Repelling force between nodes."
	
	repellingForce := aBlock! !

!ROForceBasedLayout methodsFor: 'private' stamp: 'AlexandreBergel 5/20/2012 19:03'!
repellingForceFor: aFigure
	
	^repellingForce roValue: aFigure! !

ROLayout subclass: #ROGridLayout
	instanceVariableNames: 'gapSize lineItemsCountBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROGridLayout class methodsFor: 'instance creation' stamp: ''!
new
	
	^self withGap: 5! !

!ROGridLayout class methodsFor: 'instance creation' stamp: ''!
withGap: anInteger 
	^ self 
		withGap: anInteger
		withLineItemsCount: 
			[ :graph | 
			| height width |
			(graph size < 3 
				ifTrue: [ (graph size max: 1) @ 1 ]
				ifFalse: 
					[ height := (graph size * 0.618034) sqrt ceiling truncated.
					width := (graph size / height) ceiling truncated.
					width @ height ]) x ]! !

!ROGridLayout class methodsFor: 'instance creation' stamp: ''!
withGap: anInteger withLineItemsCount: aBlock
	
	^(super new)
		gapSize: anInteger;
		lineItemsCount: aBlock;
		yourself! !

!ROGridLayout class methodsFor: 'instance creation' stamp: ''!
withLineItemsCount: aBlock
	
	^(super new)
		gapSize: 2;
		lineItemsCount: aBlock;
		yourself! !

!ROGridLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/20/2012 19:12'!
doExecute: elements 
	| pointer lineItemCount lineItemSize maxLastLineHeight |
	pointer := self gapSize @ self gapSize.
	lineItemSize := self lineItemsCountBlock roValue: elements.
	lineItemCount := 0.
	maxLastLineHeight := 0.
	elements do: 
		[ :element | 
		translator translate: element to: pointer.
		pointer := (pointer x + element width + (self gapSize * 2)) @ pointer y.
		lineItemCount := lineItemCount + 1.
		maxLastLineHeight := maxLastLineHeight max: element height.
		lineItemCount >= lineItemSize ifTrue: 
			[ pointer := self gapSize @ (pointer y + (self gapSize * 2) + maxLastLineHeight).
			maxLastLineHeight := 0.
			lineItemCount := 0 ] ]! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
gapSize
	
	^gapSize! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
gapSize: anObject
	
	gapSize := anObject! !

!ROGridLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	
	super initialize.
	gapSize := 5! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
lineItemsCount: aBlock
	
	lineItemsCountBlock := aBlock! !

!ROGridLayout methodsFor: 'accessing' stamp: ''!
lineItemsCountBlock
	
	^ lineItemsCountBlock! !

!ROLayout class methodsFor: 'public' stamp: ''!
on: aCollection
	self new applyOn: aCollection.
	^ aCollection! !

!ROLayout class methodsFor: 'public' stamp: ''!
on: elements edges: edges
	"To make all the layout polymorphic"
	
	^ self on: elements ! !

!ROLayout methodsFor: 'hook' stamp: ''!
applyOn: elements
	
	self executeOnElements: elements! !

!ROLayout methodsFor: 'hook' stamp: ''!
doInitialize: elements! !

!ROLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/22/2012 14:02'!
doPost: elements! !

!ROLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 13:59'!
executeOnElements: elements 
	"Execute the layout, myself, on the elements"

"	self userDefinedEdges isNil 
		ifTrue: [ self setEdgesFromElements: elements ]
		ifFalse: 
			[ | flat |
			flat := OrderedCollection new.
			self userDefinedEdges do: 
				[ :each | 
				each value isCollection 
					ifTrue: [ flat addAll: each value ]
					ifFalse: [ flat add: each value ] ].
			self edges: flat ]."
		
	self doInitialize: elements.
	self doExecute: elements asOrderedCollection.
	self doPost: elements! !

!ROLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	translator := ROLayoutTranslator default! !

!ROLayout methodsFor: 'hook' stamp: ''!
on: elements
	self applyOn: elements! !

!ROLayout methodsFor: 'hook' stamp: 'AlexandreBergel 4/18/2012 11:38'!
on: elements edges: edges
	self applyOn: elements! !

!ROLayout methodsFor: 'accessing' stamp: ''!
translator
	^ translator! !

!ROLayout methodsFor: 'accessing' stamp: ''!
translator: t
	translator := t! !

ROLayout subclass: #ROScatterplotLayout
	instanceVariableNames: 'horizontalPadding verticalPadding xBlock yBlock xOffset yOffset upSideDown scaleFactorX scaleFactorY scaledToWidth scaledToHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROScatterplotLayout methodsFor: 'adjusting' stamp: ''!
defaultAdjustHeightFor: childrenBounds and: myBounds
	
	| deltaY |
	deltaY := childrenBounds top - myBounds top.
	^childrenBounds height + deltaY + self yOutGap! !

!ROScatterplotLayout methodsFor: 'adjusting' stamp: ''!
defaultAdjustWidthFor: childrenBounds and: myBounds
	
	| deltaX |
	deltaX := childrenBounds left - myBounds left.
	^childrenBounds width + deltaX + self xOutGap! !

!ROScatterplotLayout methodsFor: 'hook' stamp: 'AlexandreBergel 5/21/2012 23:46'!
doExecute: elements

	| maxWidth maxHeight nodesToLayout x y origin newX newY |
	maxWidth := 0.
	maxHeight := 0.
	nodesToLayout := affectedNodes ifNil: [ elements ] ifNotNil: [ :arg | affectedNodes ].
	nodesToLayout
		do: [ :node | 
			x := (xBlock value: node model) * scaleFactorX.
			y := (yBlock value: node model) * scaleFactorY.
			maxWidth := maxWidth max: x.
			maxHeight := maxHeight max: y.	"x = #centered ifTrue: [ x := 0 ]."
			x := x + xOffset.
			y := upSideDown
				ifTrue: [ y - yOffset ]
				ifFalse: [ y + yOffset ].
			translator translate: node to: x @ y ].	"We scale them to the width and height"
	elements
		do: [ :node | 
			origin := node bounds origin.
			newX := origin x.
			newY := origin y.
			scaledToWidth ifNotNil: [ :arg | newX := (origin x / maxWidth * scaledToWidth) asInteger ].
			scaledToHeight ifNotNil: [ :arg | newY := (origin y / maxHeight * scaledToHeight) asInteger ].
			translator translate: node to:  newX @ newY ].
	scaledToHeight ifNotNil: [ :arg | maxHeight := scaledToHeight ].
	upSideDown
		ifFalse: [ ^ self ].	"We need to inverse the plots"
	nodesToLayout
		do: [ :node | 
			y := node bounds origin y.
			node translateBy: 0 @ (maxHeight - (2 * y)) ]! !

!ROScatterplotLayout methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.

	horizontalPadding := 5.
	verticalPadding := 5.
	xOffset := 0.
	yOffset := 0.
	scaleFactorX := 1.
	scaleFactorY := 1.
	upSideDown := false.
	xBlock := yBlock := [:aNode | aNode ]! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
offset: anInt

	xOffset := anInt.
	yOffset := anInt.! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
outGap
	
	^ self xOutGap @ self yOutGap! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
outGap: anObject
	
	self xOutGap: anObject.
	self yOutGap: anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaleFactor: aValue
	scaleFactorX := aValue.
	scaleFactorY := aValue! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaleFactorX: aValue
	scaleFactorX := aValue.! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaleFactorY: aValue
	scaleFactorY := aValue.! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToHeight
	^ scaledToHeight! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToHeight: anObject
	scaledToHeight := anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToWidth
	^ scaledToWidth! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
scaledToWidth: anObject
	scaledToWidth := anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
upSideDown
	upSideDown := upSideDown not! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
x: aBlock
	xBlock := aBlock! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
xOutGap
	
	^horizontalPadding! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
xOutGap: anObject
	
	horizontalPadding := anObject! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
y: aBlock
	yBlock := aBlock! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
yOutGap
	
	^verticalPadding! !

!ROScatterplotLayout methodsFor: 'accessing' stamp: ''!
yOutGap: anObject
	
	verticalPadding := anObject! !

ROObject subclass: #ROMondrianViewBuilder
	instanceVariableNames: 'shape width height container color selfDefinedInteraction title layoutToUse shouldHavePopup menu parentBehavior stack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Builder'!

!ROMondrianViewBuilder commentStamp: '<historical>' prior: 0!
A ROMondrianViewBuilder models the Mondrian Domain Specific Language. It is mostly compatible with the original Mondrian language (cf., Mondrian paper and website).

Instance Variables
	color:		<Object>
	container:		<Object>
	height:		<Object>
	isLayouted:		<Object>
	selfDefinedInteraction:		<Object>
	shape:		<Object>
	title:		<Object>
	width:		<Object>

color
	- xxxxx

container
	- xxxxx

height
	- xxxxx

isLayouted
	- xxxxx

selfDefinedInteraction
	- xxxxx

shape
	- xxxxx

title
	- xxxxx

width
	- xxxxx
!

!ROMondrianViewBuilder class methodsFor: 'public' stamp: ''!
titled: aTitleAsString
	^ self basicNew
		initializeWithTitle: aTitleAsString; 
		yourself! !

!ROMondrianViewBuilder class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 09:16'!
titled: aTitleAsString view: aView
	^ self basicNew
		initializeWithTitle: aTitleAsString roassalView: aView; 
		yourself! !

!ROMondrianViewBuilder class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 09:22'!
view: aView
	^ self basicNew
		initializeWithRoassalView: aView; 
		yourself! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/18/2012 14:38'!
action: aBlockOrSymbol
	^ self item: aBlockOrSymbol printString action: aBlockOrSymbol! !

!ROMondrianViewBuilder methodsFor: 'command' stamp: 'AlexandreBergel 5/18/2012 09:19'!
addMenu: name callBack: aCallBack
	"aCallback has to be one-arg block that accepts a view stack. It is convenient to receive the stack and not directly the view to add menu for example"
	
	menu add: name -> aCallBack! !

!ROMondrianViewBuilder methodsFor: 'compatibility' stamp: ''!
addUserCommand: anArray 
	"TODO"! !

!ROMondrianViewBuilder methodsFor: 'layout - operating' stamp: ''!
applyLayout

	layoutToUse 
		on: self nodes edges: self edges.! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/30/2012 09:28'!
arrowedLine
	shape := ROArrowedLine new.
	color := self defaultLineColor.
	shape color: color.
	^ shape! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
borderColor
	^ shape borderColor! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
borderColor: aBlock
	shape borderColor: aBlock
	! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
borderWidth: aBlock
	shape borderWidth: aBlock
	! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:58'!
bottomFlowLayout
	^ self layout: ROBottomFlowLayout new! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
buildEdgeFrom: fromNode to: toNode
	"Shape is not initialized here"
	
	^ (ROEdge from: fromNode to: toNode) + shape ! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:52'!
circleLayout
	^ self layout: ROCircleLayout new! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
color: aColor
	color := aColor.
	shape color: color.! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
container
	^ container! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 5/22/2012 21:01'!
createMondrianView
	
	| v |
	v := ROView titled: title.
	v @RODraggable @ RODraggableWithVelocity.
	^ v! !

!ROMondrianViewBuilder methodsFor: 'configuration' stamp: ''!
defaultColor 
	^ Color veryLightGray
! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: ''!
defaultHeight
	^ 5! !

!ROMondrianViewBuilder methodsFor: 'configuration' stamp: ''!
defaultLineColor
	^ Color veryLightGray! !

!ROMondrianViewBuilder methodsFor: 'configuration' stamp: ''!
defaultNodeColor
	^ Color white! !

!ROMondrianViewBuilder methodsFor: 'configuration' stamp: ''!
defaultTextColor
	^ Color black! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: ''!
defaultWidth
	^ 5! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 4/28/2012 17:38'!
edgeFromAssociation: assoc
 	| edge |
	(assoc key isNil or: [ assoc value isNil ]) ifTrue: [ ^ nil ].
	(assoc key == assoc value) ifTrue: [ ^ nil ].
	
	self prepareForNewEdge.
	edge := self rawEdgeFromAssociation: assoc.
	edge notNil ifTrue: [ container add: edge ].
	self unsetShape.
	^ edge! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 4/28/2012 17:41'!
edges
	^ self container elementsSuchThat: [ :v | v class == ROEdge ]! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
edges: objects from: fromBlock to: toBlock
	^ self edgesFromAssociations: (objects collect: [:o | (fromBlock roValue: o) -> (toBlock roValue: o)])
	! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 4/28/2012 17:31'!
edges: objects from: fromBlock toAll: toAllBlock
	"- aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each entity of the collection and return one edge source each time.
	- aToBlock will be called similarly to return a collection of destination correpsonding to each source.
	Note that there is no restriction on the entities of aCollection, as long as aFromBlock returns a node and aToBlock returns a collection of nodes.
	For example:
	  aView edges: someFamixInvocations from: #sender toAll: #candidates

	Or:
	
	| collection |
	collection := #(1 2 3 4 5 6 7 8 9 10).
	view shape label.
	view nodes: collection.
	view edges: collection from: #yourself toAll: (collection select: #odd).
	view circleLayout
		
	aToBlock should return a collection, edges will be drawn from the entity returned by aFromBlock to this collection"
	
	| associations |
	associations := OrderedCollection new.
	objects do: [ :obj |
		| from |
		from := fromBlock roValue: obj.
		(toAllBlock roValue: obj) do: [:to | 
			associations add: (from -> to)
		]
	].
	^ self edgesFromAssociations: associations! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
edgesFrom: symbolOrBlock
	"The message edgesFrom: defines one edge per node. For each node that has been added in the visualization, an edge is defined between this node and a node lookup from the provided block."

	| edges |
	edges := self rawEdgesFrom: symbolOrBlock.
	container addAll: edges.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: 'AlexandreBergel 5/17/2012 20:47'!
edgesFromAssociations: associations
	| answer edge interestingEdges |
	
	self prepareForNewEdge.

	interestingEdges := associations select: [ :assoc | 
						assoc key notNil and: [ assoc value notNil ] ].
	interestingEdges := interestingEdges select: [ :assoc |
						assoc key ~~ assoc value ].
					
	answer := interestingEdges collect: [ :assoc | 
		edge := self rawEdgeFromAssociation: assoc.
		edge notNil ifTrue: [ container add: edge ].
		
		edge ].
	self unsetShape.
	^ answer! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
edgesToAll: symbolOrBlock
	| edges |
	edges := self rawEdgesToAll: symbolOrBlock.
	container addAll: edges.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
fillColor
	^ shape color! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
fillColor:  aBlockOrASymbolOrAnObject
	shape color: aBlockOrASymbolOrAnObject! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 5/21/2012 23:58'!
fixedSize
	parentBehavior := ROFixedSizedParent instance! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:58'!
flowLayout
	^ self layout: ROFlowLayout new! !

!ROMondrianViewBuilder methodsFor: 'todo' stamp: ''!
fontSize: aBlockOrASymbolOrAnObject! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
forNode: aValue do: aBlock
	"Enable one to add a subview for a given node"
	
	| node oldPos|
	"For some strange reason, doing an applyLayout reset to 0@0 the origin of the node, it should not"
	
	node := self lookupNode: aValue globally: true.

	node removeAllEdges; removeAllNodes.
	node clearLookupCacheRecursively.
	
	oldPos := node bounds origin.
	self with: node during: [ self resetInteraction. aBlock value. node applyLayout ].
	node bounds origin: oldPos. 

	node bounds extent: (node shape computeExtentFor: node).
	node resetFormCache.
	node owner ifNotNil: [ node owner resetFormCache ].
	
	"We might have to update the bounds of the root"
	(node owner isRoot and: [( node owner absoluteBounds containsRect: node absoluteBounds) not])
		ifTrue: [ node owner updateBounds ].
		
	self root resetElementsToDisplayCacheRecursively.
	self root resetElementsToLookup.
	self resetInteraction.
	^ node! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
forNodes: values do: oneBlockArg
	"Enable one to add a subview for a given nodes"

	^ values collect: [:v | self forNode: v do: [ oneBlockArg value: v ] ]! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:52'!
forceBasedLayout
	
	^ self layout: ROForceBasedLayout new! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
forward
	self forwarder! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
forward: event

	selfDefinedInteraction add: [ :listOfNodes | listOfNodes do: [ :node | node forward: event ] ]! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
forwarder

	selfDefinedInteraction add: [ :listOfNodes | listOfNodes do: [ :node | node forward ] ]! !

!ROMondrianViewBuilder methodsFor: 'compatibility' stamp: ''!
fromPositions: v
	"For compatibility reason"! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:52'!
gridLayout
	
	^ self layout: (ROGridLayout new gapSize: 2)
		! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
height: aWidthBlock
	height := aWidthBlock! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
highlightNodesWhenOver: aBlockOrSymbol
	self highlightNodesWhenOver: aBlockOrSymbol color: Color red! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: ''!
highlightNodesWhenOver: aBlockOrSymbol color: aColorAsBlockOrSymbol
	self interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := (aBlockOrSymbol roValue: n element) . 
		ROHighlightElements 
			on: nodes 
			color: (aColorAsBlockOrSymbol roValue: n element model).
		n element signalUpdate  ].

	self interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := (aBlockOrSymbol roValue: n element).
		ROUnhighlightElements  
			on: nodes.
		n element signalUpdate  ].! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: 'AlexandreBergel 4/14/2012 09:28'!
highlightWhenOver: aBlockOrSymbol
	self highlightWhenOver: aBlockOrSymbol color: Color red! !

!ROMondrianViewBuilder methodsFor: 'interaction updating' stamp: 'AlexandreBergel 4/14/2012 18:25'!
highlightWhenOver: aBlockOrSymbol color: aColorAsBlockOrSymbol
	self interaction on: ROMouseEnter do: [ :n | 
		| nodes |
		nodes := self container elementsFromModels: (aBlockOrSymbol roValue: n element model) . 
		ROHighlightElements 
			on: nodes 
			color: (aColorAsBlockOrSymbol roValue: n element model).
		n element signalUpdate  ].

	self interaction on: ROMouseLeave do: [ :n | 
		| nodes |
		nodes := self container elementsFromModels:  (aBlockOrSymbol roValue: n element model).
		ROUnhighlightElements  
			on: nodes.
		n element signalUpdate  ].! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:53'!
horizontalLineLayout
	^ self layout: ROHorizontalLineLayout new! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
if: conditionBlock borderColor: colorBlock

	"If conditionBlock is evaluated at true, then colorBlock is used to pick the color to use. Both conditionBlock and colorBlock are evaluated with the model value of the node."

	| oldBlockOrValue |
	oldBlockOrValue := self borderColor ifNil: [ self defaultBorderColor ].
	^self borderColor: [ :each | (conditionBlock roValue: each)
								ifTrue: [ colorBlock roValue: each ] ifFalse: [ oldBlockOrValue roValue: each ]].! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 5/15/2012 15:24'!
if: conditionBlock fillColor: colorBlock
	"If conditionBlock is evaluated at true, then colorBlock is used to set the color of the node. Both conditionBlock and colorBlock are evaluated with the model value of the node."

	| oldBlockOrValue |
	oldBlockOrValue := self fillColor ifNil: [ self defaultFillColor ].
	^self fillColor: [ :each | (conditionBlock roValue: each)
								ifTrue: [ colorBlock roValue: each ] ifFalse: [ oldBlockOrValue roValue: each ]].! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 4/29/2012 11:25'!
initialize
	self initializeWithTitle: ROView defaultWindowTitle.! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 5/3/2012 09:23'!
initializeWithRoassalView: aView
	self initializeWithTitle: ROView defaultWindowTitle roassalView: aView! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 5/3/2012 09:14'!
initializeWithTitle: aTitleAsString
	self initializeWithTitle: aTitleAsString roassalView: self createMondrianView.
! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 6/1/2012 18:34'!
initializeWithTitle: aTitleAsString roassalView: aView
	super initialize.

	title := aTitleAsString.
	container := aView.
	aView title: title.
	shouldHavePopup := true.
	menu := OrderedCollection new.
	
	stack := ROViewStack new addView: container; title: container title.
	self setNodeShapeIfNecessary.
	self setUpSize.
	self setUpInteraction.
	self horizontalLineLayout.
	! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
interaction
! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
item: titleAsString action: aBlockOrSymbol

	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :n | n @ (ROMenuActivable new item: titleAsString action: aBlockOrSymbol) ] ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/30/2012 19:38'!
label
	^ shape := self newLabel! !

!ROMondrianViewBuilder methodsFor: 'layout - operating' stamp: 'AlexandreBergel 5/18/2012 08:51'!
layout: aLayout
	^ layoutToUse := aLayout! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/30/2012 09:28'!
line
	shape := ROLine new.
	color := self defaultLineColor.
	shape color: color.
	^ shape! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
linearFillColor: block within: collections
	| max |
	max := (collections collect: block) max.
	shape color: [ :v | Color gray256: 256 - ((block roValue: v) max: max in: (1 to: 256)) ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
logHeight: aBlock
	self height: [ :v | ((aBlock value: v) + 1) log * 10 ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
logWidth: aBlock
	self width: [ :v | ((aBlock value: v) + 1) log * 10 ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 4/18/2012 15:41'!
lookup: anObject
	"Return the node that has the object as model"
	
	| ans |
	ans := self container elementsSuchThat: [ :n | n model = anObject ].
	ans isEmpty ifTrue: [ ^ self nestedLookup: anObject ].
	ans size ~= 1 ifTrue: [ self error: 'Several candidates' ].
	^ ans first! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: ''!
needToSetup
	^ shape isNil! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
nestedLookup: anObject
	"Return the node that has the object as model, it goes "
	
	self container elementsDo: [ :el | 
		| t |
		t := self nestedLookup: anObject in: el.
		t ifNotNil: [ ^ t ] ].
	^ nil! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
nestedLookup: anObject in: aNode
	"Return the node that has the object as model, it goes "
	
	| ans |
	(aNode model = anObject)
		ifTrue: [ ^ aNode ].
		
	aNode elementsDo: [ :n | 
		| t |
		t := self nestedLookup: anObject in: n.
		t ifNotNil: [ ^ t ] ].
	
	^ nil. 
		! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/30/2012 19:38'!
newLabel
	^ ROLabel new color: self defaultTextColor; yourself! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/30/2012 17:12'!
noPopup 
	shouldHavePopup := false! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
node: object
	^ (self nodes: (Array with: object)) first! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
node: object forIt: aBlock
	^ (self nodes: (Array with: object) forEach: [ :v | aBlock value ]) first! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 4/28/2012 17:41'!
nodes
	^ self container elementsSuchThat: [ :v | v class == ROElement ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 6/2/2012 14:27'!
nodes: objects
	| els |
	self assert: [ objects isKindOf: Collection] description: 'Should provide a collection as parameter'.
		
	self prepareForNewNode.
	els := ROElement forCollection: objects.

	els do: [ :el | el + shape copy @ RODraggable. 
					el 
						width: [ :v | el width max: (width roValue: v)]; 
						height: [ :v | el height max: (height roValue: v)];
						resizeStrategy: parentBehavior ].
	
	shouldHavePopup 
		ifTrue: [ selfDefinedInteraction isEmpty ifTrue: [ self popupText ] ].
	selfDefinedInteraction do: [:int | int value: els ].
	
	
	self assert: [ els allSatisfy: [ :e | e model notNil ] ].
	container addAll: els.
	self unsetShape.
	self withPopup. "Make sure the next nodes have a popup"
	selfDefinedInteraction := OrderedCollection new.
	^ els! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 5/22/2012 00:45'!
nodes: objects forEach: aBlock
	| nodes oldContainer oldShape oldInteraction oldLayout |
	nodes := self nodes: objects.
	nodes do: [ :n | 
		oldContainer := container.
		oldShape := shape.
		oldInteraction := selfDefinedInteraction.
		oldLayout := layoutToUse.
		self horizontalLineLayout.
		
		container := n.
		selfDefinedInteraction := OrderedCollection new.
		
		aBlock roValue: n model.
		self applyLayout.
		n adjustSizeIfNecessary.

		container := oldContainer.
		shape := oldShape.
		selfDefinedInteraction := OrderedCollection new.
		layoutToUse := oldLayout.
		 ].
	self unsetShape.
	^ nodes! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
nodesAndEdges
	^ container elementsSuchThat: [ :v | true ]! !

!ROMondrianViewBuilder methodsFor: 'todo' stamp: 'AlexandreBergel 4/30/2012 19:53'!
nodraggable
	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :node | node removeInteraction: RODraggable ] ]! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
on: event do: block
	selfDefinedInteraction add: [ :listOfNodes | listOfNodes do: [ :node | node on: event do: block ] ]! !

!ROMondrianViewBuilder methodsFor: 'opening' stamp: 'AlexandreBergel 6/1/2012 18:37'!
open
	"Open the view. Return the system window opened"

	| whiteBox realView |
	self applyLayout.

	self populateMenuOn: stack.
	^ stack open
	
"	^ container open.
"
! !

!ROMondrianViewBuilder methodsFor: 'command' stamp: 'AlexandreBergel 5/1/2012 17:25'!
populateMenuOn: aStackView
	| labels |
	labels := OrderedCollection new. 
	menu do: [ :assoc |
		| label |
		label := ((ROLabelElement on: assoc key) @ ROLightlyHighlightable + ROBorder). 
		label on: ROMouseLeftClick do: [ :event | assoc value roValue: aStackView ].
		aStackView add: label.
		labels add: label ].
	
	ROHorizontalLineLayout on: labels.! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/18/2012 14:40'!
popupText
	^ self popupText: [ :v | (v class == 'ab' class) ifTrue: [ v ] ifFalse: [ v printString ] ]! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 6/1/2012 18:38'!
popupText: aBlockOrSelector

	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :node | 
			| int |
			int := ROPopup text: aBlockOrSelector.
			int receivingView: stack.
			int textColor: Color black.
			node changeInteraction: ROAbstractPopup for: int.
			 ] ]
		
	
	! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: ''!
popupView: aTwoArgsBlock

	^ self popupView: aTwoArgsBlock delay: 100
! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 6/2/2012 17:42'!
popupView: aTwoArgsBlock delay: delayAsInteger

	selfDefinedInteraction add: [ :listOfNodes | 
		listOfNodes do: [ :node | 
			node changeInteraction: ROAbstractPopup for: 
				(ROPopupView new 
					 receivingView: stack;
					view: [ :entity | 
						| v |
						v := self class new.
						aTwoArgsBlock value: entity model value: v.
						v applyLayout.
						v ] ) ] ]! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
prepareForNewEdge

	self needToSetup ifTrue: 
		[self setUpSize.
		self setLineShapeIfNecessary.
		self setUpInteraction ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: 'AlexandreBergel 5/21/2012 23:59'!
prepareForNewNode

	self needToSetup ifTrue: 
		[ self setUpSize.
		  self setNodeShapeIfNecessary ].
	parentBehavior ifNil: [ parentBehavior := ROExtensibleParent instance ]
! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 09:03'!
radialTreeLayout
	
	^ self layout: RORadialTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
rawEdgeFromAssociation: assoc
	| from to |
	from := self lookup: assoc key.
	to := self lookup: assoc value.
	(from isNil or: [ to isNil ]) ifTrue: [ ^ nil ].
	^  self buildEdgeFrom: from to: to! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
rawEdges: objects from: symbolOrBlockFrom to: symbolOrBlockTo
	| edges |
	edges := OrderedCollection new.
	self prepareForNewEdge.
	
	objects do: [ :obj | 
		| from to |
		from := self lookup: (symbolOrBlockFrom roValue: obj).
		to := self lookup: (symbolOrBlockTo roValue: obj).
		(from notNil and: [ to notNil ]) ifTrue: [  edges add: (self buildEdgeFrom: from to: to)  ]
		].
	
"	container elementsDo: [ :el | 
		container elementsDo: [ :el2 | 
			((objects includes: el model ) and: [ objects includes: el2 model ])
				ifTrue: 
				[ ((symbolOrBlockFrom roValue: el model) = 
					(symbolOrBlockTo roValue: el2 model))
						ifTrue: [ 
							(el ~~ el2) ifTrue: [ edges add: (self buildEdgeFrom: el2 to: el) ] ] ] ] ]. "
	self unsetShape.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
rawEdgesFrom: symbolOrBlockFrom
	^ self rawEdgesFrom: symbolOrBlockFrom to: #yourself! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
rawEdgesFrom: symbolOrBlockFrom to: symbolOrBlockTo
	| edges |
	edges := OrderedCollection new.
	self prepareForNewEdge.
	container elementsWithModelDo: [ :el | 
		container elementsWithModelDo: [ :el2 | 
			self assert: [ el model notNil ].
			self assert: [ el2 model notNil ].
			((symbolOrBlockFrom roValue: el model) = 
				(symbolOrBlockTo roValue: el2 model))
					ifTrue: [ 
						(el ~~ el2) ifTrue: [ edges add: (self buildEdgeFrom: el2 to: el) ] ] ] ]. 
	self unsetShape.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
rawEdgesToAll: symbolOrBlock
	| edges values v |
	edges := OrderedCollection new.
	self prepareForNewEdge.
	container
		elementsDo: [ :el | 
			values := symbolOrBlock roValue: el model.
			container
				elementsDo: [ :el2 | 
					v := values detect: [ :n | n == el2 model ] ifNone: [ nil ].
					v ifNotNil: [ edges add: (self buildEdgeFrom: el2 to: el) ] ] ].
	self unsetShape.
	^ edges! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/30/2012 09:29'!
rectangle
	shape := ROBox new.
	color := self defaultNodeColor.
	shape color: color.
	shape borderWidth: 1.
! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 5/7/2012 11:39'!
rectangleWithoutBorder
	shape := ROBoxWithoutBorder new.
	color := self defaultNodeColor.
	shape color: color.! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
root
	^ self ! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 09:04'!
scatterPlotLayout
	
	^ self layout: ROScatterplotLayout new! !

!ROMondrianViewBuilder methodsFor: 'layout - operating' stamp: 'AlexandreBergel 5/7/2012 12:00'!
setEdgesToVerticalShape
	self edges do: [ :ed | 
		ed change: ROShape for: 
			(ROLine new color: color; attachPoint: ROVerticalAttachPoint instance )  ].
	! !

!ROMondrianViewBuilder methodsFor: 'edges' stamp: ''!
setLineShapeIfNecessary
	"If no shape for edge is defined, then we set up a default one"

	shape ifNil: [ self shape line ]! !

!ROMondrianViewBuilder methodsFor: 'nodes' stamp: ''!
setNodeShapeIfNecessary
	"If no shape for node is defined, then we set up a default one"

	shape ifNil: [ self shape rectangle ]! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: 'AlexandreBergel 4/30/2012 17:22'!
setUpInteraction
	selfDefinedInteraction := OrderedCollection new.
! !

!ROMondrianViewBuilder methodsFor: 'initialize' stamp: ''!
setUpSize
	width := self defaultWidth.
	height := self defaultHeight! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
shape
! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 5/21/2012 22:17'!
shape: aShape
	shape := aShape! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
size: aSizeBlock
	width := aSizeBlock.
	height := aSizeBlock.	! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/1/2012 18:37'!
stack
	^ stack! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 17:18'!
stack: aStack
	"This method is essentially used in the VW Easel. It should not be existing actually"
	stack := aStack! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:57'!
sugiyamaLayout
	self setEdgesToVerticalShape.
	^ self layout: ROSugiyamaLayout new
	! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
title
	"Return a string"
	
	^ title! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
title: aString
	"Define the title of the view"

	title := aString! !

!ROMondrianViewBuilder methodsFor: 'compatibility' stamp: ''!
toPositions: v
	"For compatibility reason"! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:53'!
treeLayout
	self setEdgesToVerticalShape.
	^ self layout: ROTreeLayout new! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
unsetShape
	shape := nil.
	self setUpSize.! !

!ROMondrianViewBuilder methodsFor: 'layout' stamp: 'AlexandreBergel 5/18/2012 08:53'!
verticalLineLayout
	^ self layout: ROVerticalLineLayout new.
	! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
view
	^ self container! !

!ROMondrianViewBuilder methodsFor: 'accessing' stamp: ''!
view: aView
	container := aView! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
width: aWidthBlock
	width := aWidthBlock! !

!ROMondrianViewBuilder methodsFor: 'interactions' stamp: 'AlexandreBergel 4/30/2012 17:23'!
withPopup 
	shouldHavePopup := true! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 4/30/2012 19:41'!
withText
	^ self withText: [ :element | element model ]! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: 'AlexandreBergel 5/22/2012 18:44'!
withText: aBlockOrASymbolAnOrObject
	| label |
	shape next: (label := self newLabel text: aBlockOrASymbolAnOrObject).
	width := [ :v | label widthOfString: v printString ].
	height := [ :v | label heightOfString: v printString ].! !

!ROMondrianViewBuilder methodsFor: 'shapes' stamp: ''!
withoutBorder
	"We assume we want to have a rectangle"
	
	self rectangleWithoutBorder! !

ROObject subclass: #RONativeExampleUtility
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!RONativeExampleUtility class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 5/11/2012 14:48'!
current
	^self allSubclasses first ! !

!RONativeExampleUtility class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 5/11/2012 14:50'!
getMethodsForClass: aClass
	^self subclassResponsibility ! !

!RONativeExampleUtility class methodsFor: 'as yet unclassified' stamp: 'VanessaPena 5/11/2012 14:51'!
substringsFor: aString
	^self subclassResponsibility ! !

ROObject subclass: #RONativeWidgetFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!RONativeWidgetFactory commentStamp: 'AlexandreBergel 4/23/2012 17:31' prior: 0!
RONativeWidgetFactory is useful to create a ROMorph or ROVWVisual, depending on where the platform is running!

!RONativeWidgetFactory class methodsFor: 'public' stamp: 'AlexandreBergel 4/23/2012 17:34'!
current
	^ self subclasses first! !

!RONativeWidgetFactory class methodsFor: 'public' stamp: 'AlexandreBergel 5/7/2012 18:38'!
forView: aView
	"Return an instance of ROMorph of ROVWVisual without opening the window. "
	
	self subclassResponsibility! !

!RONativeWidgetFactory class methodsFor: 'public' stamp: 'AlexandreBergel 4/26/2012 17:07'!
forView: aView windowSized: aPoint
	"Return an instance of ROMorph of ROVWVisual and open the window. This depends on which platform it is run"
	
	self subclassResponsibility! !

!RONativeWidgetFactory class methodsFor: 'public' stamp: 'AlexandreBergel 4/26/2012 17:09'!
menuForAssociations: associations on: element
	"associations is a list of association following: #aSymbol -> [ :model | ... ]
	The block contains in the association is evaluated with the model provided by the element."
	
	self subclassResponsibility! !

!ROObject class methodsFor: 'instance creation' stamp: 'AlexandreBergel 4/17/2012 18:02'!
new
	^ super new initialize! !

!ROObject methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/17/2012 20:19'!
initialize! !

ROObject subclass: #ROSequenceOfInteraction
	instanceVariableNames: 'sequence'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Interaction'!

!ROSequenceOfInteraction methodsFor: 'actions' stamp: 'AlexandreBergel 5/4/2012 09:53'!
after: nbOfMilliseconds do: aBlock
	sequence add: (Array with: nbOfMilliseconds with: aBlock)! !

!ROSequenceOfInteraction methodsFor: 'actions' stamp: 'AlexandreBergel 5/4/2012 10:16'!
execute
	
	[ [ self isOver ] whileFalse: [ self step ] ] fork! !

!ROSequenceOfInteraction methodsFor: 'initialize-release' stamp: 'AlexandreBergel 5/4/2012 09:41'!
initialize

	super initialize.
	sequence := OrderedCollection new.! !

!ROSequenceOfInteraction methodsFor: 'tests' stamp: 'AlexandreBergel 5/4/2012 09:44'!
isOver
	^ self leftToDo = 0! !

!ROSequenceOfInteraction methodsFor: 'accessing' stamp: 'AlexandreBergel 5/4/2012 09:41'!
leftToDo
	^ sequence size! !

!ROSequenceOfInteraction methodsFor: 'actions' stamp: 'AlexandreBergel 5/4/2012 09:43'!
step
	"Execute the first action in the sequence"
	| seq |
	self isOver ifTrue: [ ^ self ].
	seq := sequence first.
	(Delay forMilliseconds: seq first) wait.
	seq second value.
	sequence removeFirst.! !

!ROSequenceOfInteraction methodsFor: 'actions' stamp: 'AlexandreBergel 5/4/2012 11:30'!
waitUntilDone
	"The caller of this method will wait until all the step have been executed"
	[ self isOver ] whileFalse: [ (Delay forMilliseconds: 5) wait ]! !

ROObject subclass: #ROShape
	instanceVariableNames: 'color colorCache next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROShape commentStamp: '<historical>' prior: 0!
A ROShape represents the graphical representation of an element.
Decorator has a color, and they are link together.

Instance Variables
	color:		<Object>
	colorCache:		<Object>
	next:		<Object>

color
	- xxxxx

colorCache
	- xxxxx

next
	- xxxxx
!

ROShape subclass: #ROAbstractLine
	instanceVariableNames: 'attachPoint width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROAbstractLine methodsFor: 'accessing' stamp: ''!
attachPoint
	
	^ attachPoint! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 6/1/2012 05:56'!
attachPoint: attach
	
	attachPoint := attach! !

!ROAbstractLine methodsFor: 'initialize' stamp: 'AlexandreBergel 5/22/2012 17:49'!
defaultWidth
	^ 1 ! !

!ROAbstractLine methodsFor: 'computing attach point' stamp: 'AlexandreBergel 5/31/2012 14:46'!
endingPointOf: anEdge
	^ attachPoint endingPointOf: anEdge! !

!ROAbstractLine methodsFor: 'initialize' stamp: 'AlexandreBergel 6/1/2012 06:11'!
initialize
	super initialize.
	attachPoint := ROShorterDistanceAttachPoint instance.
	width := self defaultWidth! !

!ROAbstractLine methodsFor: 'computing attach point' stamp: 'AlexandreBergel 5/31/2012 14:46'!
startingPointOf: anEdge
	^ attachPoint startingPointOf: anEdge! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 17:48'!
width
	^ width! !

!ROAbstractLine methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 17:49'!
width: aNumber
	width := aNumber! !

ROAbstractLine subclass: #ROArrowedLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROArrowedLine methodsFor: 'configuration' stamp: 'AlexandreBergel 4/15/2012 19:07'!
arrowSize
	^ 10! !

!ROArrowedLine methodsFor: 'rendering' stamp: 'AlexandreBergel 5/31/2012 14:43'!
drawOn: aCanvas for: anEdge 
	| fromPoint toPoint vector u unit arrowMiddle arrowLeft arrowRight w c |
	fromPoint := self startingPointOf: anEdge.
	toPoint := self endingPointOf: anEdge.

	(fromPoint = toPoint)
		ifTrue: [ ^ self ].

	"Draw head"
	vector := toPoint - fromPoint.
	u := vector normal.
	unit := vector / vector r.
	arrowMiddle := toPoint - (unit * self arrowSize). 
	arrowLeft :=  arrowMiddle- (u * self arrowSize).
	arrowRight := arrowMiddle + (u * self arrowSize).

	w :=  width roValue: anEdge.
	c := self colorFor: anEdge.
	aCanvas line: toPoint to: arrowLeft width: w color: c.
	aCanvas line: arrowLeft to: arrowRight width: w color: c.
	aCanvas line: arrowRight to: toPoint width: w color: c.

	"Draw body"
	aCanvas line: arrowMiddle to: fromPoint width: w color: color! !

ROAbstractLine subclass: #ROLine
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROLine methodsFor: 'rendering' stamp: 'AlexandreBergel 5/22/2012 17:51'!
drawOn: aCanvas for: anEdge 
	aCanvas line: (attachPoint startingPointOf: anEdge) to: (attachPoint endingPointOf: anEdge) width: (width roValue: anEdge) color: color! !

ROShape subclass: #ROBorder
	instanceVariableNames: 'width'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROBorder commentStamp: '<historical>' prior: 0!
A ROBorder defines a border to be added to an element.

Instance Variables
	width:		Number

width
	- Width of the border!

!ROBorder class methodsFor: 'as yet unclassified' stamp: ''!
defaultColor
	^ Color black! !

!ROBorder methodsFor: 'rendering' stamp: ''!
drawOn: aCanvas for: aROElement
	| b |
	b := aROElement bounds.
	aCanvas 
		line: b topLeft to: b topRight width: width color: color.
	aCanvas 
		line: b topRight to: b bottomRight width: width color: color.
	aCanvas 
		line: b bottomRight to: b bottomLeft width: width color: color.
	aCanvas 
		line: b topLeft to: b bottomLeft width: width color: color.
! !

!ROBorder methodsFor: 'initialization' stamp: ''!
initialize 
	super initialize.
	width := 1.
	color := self class defaultColor! !

ROShape subclass: #ROBox
	instanceVariableNames: 'borderColorCache borderColor borderWidthCache borderWidth'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROBox class methodsFor: 'defaults' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROBox methodsFor: 'rendering' stamp: ''!
borderColor
	^ borderColor! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 4/6/2012 14:06'!
borderColor: aBlockOrSymbolOrObject
	borderColor := aBlockOrSymbolOrObject.
	borderColorCache := nil.! !

!ROBox methodsFor: 'rendering' stamp: ''!
borderColorFor: element
	borderColorCache ifNotNil: [ ^ borderColorCache ].
	^ borderColorCache := borderColor roValue: element model! !

!ROBox methodsFor: 'rendering' stamp: ''!
borderWidth
	^ borderWidth! !

!ROBox methodsFor: 'rendering' stamp: 'AlexandreBergel 4/6/2012 14:07'!
borderWidth: aBlockOrSymbolOrObject
	borderWidth := aBlockOrSymbolOrObject.
	borderWidthCache := nil! !

!ROBox methodsFor: 'rendering' stamp: ''!
borderWidthFor: element
	borderWidthCache ifNotNil: [ ^ borderWidthCache ].
	^ borderWidthCache := borderWidth roValue: element model! !

!ROBox methodsFor: 'as yet unclassified' stamp: 'SantiagoVidal 6/13/2012 18:07'!
changeColor:aColor
	color := aColor.
	colorCache := nil.! !

!ROBox methodsFor: 'rendering' stamp: ''!
drawOn: aCanvas for: aROElement

	aCanvas 
		frameAndFillRectangle: aROElement bounds 
		fillColor: (self colorFor: aROElement) 
		borderWidth: (self borderWidthFor: aROElement) 
		borderColor: (self borderColorFor: aROElement)! !

!ROBox methodsFor: 'initialize' stamp: ''!
initialize 
	super initialize.
	borderColor := Color black.
	borderWidth := 0.! !

ROShape subclass: #ROBoxWithoutBorder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROBoxWithoutBorder class methodsFor: 'defaults' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROBoxWithoutBorder methodsFor: 'rendering' stamp: ''!
drawOn: aCanvas for: aROElement
	aCanvas 
		fillRectangle: aROElement bounds 
		color: (self colorFor: aROElement) 
! !

ROShape subclass: #ROCircle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROCircle class methodsFor: 'public' stamp: ''!
color: aColor
	^ self new color: aColor! !

!ROCircle class methodsFor: 'defaults' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROCircle methodsFor: 'rendering' stamp: ''!
drawOn: aCanvas for: aROElement
	aCanvas
		fillOval: aROElement bounds 
		color: color 
		borderWidth: 0 
		borderColor: Color black! !

ROShape subclass: #ROImage
	instanceVariableNames: 'form'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROImage methodsFor: 'rendering' stamp: ''!
drawOn: aCanvas for: aROElement
	aCanvas
		paintImage: (form roValue: aROElement) at: aROElement topLeft
! !

!ROImage methodsFor: 'accessing' stamp: ''!
form
	^ form! !

!ROImage methodsFor: 'accessing' stamp: ''!
form: aFormBlockOrObject
	form := aFormBlockOrObject! !

!ROImage methodsFor: 'hooks' stamp: ''!
installedOn: element
	"This method is meant to be overriden in case a special treatment has to be realized on the element"
	
	| p | 
	super installedOn: element.
	p := (form roValue: element) extent.
	element extent < p
		ifTrue: [ element extent: p ].
	! !

!ROImage methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 5/29/2012 10:22'!
preferedExtentFor: element
	^ (form roValue: element) extent! !

ROShape subclass: #ROLabel
	instanceVariableNames: 'text textVerticalPadding textHorizontalPadding'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROLabel class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 6/5/2012 20:22'!
defaultColor
	^ Color black! !

!ROLabel class methodsFor: 'public' stamp: ''!
text: aBlock
	^ self new text: aBlock! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 5/3/2012 16:36'!
drawOn: aCanvas for: aROElement
	| str runner |
	str := self textAdaptedFor: aROElement.

	runner := aROElement topLeft + ROFontOrganizer current offsetWhenDrawing.
	str linesDo: [ :line |
		aCanvas drawString: line at: runner color: color.
		runner := runner + (0 @ (self heightOfString: line))
	]! !

!ROLabel methodsFor: 'todo' stamp: ''!
fontSize: aBlockOrASymbolOrAnObject! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 4/27/2012 17:57'!
heightFor: aROElement
	"Return the height for the element"
	
	^ self heightOfString: (self textFor: aROElement).
	! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 4/27/2012 18:03'!
heightOfString: string
	"Return the height of a string"
	
	| lineCount height |
	lineCount := string lineCount.
	height := ROFontOrganizer current height.
	^ (( height asInteger + self interlineSpace) * lineCount) + (2 * textVerticalPadding) ! !

!ROLabel methodsFor: 'initialize' stamp: 'AlexandreBergel 4/27/2012 18:04'!
initialize 
	super initialize.
	text := #model.
	textHorizontalPadding := textVerticalPadding := 0 ! !

!ROLabel methodsFor: 'initialize' stamp: 'AlexandreBergel 4/27/2012 18:06'!
interlineSpace
	"Space between lines in a multi-line text"

	^ 3! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 5/3/2012 09:05'!
linesOf: aString
	"Return a collection of strings got from aString."
	
	| ans runner |
	ans := OrderedCollection new.
	runner := ''.
	aString do: [ :c |
		c = Character cr
			ifTrue: [ ans add: runner. runner := '' ]
			ifFalse: [ runner := runner, (String with: c) ].
	].
	runner isEmpty ifFalse: [ ans add: runner ].
	^ ans asArray! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 5/3/2012 09:07'!
longestTextLineFor: aROElement
	"Return the longest line for the textFor: of the element. This is use to compute the right width of the label"
	
	| lines |
	lines := self linesOf: (self textAdaptedFor: aROElement).
	lines size = 0 ifTrue: [ ^ '' ].
	^ lines inject: lines first into: [ :longest :line | 
		line size > longest size 
			ifTrue: [ line ] ifFalse: [ longest ] ]! !

!ROLabel methodsFor: 'accessing' stamp: 'AlexandreBergel 4/27/2012 18:06'!
preferedExtentFor: aROElement
	^ (self widthFor: aROElement) @ (self heightFor: aROElement)! !

!ROLabel methodsFor: 'accessing' stamp: ''!
text
	^ text! !

!ROLabel methodsFor: 'accessing' stamp: ''!
text: anObject
	text := anObject! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 4/27/2012 20:21'!
textAdaptedFor: anElement
	"Return the text from anElement. All the tabulation are replaced"
	
	^ (self textFor: anElement) copyReplaceAll: '	' with: '    '! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 4/18/2012 14:37'!
textFor: aROElement
	 | v |
	v := (text roValue: aROElement).
	^ (v class == 'abc' class)
			ifTrue: [ v ]
			ifFalse: [ v printString ]
! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 4/29/2012 10:05'!
widthFor: aROElement
	"Return the width for the element"
	
	^ self widthOfString: (self longestTextLineFor: aROElement).
	! !

!ROLabel methodsFor: 'rendering' stamp: 'AlexandreBergel 4/25/2012 15:47'!
widthOfString: string
	"Return the length of a string"
	
	^ ROFontOrganizer current widthOfString: string! !

ROShape subclass: #RONullShape
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

RONullShape class
	instanceVariableNames: 'current'!

RONullShape class
	instanceVariableNames: 'current'!

!RONullShape class methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 4/14/2012 19:39'!
current
	current ifNil: [ current := self basicNew ].
	^ current! !

!RONullShape class methodsFor: 'as yet unclassified' stamp: ''!
new
	self error: 'should not use'! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:02'!
addLast: aShape
	^ aShape! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:03'!
addLast: aShape in: elementToAdd

	elementToAdd next: aShape! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/22/2012 08:45'!
change: aShapeClass for: aShape
	^ self ! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:09'!
isShapedAs: aShapeClass
	^ false! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/22/2012 08:23'!
removeShape: aShapeClass
	^ self ! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/17/2012 20:38'!
shapeDetect: aBlock
	self error: 'Not found'! !

!RONullShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:03'!
shapesDetect: aBlock
	self error: 'Not found'! !

!ROShape class methodsFor: 'public' stamp: 'AlexandreBergel 6/4/2012 00:53'!
blue
	^ self new color: Color blue! !

!ROShape class methodsFor: 'public' stamp: ''!
defaultColor 
	^ Color veryLightGray! !

!ROShape class methodsFor: 'public' stamp: ''!
green
	^ self new color: Color green! !

!ROShape class methodsFor: 'public' stamp: ''!
installedOn: element
	^ self new installedOn: element; yourself! !

!ROShape class methodsFor: 'public' stamp: ''!
red
	^ self new color: Color red! !

!ROShape class methodsFor: 'public' stamp: ''!
white
	^ self new color: Color white! !

!ROShape class methodsFor: 'public' stamp: ''!
yellow
	^ self new color: Color yellow! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 11:43'!
addLast: aShape
	self addLast: aShape in: self! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 11:43'!
addLast: aShape in: elementToAdd
	next addLast: aShape in: self! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 11:44'!
change: aShapeClass for: aShape

	^ (self isKindOf: aShapeClass) 
		ifTrue: [ aShape next: self next; yourself ]
		ifFalse: [ self next: (self next change: aShapeClass for: aShape) ]! !

!ROShape methodsFor: 'accessing' stamp: ''!
color
	^ color! !

!ROShape methodsFor: 'accessing' stamp: ''!
color: anObject
	color := anObject! !

!ROShape methodsFor: 'accessing' stamp: ''!
colorFor: element
	colorCache ifNotNil: [ ^ colorCache ].
	^ colorCache := color roValue: element model! !

!ROShape methodsFor: 'rendering' stamp: ''!
drawOn: aCanvas for: aROElement 
	! !

!ROShape methodsFor: 'initialize' stamp: 'AlexandreBergel 5/7/2012 11:52'!
initialize 
	super initialize.
	color := self class defaultColor.
	next := RONullShape current! !

!ROShape methodsFor: 'hooks' stamp: 'AlexandreBergel 5/29/2012 10:18'!
installedOn: element
	"This method is meant to be overriden in case a special treatment has to be realized on the element"
	
	| p |
	p := self preferedExtentFor: element.
	element extent: (element extent max: p)! !

!ROShape methodsFor: 'testing' stamp: ''!
isNesting
	^ false! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 12:09'!
isShapedAs: aShapeClass
	^ (self isKindOf: aShapeClass) or: [ self next isShapedAs: aShapeClass ]! !

!ROShape methodsFor: 'accessing' stamp: ''!
next
	^ next! !

!ROShape methodsFor: 'accessing' stamp: 'AlexandreBergel 5/7/2012 11:52'!
next: aShape
	next := aShape! !

!ROShape methodsFor: 'hooks' stamp: 'AlexandreBergel 5/29/2012 10:19'!
preferedExtentFor: element
	"Override this method is you want the element to have a particular shape"
	^ 0 @ 0! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/22/2012 08:19'!
removeShape: aShapeClass
	"Remove a shape of the element"

	^ (self isKindOf: aShapeClass)
		ifTrue: [ next ]
		ifFalse: [ next removeShape: aShapeClass ]! !

!ROShape methodsFor: 'hooks' stamp: ''!
setView: view
	"Invoked when a node is added within a view"! !

!ROShape methodsFor: 'linking' stamp: 'AlexandreBergel 5/7/2012 11:44'!
shapeDetect: aBlock

	(aBlock value: self) ifTrue: [ ^ self ].
	^ self next shapeDetect: aBlock! !

ROObject subclass: #ROTimeOrganizer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Hooks'!

!ROTimeOrganizer commentStamp: '<historical>' prior: 0!
Abstract class for the time passing.!

!ROTimeOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:42'!
current
	^ self subclasses first! !

!ROTimeOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:44'!
milliseconds
	"Return the elapsed amount of milliseconds"
	
	self subclassResponsibility ! !

!ROTimeOrganizer class methodsFor: 'public' stamp: 'AlexandreBergel 5/3/2012 16:42'!
now
	^ Time now! !

ROObject subclass: #ROView
	instanceVariableNames: 'camera eventHandler elements title backgroundColor'
	classVariableNames: 'BlackHole'
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROView class methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 00:59'!
blackHole
	^ BlackHole ifNil: [ BlackHole := self new ].! !

!ROView class methodsFor: 'configuration' stamp: ''!
defaultWindowTitle
	^ 'Roassal visualization'! !

!ROView class methodsFor: 'public' stamp: ''!
titled: aTitle
	"Create an instance of the view and set a title to it"

	^ self new 
		title: aTitle; 
		yourself! !

!ROView methodsFor: 'interaction' stamp: ''!
@ anInteractionClassOrInstance

	anInteractionClassOrInstance initializeElement: self ! !

!ROView methodsFor: 'accessing' stamp: ''!
absolutePosition
	^ 0 @ 0! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 00:27'!
add: element 
	elements add: element.
	element parent: self.
	element view: self! !

!ROView methodsFor: 'accessing' stamp: ''!
addAll: els 
	self assert: [ els isKindOf: Collection ].
	els do: [:n | self add: n ]! !

!ROView methodsFor: 'accessing' stamp: ''!
addAllNoContaining:  els
	"Used for  polymorphism with the containing elements. This really ugly. This cannot be left like this."
	^ self addAll: els! !

!ROView methodsFor: 'accessing' stamp: ''!
addFirst: element 
	elements addFirst: element.
	element view: self! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 00:42'!
adjustSizeIfNecessary
	"do nothing"! !

!ROView methodsFor: 'events' stamp: ''!
announce: event
	eventHandler announce: event! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 20:58'!
backgroundColor
	^ backgroundColor ! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 20:58'!
backgroundColor: aColor
	
	backgroundColor := aColor! !

!ROView methodsFor: 'rendering' stamp: ''!
bitmap
	| canvas |
	canvas := self camera canvas.
	self drawOn: canvas.
	^ canvas form	
! !

!ROView methodsFor: 'rendering' stamp: ''!
bitmapForRealSize: aPoint 
	self camera realExtent: aPoint.
	^ self bitmap! !

!ROView methodsFor: 'rendering' stamp: 'AlexandreBergel 6/3/2012 15:29'!
bitmapForSize: aPoint 
	self camera realExtent: aPoint; extent: aPoint.
	^ self bitmap! !

!ROView methodsFor: 'camera' stamp: ''!
camera
	^ camera! !

!ROView methodsFor: 'camera' stamp: ''!
cameraTranslateBy: point
	camera translateBy: point.
	self signalUpdate! !

!ROView methodsFor: 'camera' stamp: ''!
cameraTranslateByRealStep: aStep
	camera translateByRealStep: aStep.
	self signalUpdate! !

!ROView methodsFor: 'camera' stamp: 'AlexandreBergel 6/5/2012 00:29'!
cameraTranslateTo: point
	camera translateTo: point.
	self signalUpdate! !

!ROView methodsFor: 'rendering' stamp: ''!
canvasForRealSize: realSize
	^ camera extent: realSize; realExtent: realSize; canvas! !

!ROView methodsFor: 'opening' stamp: ''!
defaultWindowSize
	^ 500 @ 500! !

!ROView methodsFor: 'rendering' stamp: ''!
drawElementsOn: canvas
	elements do: [ :n | n drawOn: canvas ]! !

!ROView methodsFor: 'rendering' stamp: 'AlexandreBergel 5/22/2012 20:58'!
drawOn: canvas
	canvas camera: self camera.
	canvas paintBackground: backgroundColor.
	self drawElementsOn: canvas
! !

!ROView methodsFor: 'accessing' stamp: ''!
elementAt: aPoint
	"The lookup has to be done in an order reversed from the display"
 
	^ self localElementAt: aPoint
! !

!ROView methodsFor: 'accessing' stamp: ''!
elementAtRealPosition: aPoint
	"The lookup has to be done in an order reversed from the display"
 
	^ self elementAt: (self camera realToVirtualPoint: aPoint)
! !

!ROView methodsFor: 'accessing' stamp: ''!
elementDetect: aBlock
	^ elements copy detect: aBlock! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 4/14/2012 10:36'!
elementFromModel: object
	| v |
	elements do: [: e |
		v := e elementFromModel: object.
		v ifNotNil: [ ^ v ] ].
	^ nil
	
	"^ (self elementsSuchThat: [ :el | objects includes: el model ]) first"! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/28/2012 13:58'!
elements
	"We return a copy to not let anyone fiddling with it"
	^ elements copy! !

!ROView methodsFor: 'accessing' stamp: ''!
elementsDo: aBlock
	^ elements copy do: aBlock! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 4/14/2012 18:33'!
elementsFromModels: objects
	^ (objects collect: [ :o | self elementFromModel: o ]) copyWithout:  nil
! !

!ROView methodsFor: 'accessing' stamp: ''!
elementsSuchThat: aBlock
	^ elements copy select: aBlock! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 4/18/2012 15:41'!
elementsWithModelDo: aBlock
	^ (elements copy select: [ :n | n model notNil ]) do: aBlock
	! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 6/3/2012 15:11'!
encompassingRectangle
	"Return the encompassing rectangle of the view. All the elements are contained in this rectangle"

	| max maxPoint lowerPoint |
	max := 1000000.
	maxPoint := max negated @ max negated.
	lowerPoint := max @ max.
	
	self elementsDo: [ :el |
		maxPoint := maxPoint max: el bounds bottomRight.
		lowerPoint := lowerPoint min: el position ].

	^ lowerPoint corner: maxPoint! !

!ROView methodsFor: 'initialize' stamp: 'AlexandreBergel 5/22/2012 20:58'!
initialize 
	super initialize.
	elements := OrderedCollection new.
	camera := ROCamera new.
	eventHandler := Announcer new.
	title := self class defaultWindowTitle.
	backgroundColor := Color white.! !

!ROView methodsFor: 'testing' stamp: 'AlexandreBergel 4/18/2012 15:35'!
is: aClass
	"Not sure whether this is important or not"
	^ false! !

!ROView methodsFor: 'accessing' stamp: ''!
localElementAt: aPoint
	"The lookup has to be done in an order reversed from the display"
 
	| el |
	el := (elements reverse detect: [ :e | e contains: aPoint ] ifNone: [ ^ self ]).
	^ el elementAt: (aPoint - el topLeft)
	! !

!ROView methodsFor: 'accessing' stamp: ''!
localElementAtRealPoint: aPoint

	^ self localElementAt: (camera realToVirtualPoint: aPoint)! !

!ROView methodsFor: 'accessing' stamp: ''!
numberOfElements
	^ elements size ! !

!ROView methodsFor: 'accessing' stamp: ''!
numberOfNodes
	^ elements size ! !

!ROView methodsFor: 'events' stamp: 'AlexandreBergel 4/18/2012 13:58'!
on: event do: aBlock
	eventHandler when: event do: aBlock! !

!ROView methodsFor: 'opening' stamp: ''!
open
	^ self openInWindow! !

!ROView methodsFor: 'opening' stamp: ''!
openInWindow
	^ self openInWindowSized: self defaultWindowSize! !

!ROView methodsFor: 'opening' stamp: 'AlexandreBergel 4/26/2012 17:02'!
openInWindowSized: aPoint

	^ RONativeWidgetFactory current forView: self windowSized: aPoint
	! !

!ROView methodsFor: 'accessing' stamp: ''!
positionRelativeTo: anElement
	^ 0 @ 0! !

!ROView methodsFor: 'accessing' stamp: ''!
remove: element 
	elements remove: element.
	! !

!ROView methodsFor: 'accessing' stamp: ''!
remove: element ifAbsent: aBlock
	elements remove: element ifAbsent: aBlock! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 6/2/2012 14:26'!
resizeStrategy
	^ ROFixedSizedParent instance! !

!ROView methodsFor: 'events' stamp: ''!
signalUpdate
	self announce: RORefreshNeeded! !

!ROView methodsFor: 'accessing' stamp: 'AlexandreBergel 5/22/2012 13:55'!
sortElementsWith: aTwoArgBlock
	elements sort: aTwoArgBlock
	
! !

!ROView methodsFor: 'accessing' stamp: ''!
title
	^ title! !

!ROView methodsFor: 'accessing' stamp: ''!
title: anObject
	title := anObject! !

!ROView methodsFor: 'camera' stamp: ''!
translateBy: point
	self cameraTranslateBy: point negated! !

!ROView methodsFor: 'camera' stamp: ''!
translateByRealPoint: aPoint 
	| p1 p2 |
	p1 := self camera position.
	p2 := self camera realToVirtualPoint: aPoint. 
	self translateBy: (p2 - p1).
! !

!ROView methodsFor: 'camera' stamp: 'AlexandreBergel 6/5/2012 00:30'!
translateTo: point
	self cameraTranslateTo: point negated! !

!ROView methodsFor: 'accessing' stamp: ''!
view
	^ self ! !

ROView subclass: #ROViewStack
	instanceVariableNames: 'views'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROViewStack methodsFor: 'accessing' stamp: ''!
addFirst: aView
	views addFirst: aView.
	self announce: (ROViewChanged new newView: aView).! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
addLast: aView
	views addLast: aView.
	self announce: (ROViewChanged new newView: aView).! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
addView: aView
	self addLast: aView! !

!ROViewStack methodsFor: 'rendering' stamp: 'AlexandreBergel 5/22/2012 21:13'!
drawOn: aROCanvas
	self viewDo: [ :v | v drawOn: aROCanvas ].
	aROCanvas camera: self camera.
	self drawElementsOn: aROCanvas
! !

!ROViewStack methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2012 17:36'!
elementAtRealPosition: aPoint
	"Override of the superclass. If nothing is found in myself, then we look in the embedded views"

 	| t el |
	
	el := self elementAt: (self camera realToVirtualPoint: aPoint).
	(el == self) 
		ifTrue: [ self viewDo: [ :v | 
					^ v elementAtRealPosition: aPoint ] ]
		ifFalse: [ ^ el ].
	^ self
! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
firstView
	^ views first! !

!ROViewStack methodsFor: 'initialize' stamp: ''!
initialize
	super initialize.
	views := OrderedCollection new.
	 ! !

!ROViewStack methodsFor: 'interactions' stamp: ''!
on: eventClass do: aBlock
	super on: eventClass do: aBlock.
	self viewDo: [ :v | v on: eventClass do: aBlock ]! !

!ROViewStack methodsFor: 'accessing' stamp: ''!
replaceFirstBy: view
	views removeFirst.
	self addFirst: view ! !

!ROViewStack methodsFor: 'opening' stamp: ''!
viewDo: aBlock
	views do: [:v | aBlock value: v ].! !

!ROViewStack methodsFor: 'opening' stamp: ''!
viewReverseDo: aBlock
	views do: [:v | aBlock value: v ].
				
	! !

ROViewStack subclass: #ROViewStackWithMenu
	instanceVariableNames: 'menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Core'!

!ROViewStackWithMenu methodsFor: 'public' stamp: 'AlexandreBergel 5/28/2012 22:22'!
addMenu: name callBack: aCallBack
	"aCallback has to be one-arg block that accepts a view stack. It is convenient to receive the stack and not directly the view to add menu for example"
	
	menu add: name -> aCallBack! !

!ROViewStackWithMenu methodsFor: 'initialize-release' stamp: 'AlexandreBergel 5/28/2012 22:24'!
initialize
	super initialize.
	menu := OrderedCollection new! !

!ROViewStackWithMenu methodsFor: 'initialize-release' stamp: 'AlexandreBergel 5/28/2012 22:55'!
layoutMenu

	| labels |
	labels := OrderedCollection new. 
	menu do: [ :assoc |
		| label |
		label := ((ROLabelElement on: assoc key) @ ROLightlyHighlightable + ROBorder). 
		label on: ROMouseLeftClick do: [ :event | assoc value roValue: self ].
		self add: label.
		labels add: label ].
	
	ROHorizontalLineLayout on: labels.
	
	self firstView translateBy: 0 @ 30.
! !

!ROViewStackWithMenu methodsFor: 'public' stamp: 'AlexandreBergel 5/28/2012 22:55'!
open
	self layoutMenu.
	super open.! !

!ROViewStackWithMenu methodsFor: 'menu' stamp: 'AlexandreBergel 5/28/2012 22:53'!
zoomInButton
	self addMenu: 'Zoom in' callBack: [ :stack | ROZoomInMove new on: stack firstView ].! !

!ROViewStackWithMenu methodsFor: 'menu' stamp: 'AlexandreBergel 5/28/2012 22:54'!
zoomOutButton
	self addMenu: 'Zoom out' callBack: [ :stack | ROZoomOutMove new on: stack firstView ].! !

ROObject subclass: #ROVisitor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

ROVisitor subclass: #ROCountingVisitor
	instanceVariableNames: 'nbOfNodes nbOfEdges'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

!ROCountingVisitor methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	nbOfEdges := 0.
	nbOfNodes := 0! !

!ROCountingVisitor methodsFor: 'accessing' stamp: ''!
nbOfEdges
	^ nbOfEdges! !

!ROCountingVisitor methodsFor: 'accessing' stamp: ''!
nbOfNodes
	^ nbOfNodes! !

!ROCountingVisitor methodsFor: 'visiting' stamp: ''!
visitEdge: anEdge
	nbOfEdges := nbOfEdges + 1! !

!ROCountingVisitor methodsFor: 'visiting' stamp: ''!
visitNode: aNode
	nbOfNodes := nbOfNodes + 1! !

ROVisitor subclass: #ROHighlighter
	instanceVariableNames: 'elementsToHighlight color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Visitor'!

!ROHighlighter class methodsFor: 'public' stamp: ''!
for: aBlockOrSymbol in: view

	^ self on: (view elementsSuchThat: aBlockOrSymbol) in: view! !

!ROHighlighter class methodsFor: 'public' stamp: 'AlexandreBergel 4/17/2012 17:00'!
on: elementsOrSingleElement in: view
	elementsOrSingleElement isCollection ifFalse: [ ^ self on: (Array with: elementsOrSingleElement) ].

	^ self new on: elementsOrSingleElement in: view! !

!ROHighlighter methodsFor: 'accessing' stamp: ''!
color
	^ color! !

!ROHighlighter methodsFor: 'accessing' stamp: ''!
color: anObject
	color := anObject! !

!ROHighlighter methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/5/2012 21:48'!
initialize
	super initialize.
	color := Color red! !

!ROHighlighter methodsFor: 'public' stamp: 'AlexandreBergel 4/30/2012 17:58'!
on: elements in: view

	(elements isCollection and: [ elements notEmpty ]) ifFalse: [ ^ self ].
	
	elementsToHighlight := elements.
	self runOn: view.
	elements first signalUpdate! !

!ROHighlighter methodsFor: 'visiting' stamp: 'AlexandreBergel 5/7/2012 11:48'!
visitNode: aNode
	| v |
	(elementsToHighlight includes: aNode)
		ifTrue: [ v := ( aNode getShape: ROBox). 
			v ifNotNil: [ v  borderColor: self color ] ]! !

!ROVisitor methodsFor: 'public' stamp: ''!
runOn: aROView 
	aROView elementsDo: [ :el | el accept: self ] ! !

!ROVisitor methodsFor: 'visit' stamp: ''!
visitEdge: anEdge! !

!ROVisitor methodsFor: 'visit' stamp: ''!
visitNode: aNode! !

Object subclass: #ROSortBlock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Roassal-Layout'!

!ROSortBlock methodsFor: 'accessing' stamp: ''!
fixTemps! !

!ROSortBlock methodsFor: 'accessing' stamp: ''!
value: assocA value: assocB
	"Return false if assocA is bigger than assocB.
	Return true if assocA is smaller than assocB.
	-> Inverted list with biggest elements first"
	
	| a b offset |
	offset := 0.
	a := assocA value.
	b := assocB value.
	[(a size > offset)
		and: [(b size > offset) and: [(a at: a size - offset) = (b at: b size - offset)]]]
		whileTrue: [offset := offset + 1].	"Corner cases"
	(a size = b size and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3], [3, 3]"
	(a size > offset and: [b size = offset]) ifTrue: [ ^ true ].	"[3, 3, 6], [3, 3]"
	(b size > offset and: [a size = offset]) ifTrue: [ ^ false ].	"[3, 3], [3, 3, 6]"	"Normal case"
	^(a at: a size - offset) >= (b at: b size - offset)! !

!Symbol methodsFor: '*roassal-core' stamp: ''!
roValue: anObject 
	^ anObject perform: self! !

!Color class methodsFor: '*roassal-core' stamp: ''!
gray256: intensity
	"between 0 and 256"
	| i |
	i := intensity asFloat / 256.
	^ self r:  i g: i b: i ! !

!Color class methodsFor: '*roassal-core' stamp: ''!
wheel: s alpha: a
	^ (Color wheel: 6) collect: [:c | c alpha: a ].! !
